function	ParseFloatEx(Value, bReplaceEmpty)
{
	if (Value == "")	{
		return bReplaceEmpty ? 0. : "";
	}
	Value		= Value.replace(',', '.');
	Value = parseFloat(Value);
	return isNaN(Value) ? 0. : Value;
}

function	ParseFloatObj(objCtrl, bReplaceEmpty)
{
	objCtrl.value = ParseFloatEx(objCtrl.value, bReplaceEmpty);
}

function	CheckPositive(objEdit, strMessageObjID, bReplaceEmpty)
{
	objEdit.value = ParseFloatEx(objEdit.value, bReplaceEmpty);
	if (objEdit.value < 0.)	{
		objEdit.value = 0.;
		if (strMessageObjID != "")	{
			var objMessage = document.getElementById(strMessageObjID);
			if (objMessage != null)
				alert(objMessage.value);
		}
	}
}

function	CheckPositiveNumeric(objEdit, strMessageObjID, bReplaceEmpty)
{
	var value=objEdit.value;
	if (value == "" && bReplaceEmpty)	{
		objEdit.value = 0.;
		return;
	}
	value		= value.replace(',', '.');
	value = parseFloat(value);
	if (isNaN(value) || value < 0.)	{
		objEdit.value = 0.;
		if (strMessageObjID != "")	{
			var objMessage = document.getElementById(strMessageObjID);
			if (objMessage != null)
				alert(objMessage.value);
		}
	}
}

function	checkPositive(Value, strMessageObjID, bReplaceEmpty)
{
	Value = ParseFloatEx(Value, bReplaceEmpty);
	if (Value < 0.)	{
		if (strMessageObjID != "")	{
			var objMessage = document.getElementById(strMessageObjID);
			if (objMessage != null) {
				alert(objMessage.value);
			}
		}
		return false;
	}
	return true;
}

function	CheckMinimum(objEdit, dMin, strMessageObjID, bReplaceEmpty)
{
	objEdit.value = ParseFloatEx(objEdit.value, bReplaceEmpty);
	if (objEdit.value < dMin)	{
		objEdit.value = dMin;
		if (strMessageObjID != "")	{
			var objMessage = document.getElementById(strMessageObjID);
			if (objMessage != null)
				alert(objMessage.value);
		}
		objEdit.focus();
	}
}

function	CheckMinMax(objEdit, dMin, dMax, strMessageMinObjID, strMessageMaxObjID, bReplaceEmpty, dDefMin, dDefMax)
{
	objEdit.value = ParseFloatEx(objEdit.value);
	if (objEdit.value < dMin)	{
		objEdit.value = (dDefMin == null) ? dMin : dDefMin;
		if (strMessageMinObjID != "")	{
			var objMessage = document.getElementById(strMessageMinObjID);
			if (objMessage != null)
				alert(objMessage.value);
		}
		objEdit.focus();
	}
	if (objEdit.value > dMax)	{
		objEdit.value = (dDefMax == null) ? dMax : dDefMax;
		if (strMessageMaxObjID != "")	{
			var objMessage = document.getElementById(strMessageMaxObjID);
			if (objMessage != null)
				alert(objMessage.value);
		}
		objEdit.focus();
	}
}

