// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.10.14 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # Initialize Ausmasse-Template (Message,...)
// # ============================================================================

var adXPosKGT = new Array(391, 249, 118);
var adYPosKGT = new Array(207, 125, 45);
var adXPosLF = new Array(392, 250, 119);
var adYPosLF = new Array(175, 93, 13);

var adYPosHArrow = new Array(206, 124, 44);
var adYPosHArrowLF = new Array(206, 124, 44);
var adYPosHArrowLF = new Array(174, 92, 12);
var dXPosHArrowPositive = 125;
var dXPosHArrowNegative = 264;

var adXPosVArrow = new Array(393 ,253, 111);
var dYPosVArrowPositive = 66;
var dYPosVArrowNegative = 145;
var dYPosVArrowPositiveLF = 34;
var dYPosVArrowNegativeLF = 113;


var phi = 0.;


function	InitAusmasse()
{
/*
	if (document.getElementById('SHOW_LW2').value > 0)
		document.getElementById('IDC_WAGENMITTENABSTAND_LW2_EDIT').style.visibility = 'visible';
	else
		document.getElementById('IDC_WAGENMITTENABSTAND_LW2_EDIT').style.visibility = 'hidden';
*/
	PositionKGT();
	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	hiliteNavigation();
}
function	InitAusmasseLF()
{
	PositionLF();
	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	hiliteNavigation();
}

function	HandleFocus(objEdit)
{
	document.getElementById("IDC_MASSE1_IMG").style.visibility = 'hidden';
};

function	SetDistancesImage(strInputFocusCtrlID)
{
	var objNewImageUrl = document.getElementById(strInputFocusCtrlID);
	var objImage = document.getElementById('IDC_MASSE2_IMG');
//	alert(strInputFocusCtrlID);
	if (objImage != null && objNewImageUrl != null)	{
//		alert(objNewImageUrl.value);
		objImage.src = objNewImageUrl.value;
/*
		objImage.style.filter = "progid:DXImageTransform.Microsoft.BasicImage('Rotation=3')";
		objImage.filters.item("DXImageTransform.Microsoft.BasicImage").Enabled = 1;
		if (objImage.filters.item("DXImageTransform.Microsoft.BasicImage").Rotation == 3)
			objImage.filters.item("DXImageTransform.Microsoft.BasicImage").Rotation	= 0;
		else
			objImage.filters.item("DXImageTransform.Microsoft.BasicImage").Rotation++; // = 3;
*/
/*
		objImage.style.filter = "progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand')";
		objImage.filters.item("DXImageTransform.Microsoft.Matrix").Enabled = 1;
		phi += 10.;
		phiRad = phi * Math.PI / 180;
		objImage.filters.item("DXImageTransform.Microsoft.Matrix").M11 = Math.cos(phiRad);
		objImage.filters.item("DXImageTransform.Microsoft.Matrix").M22 = Math.cos(phiRad);
		objImage.filters.item("DXImageTransform.Microsoft.Matrix").M12 = -Math.sin(phiRad);
		objImage.filters.item("DXImageTransform.Microsoft.Matrix").M21 = Math.sin(phiRad);
*/
	}
}

function	PositionKGT()
{
	var bShowHorzArrows = false;
	var bShowVertArrows = false;
	var dLY	= ParseFloatEx(document.getElementById('IDC_ANTRIEBSABSTAND_LY_EDIT').value, true);
	var dLZ	= ParseFloatEx(document.getElementById('IDC_ANTRIEBSABSTAND_LZ_EDIT').value, true);
	var objImgKGT	= document.getElementById('IDC_IMAGE_KGT');
	var objArrowLY	= document.getElementById('IDC_IMAGE_KGT_ARROW_LY');
	var objArrowLZ	= document.getElementById('IDC_IMAGE_KGT_ARROW_LZ');
	var objSystemImg= document.getElementById('IDC_MASSE1_IMG');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);

	if (dLY > 0)	{
		dXPos = adXPosKGT[2];
		bShowHorzArrows = true;
		dXPosHArrow = nLeft + dXPosHArrowPositive;
		dXPosVArrow = nLeft + adXPosVArrow[2];
	}
	else if (dLY < 0)	{
		dXPos = nLeft + adXPosKGT[0];
		bShowHorzArrows = true;
		dXPosHArrow = nLeft + dXPosHArrowNegative;
		dXPosVArrow = nLeft + adXPosVArrow[0];
	}
	else	{
		dXPos = nLeft + adXPosKGT[1];
		bShowHorzArrows = false;
		dXPosVArrow = nLeft + adXPosVArrow[1];
	}
	if (dLZ > 0)	{
		dYPos = nTop + adYPosKGT[2];
		bShowVertArrows = true;
		dYPosHArrow = nTop + adYPosHArrow[2];
		dYPosVArrow = nTop + dYPosVArrowPositive;
	}
	else if (dLZ < 0)	{
		dYPos = nTop + adYPosKGT[0];
		bShowVertArrows = true;
		dYPosHArrow = nTop + adYPosHArrow[0];
		dYPosVArrow = nTop + dYPosVArrowNegative
	}
	else	{
		dYPos = nTop + adYPosKGT[1];
		bShowVertArrows = false;
		dYPosHArrow = nTop + adYPosHArrow[1];
	}
	if (bShowHorzArrows == true)	{
		objArrowLY.style.visibility = 'visible';
		objArrowLY.style.top = dYPosHArrow;
		objArrowLY.style.left = dXPosHArrow;
	}
	else	{
		objArrowLY.style.visibility = 'hidden';
	}
	if (bShowVertArrows == true)	{
		objArrowLZ.style.visibility = 'visible';
		objArrowLZ.style.top = dYPosVArrow;
		objArrowLZ.style.left = dXPosVArrow;
	}
	else	{
		objArrowLZ.style.visibility = 'hidden';
	}
	objImgKGT.style.top = dYPos;
	objImgKGT.style.left = dXPos;
	objImgKGT.style.position = 'absolute';
	objArrowLY.style.position = 'absolute';
	objArrowLZ.style.position = 'absolute';
//	alert(objImgKGT.style.position);
}
function	PositionLF()
{
	var bShowHorzArrows = false;
	var bShowVertArrows = false;
	var dLY	= ParseFloatEx(document.getElementById('IDC_ANTRIEBSABSTAND_LY_EDIT').value, true);
	var dLZ	= ParseFloatEx(document.getElementById('IDC_ANTRIEBSABSTAND_LZ_EDIT').value, true);
	var objImgKGT	= document.getElementById('IDC_IMAGE_KGT');
	var objArrowLY	= document.getElementById('IDC_IMAGE_KGT_ARROW_LY');
	var objArrowLZ	= document.getElementById('IDC_IMAGE_KGT_ARROW_LZ');
	var objSystemImg= document.getElementById('IDC_MASSE1_IMG');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);

	if (dLY > 0)	{
		dXPos = adXPosLF[2];
		bShowHorzArrows = true;
		dXPosHArrow = nLeft + dXPosHArrowPositive;
		dXPosVArrow = nLeft + adXPosVArrow[2];
	}
	else if (dLY < 0)	{
		dXPos = nLeft + adXPosLF[0];
		bShowHorzArrows = true;
		dXPosHArrow = nLeft + dXPosHArrowNegative;
		dXPosVArrow = nLeft + adXPosVArrow[0];
	}
	else	{
		dXPos = nLeft + adXPosLF[1];
		bShowHorzArrows = false;
		dXPosVArrow = nLeft + adXPosVArrow[1];
	}
	if (dLZ > 0)	{
		dYPos = nTop + adYPosLF[2];
		bShowVertArrows = true;
		dYPosHArrow = nTop + adYPosHArrowLF[2];
		dYPosVArrow = nTop + dYPosVArrowPositiveLF;
	}
	else if (dLZ < 0)	{
		dYPos = nTop + adYPosLF[0];
		bShowVertArrows = true;
		dYPosHArrow = nTop + adYPosHArrowLF[0];
		dYPosVArrow = nTop + dYPosVArrowNegativeLF;
	}
	else	{
		dYPos = nTop + adYPosLF[1];
		bShowVertArrows = false;
		dYPosHArrow = nTop + adYPosHArrowLF[1];
	}
	if (bShowHorzArrows == true)	{
		objArrowLY.style.visibility = 'visible';
		objArrowLY.style.top = dYPosHArrow;
		objArrowLY.style.left = dXPosHArrow;
	}
	else	{
		objArrowLY.style.visibility = 'hidden';
	}
	if (bShowVertArrows == true)	{
		objArrowLZ.style.visibility = 'visible';
		objArrowLZ.style.top = dYPosVArrow;
		objArrowLZ.style.left = dXPosVArrow;
	}
	else	{
		objArrowLZ.style.visibility = 'hidden';
	}
	objImgKGT.style.top = dYPos;
	objImgKGT.style.left = dXPos;
	objImgKGT.style.position = 'absolute';
	objArrowLY.style.position = 'absolute';
	objArrowLZ.style.position = 'absolute';
//	alert(objImgKGT.style.position);
}

function EKCheckEdit(obj) {
	strMsgPosValues			= document.getElementById('IDC_POSVALUESONLY_MSG').value;
	if (strMsgPosValues != "")	{
		var objEdit = document.getElementById("IDC_WAGENMITTENABSTAND_LW1_EDIT");
		if (objEdit != null && objEdit.style.visibility == "visible")	{
			var Value = ParseFloatEx(objEdit.value, true);
			if (Value <= 0.)	{
				alert(strMsgPosValues);
				objEdit.focus();
				return false;
			}
		}
		objEdit = document.getElementById("IDC_WAGENMITTENABSTAND_LW2_EDIT");
		if (objEdit != null && objEdit.style.visibility == "visible")	{
			var Value = ParseFloatEx(objEdit.value, true);
			if (Value <= 0.)	{
				alert(strMsgPosValues);
				objEdit.focus();
				return false;
			}
		}
		objEdit = document.getElementById("IDC_SCHIENENMITTENABSTAND_EDIT");
		if (objEdit != null && objEdit.style.visibility == "visible")	{
			var Value = ParseFloatEx(objEdit.value, true);
			if (Value <= 0.)	{
				alert(strMsgPosValues);
				objEdit.focus();
				return false;
			}
		}
		objEdit = document.getElementById("IDC_ANTRIEBSSTEIFIGKEIT_EDIT");
		if (objEdit != null)	{
			var Value = ParseFloatEx(objEdit.value, true);
			if (Value <= 0.)	{
				alert(strMsgPosValues);
				objEdit.focus();
				return false;
			}
		}
	}
	return true;

};
function	EKCheckEditAndSubmit(obj)
{
	if (EKCheckEdit(obj)) {
		ekSubmit(obj);
	};
}

/*
function	ParseFloatEx(Value)
{
	Value		= Value.replace(',', '.');
	return parseFloat(Value);
}
*/