// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.10.07 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # Initialize DynZeitanteile-Template (Message,...)
// # ============================================================================

function	InitDynZeitanteile()
{
	InitFocus("INPUT_FOCUS");
	hiliteNavigation();

	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	if (document.getElementById('BMSG_QS_SUM').value == "true")	{
		document.getElementById('BMSG_QS_SUM').value = "false";
		alert(document.getElementById('IDC_SUMME_QS_MSG').value);
	}
}

function	EKCheckEditAndSubmit(obj, bCheckSumQs, bAjax)
{
	var objTable = document.getElementById('IDC_ZEITANTEILE_TAB_TABLE');
	if (objTable == null)	{
		alert('Error: Table not found');
		return;
	}
//	alert(objTable.rows.length);

	strMsgPosValues			= document.getElementById('IDC_POSVALUESONLY_MSG').value;
	strMsgValueExceeds100	= document.getElementById('IDC_VALUEEXCEEDS100PERCENT_MSG').value;
	strMsgBothValuesNotNull	= document.getElementById('IDC_VALUESNOTNULL_MSG').value;
	var dSum = 0.;
	var dSumQs = 0.;
	for (i = 1; i < objTable.rows.length; ++i)	{
		var objEdit1 = document.getElementById('IDC_ZEITANTEILE_EDIT_' + i + '_1');
		var Value1 = objEdit1.value;
		Value1 = Value1.replace(',', '.');
		Value1 = (Value1 == "") ? 0. : parseFloat(Value1);
//		objEdit1.value = Value1;
		if (Value1 < 0. && strMsgPosValues != "")	{
			alert(strMsgPosValues + ' [' +objTable.rows(i).cells(0).innerText + ']');
			objEdit1.focus();
			return;
		}
		dSum += Value1;
		if (Value1 > 100. && strMsgValueExceeds100 != "")	{
			alert(strMsgValueExceeds100 + ' [' +objTable.rows(i).cells(0).innerText + ']');
			objEdit1.focus();
			return;
		}
		var objEdit2 = document.getElementById('IDC_ZEITANTEILE_EDIT_' + i + '_2');
		var Value2 = objEdit2.value;
		Value2 = Value2.replace(',', '.');
		Value2 = parseFloat(Value2);
/*
		if (Value2 < 0. && strMsgPosValues != "")	{
			alert(strMsgPosValues + ' [' +objTable.rows(i).cells(0).innerText + ']');
			objEdit2.focus();
			return;
		}
*/

		if (bCheckSumQs == true)	{
			var Value3 = document.getElementById("IDC_ZEITANTEILE_LABEL" + i + "_3").innerHTML;
			if (Value3 != "")	{
				Value3.replace(",",".");
				Value3 = parseFloat(Value3);
				dSumQs += Value3;
			}

		}

		if (strMsgBothValuesNotNull != "")	{
			if (Value1 == 0. && Value2 > 0.)	{
				alert(strMsgBothValuesNotNull);
				objEdit1.focus();
				return;
			}
/*
			else if (Value1 > 0. && Value2 == 0.)	{
				alert(strMsgBothValuesNotNull);
				objEdit2.focus();
				return;
			}
*/
		}
	}
//	alert(dSum);
	var dEps = 0.5
	if (dSum < (100 - dEps) || dSum > (100 + dEps))	{
		strMsgTotalValueExceeds100	= document.getElementById('IDC_TOTALEXCEEDS100PERCENT_MSG').value;
		alert(strMsgTotalValueExceeds100);
		return;
	}
	if (bCheckSumQs == true && (dSumQs < (100 - dEps) || dSumQs > (100 + dEps)))	{
		strMsgTotalValueExceeds100	= document.getElementById('IDC_SUMME_QS_MSG').value;
		alert(strMsgTotalValueExceeds100);
		return;
	}
	if (bAjax)
	    ekSubmitDialog(obj.id);
	else
	    ekSubmit(obj);
}

function	ResetTableContent(nRow)
{
	var objTable = document.getElementById('IDC_ZEITANTEILE_TAB_TABLE');
	for (i = nRow; i < objTable.rows.length; ++i)	{
		document.getElementById('IDC_ZEITANTEILE_EDIT_' + i + '_1').value = "";
		document.getElementById('IDC_ZEITANTEILE_EDIT_' + i + '_2').value = "";
		document.getElementById('IDC_ZEITANTEILE_EDIT_' + i + '_N').value = "";
		document.getElementById('IDC_ZEITANTEILE_LABEL' + i + '_3').innerText = "";
	}
}

function	EKEditSubmit(strEvent, strCtrlID)
{
	// document.getElementById("dontsubmit").value = "1";
	// document.getElementById("dontsubmit").value = "0";
	var objCtrl = document.getElementById(strCtrlID);
	var strValue = objCtrl.value + "";
	strValue = strValue.replace(".", "");
	strValue = strValue.replace(",", "");
	strValue = strValue.replace("-", "");
	var Number = /\D/;
	if (strValue.match(Number) != null)	{
		objCtrl.focus();
		alert(document.getElementById("IDC_NAN_MSG").value);
		objCtrl.focus();
		//document.getElementById("dontsubmit").value = "0";
		return true;
	}
	EKSingleSubmit(strEvent, strCtrlID);
}
