// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.10.07 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # Initialize Dynzyklus-Template (Message,...)
// # ============================================================================

var nFIXEDCOLS = 2;
var nANZPHASEN = 18;


function	InitDynZyklus()
{
	InitFocus("INPUT_FOCUS");
	strMsg = document.getElementById("IDC_INIT_MSG").value;
	document.getElementById("NEXT_FOCUS").value="";
	
	hiliteNavigation();

	// strCtrlID = document.activeElement.id;
	var strCtrlID = document.getElementById("INPUT_FOCUS").value;
	
	var bEnableEdits = true;
	var nActColIndex = getColIndex(strCtrlID);
	if (nActColIndex > 0 && !CheckColInputComplete(nActColIndex))	{
		bEnableEdits = false;
	}

	var bEnableContinue = true;
	if (strMsg != "")	{
		alert(strMsg);
		document.getElementById("IDC_INIT_MSG").value = "";
		bEnableContinue = false;
		bEnableEdits = false;
	}
	else	{
		bEnableContinue = true;
	}
	if (bEnableEdits)   {
		// EnableEdits(strCtrlID);
		EnableColEdits(nActColIndex + 1);
		DisableNextEdits(nActColIndex + 2);
		if (strCtrlID==("IDC_DYNZYKLUS_EDIT_4_"+nActColIndex)) {
			var NextFocusCtrlID="IDC_DYNZYKLUS_EDIT_2_"+(nActColIndex+1);
			document.getElementById("NEXT_FOCUS").value=NextFocusCtrlID;
		};
	}
	else
		// DisableEdits(strCtrlID);
		DisableNextEdits(nActColIndex);

	if (bEnableContinue)	{
		componentEnable("IDC_CONTINUE_BUT");
	}
	else	{
		componentDisable("IDC_CONTINUE_BUT");
	}
	InitFocus("INPUT_FOCUS");

	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	if (document.getElementById('BMSG_QS_SUM').value == "true")	{
		document.getElementById('BMSG_QS_SUM').value = "false";
		alert(document.getElementById('IDC_SUMME_QS_MSG').value);
	}
	if (document.getElementById('*.DLGDATA.DYNZYKLUS.BMSG_HUB_RANGE').value == "true")	{
		document.getElementById('*.DLGDATA.DYNZYKLUS.BMSG_HUB_RANGE').value = "false";
		alert(document.getElementById('IDC_MSG_HUB_RANGE').value);
	}
}

function	EKEditSubmit(strEvent, strCtrlID)
{
	// document.getElementById("dontsubmit").value = "1";
	document.getElementById("dontsubmit").value = "0";
	var objCtrl = document.getElementById(strCtrlID);
	var strValue = objCtrl.value + "";
	strValue = strValue.replace(".", "");
	strValue = strValue.replace(",", "");
	strValue = strValue.replace("-", "");
	var Number = /\D/;
	if (strValue.match(Number) != null)	{
		objCtrl.focus();
		alert(document.getElementById("IDC_NAN_MSG").value);
		objCtrl.focus();
		document.getElementById("dontsubmit").value = "0";
		return true;
	}
	//MyEKSubmit(strEvent, strCtrlID);
	EKSingleSubmit(strEvent, strCtrlID);
	var nActColIndex = getColIndex(strCtrlID);
	if (nActColIndex > 0)
        clearCols(nActColIndex + 1);
	InitDynZyklus();
}

function	EnableEdits(strStartEditID)
{
	var strRowCols = strStartEditID.replace("IDC_DYNZYKLUS_EDIT_","");
	aRowCols = strRowCols.split("_");
	if (aRowCols.length > 1)	{
		strSelRow = aRowCols[0];
		strSelCol = aRowCols[1];
	}
	else	{
		alert("error!");
		return;
	}
	var nStart = parseInt(strSelCol) + 1;
	var nFixedCols = 2;
	var nAnzPhasen = 18;
	var nEnd = nAnzPhasen + nFixedCols;
	for (i = nStart; i <= nEnd; ++i)	{
		componentEnable("IDC_DYNZYKLUS_EDIT_2_" + i);
		componentEnable("IDC_DYNZYKLUS_EDIT_3_" + i);
		componentEnable("IDC_DYNZYKLUS_EDIT_4_" + i);
		componentEnable("IDC_DYNZYKLUS_EDIT_5_" + i);
	}
}

function	EnableColEdits(nCurrentColIndex)
{
    if (nCurrentColIndex > nFIXEDCOLS && nCurrentColIndex <= (nFIXEDCOLS + nANZPHASEN)) {
		componentEnable("IDC_DYNZYKLUS_EDIT_2_" + nCurrentColIndex);
		componentEnable("IDC_DYNZYKLUS_EDIT_3_" + nCurrentColIndex);
		componentEnable("IDC_DYNZYKLUS_EDIT_4_" + nCurrentColIndex);
		componentEnable("IDC_DYNZYKLUS_EDIT_5_" + nCurrentColIndex);
		if (document.getElementById("IDC_DYNZYKLUS_EDIT_9_" + nCurrentColIndex) != null)
		    componentEnable("IDC_DYNZYKLUS_EDIT_9_" + nCurrentColIndex);
	}
}

function	DisableEdits(strStartEditID)
{
	var strRowCols = strStartEditID.replace("IDC_DYNZYKLUS_EDIT_","");
	aRowCols = strRowCols.split("_");
	if (aRowCols.length > 1)	{
		strSelRow = aRowCols[0];
		strSelCol = aRowCols[1];
	}
	else	{
		alert("error!");
		return;
	}
	var nStart = parseInt(strSelCol) + 1;

	var nFixedCols = 2;
	var nAnzPhasen = 18;
	var nEnd = nAnzPhasen + nFixedCols;
	for (i = nStart; i <= nEnd; ++i)	{
		componentDisable("IDC_DYNZYKLUS_EDIT_2_" + i);
		componentDisable("IDC_DYNZYKLUS_EDIT_3_" + i);
		componentDisable("IDC_DYNZYKLUS_EDIT_4_" + i);
		componentDisable("IDC_DYNZYKLUS_EDIT_5_" + i);
	}
}

function	DisableNextEdits(nStartCol)
{
	var nStart = nStartCol + 1;
	var nEnd = nANZPHASEN + nFIXEDCOLS;
	for (i = nStart; i <= nEnd; ++i)	{
		componentDisable("IDC_DYNZYKLUS_EDIT_2_" + i);
		componentDisable("IDC_DYNZYKLUS_EDIT_3_" + i);
		componentDisable("IDC_DYNZYKLUS_EDIT_4_" + i);
		componentDisable("IDC_DYNZYKLUS_EDIT_5_" + i);
		if (document.getElementById("IDC_DYNZYKLUS_EDIT_9_" + i) != null)   {
		    componentDisable("IDC_DYNZYKLUS_EDIT_9_" + i);
		}
	}
}

function	CheckInputComplete()
{
	var nFixedCols = 2;
	var nAnzPhasen = 18;
	var nEnd = nAnzPhasen + nFixedCols;
	var nStart = 3;

	for (i = nStart; i <= nEnd; ++i)	{
		var nCounter = 0;
		var value = document.getElementById("IDC_DYNZYKLUS_EDIT_2_" + i).value;
		if (value == "")
			++nCounter;
		value = document.getElementById("IDC_DYNZYKLUS_EDIT_3_" + i).value;
		if (value == "")
			++nCounter;
		value = document.getElementById("IDC_DYNZYKLUS_EDIT_4_" + i).value;
		if (value == "")
			++nCounter;
		value = document.getElementById("IDC_DYNZYKLUS_EDIT_5_" + i).value;
		if (value == "")
			++nCounter;
		if (nCounter < 4 && nCounter > 0)
			return false;
	}
	return true;
}

function	CheckColInputComplete(nCol)
{
	var nFixedCols = 2;
	var i = nCol;
	var nCounter = 0;
	var nStartRow = 2;
	var nEndRow = 5;
	for (var nRow = nStartRow; nRow <= nEndRow; ++nRow)	{
	    var strEditID = "IDC_DYNZYKLUS_EDIT_" + nRow + "_" + nCol;
	    var objEdit = document.getElementById(strEditID);
	    if (objEdit == null)
	        alert(strEditID + " not found!");
	    var value = (objEdit == null) ? "" : objEdit.value;
	    if (value == "")
		    ++nCounter;
	}
	if (nCounter < 4 && nCounter > 0)
		return false;
	return true;
}

function	CheckQS()
{
	var nFixedCols = 2;
	var nAnzPhasen = 18;
	var nEnd = nAnzPhasen + nFixedCols;
	var nStart = 3;
	for (i = nStart; i <= nEnd; ++i)	{
		var value = document.getElementById("IDC_DYNZYKLUS_8_" + i).innerHTML;
		alert (value);
		value.replace(",",".");
		value = parseFloat(value);
		if (value != 0.)
			return true;
	}
}

function	CheckAndSubmit(objSubmit)
{
	if (document.getElementById("dontsubmit").value == "1")
		return;

	if (!CheckTMin() || !CheckSumQS())
		return;
		
	if (CheckInputComplete())	{
		ekSubmit(objSubmit);
	}
	else	{
		strMsg = document.getElementById("IDC_TWOVALUESREQUIRED_MSG").value;
		if (strMsg != "")
			alert(strMsg);
	}
}

function	CondSubmit(objSubmit)
{
	if (document.getElementById("dontsubmit").value == "1")
		return;
	ekSubmit(objSubmit);
}

function	CheckSumQS()
{
	var nFixedCols = 2;
	var nAnzPhasen = 18;
	var nEnd = nAnzPhasen + nFixedCols;
	var nStart = nFixedCols + 1;
	var dSum = 0.;
	for (i = nStart; i <= nEnd; ++i)	{
		var value = document.getElementById("IDC_DYNZYKLUS_6_" + i).innerHTML;
		value = ParseFloatEx(value, true);
		dSum += value;
	}
	var dEps = 0.5;
	if (dSum < (100. - dEps) || dSum > (100. + dEps))	{
		alert(document.getElementById("IDC_SUMME_QS_MSG").value);
		return false;
	}
	return true;
}

function	CheckTMin()
{
	var nFixedCols = 2;
	var nAnzPhasen = 18;
	var nEnd = nAnzPhasen + nFixedCols;
	var nStart = nFixedCols + 1;
	for (i =nStart; i <= nEnd; ++i)	{
		var objEdit = document.getElementById("IDC_DYNZYKLUS_EDIT_5_" + i);
		var Value = objEdit.value;
		if (Value != "")	{
			Value = ParseFloatEx(Value, true);
			if (Value < 0.001)	{
				alert(document.getElementById("IDC_TMIN_MSG").value);
				objEdit.focus();
				return false;
			}
		}
	}
	return true;
}

function    clearCols(nStartCol)
{
	var nEnd = nANZPHASEN + nFIXEDCOLS;
    for (var i = nStartCol; i <= nEnd; ++i)  {
        document.getElementById("IDC_DYNZYKLUS_EDIT_2_" + i).value = "";
        document.getElementById("IDC_DYNZYKLUS_EDIT_3_" + i).value = "";
        document.getElementById("IDC_DYNZYKLUS_EDIT_4_" + i).value = "";
        document.getElementById("IDC_DYNZYKLUS_EDIT_5_" + i).value = "";
        var objEdit = document.getElementById("IDC_DYNZYKLUS_EDIT_9_" + i);
        if (objEdit != null)
            objEdit.value = "";
        document.getElementById("IDC_DYNZYKLUS_6_" + i).innerText = "";           
        document.getElementById("IDC_DYNZYKLUS_7_" + i).innerText = "";           
        document.getElementById("IDC_DYNZYKLUS_8_" + i).innerText = "";           
    }
}

function    getColIndex(strEditCtrlID)
{
	var strRowCols = strEditCtrlID.replace("IDC_DYNZYKLUS_EDIT_","");
	var aRowCols = strRowCols.split("_");
	return (aRowCols.length > 1) ? parseInt(aRowCols[1]) : -1;
}
// Fokus fuer Button umleiten, falls weitere Eingabespalte gerade verfuegbar geworden
function deflectFocus() {
	var NextFocusCtrlID=document.getElementById("NEXT_FOCUS").value;
	if (NextFocusCtrlID!="") {
		document.getElementById("NEXT_FOCUS").value="";
		var ctrl=document.getElementById(NextFocusCtrlID);
		if (ctrl) ctrl.focus();
	};

};