function initKGTAusmasse()
{
	hiliteNavigation();
    var strSPUCheck = "*.DLGDATA.KGTSYSTEM.BSPINDELUNTERSTUETZUNG";
    if (dialog["*.DLGDATA.KGTSYSTEM.LAGERART"].getValue() == "FEST_FREI")    {
        var objSPUCheck = $(strSPUCheck);
        objSPUCheck.checked = false;
        componentDisable(strSPUCheck);
    }
	if (document.getElementById('*.DLGDATA.DYNZYKLUS.BMSG_HUB_RANGE').value == "true")	{
		document.getElementById('*.DLGDATA.DYNZYKLUS.BMSG_HUB_RANGE').value = "false";
		alert(document.getElementById('IDC_MSG_HUB_RANGE').value);
	}
	if (document.getElementById('*.DLGDATA.KGTAUSMASSE.BMSG_NOT_FOUND_SPU').value == "true")	{
		document.getElementById('*.DLGDATA.KGTAUSMASSE.BMSG_NOT_FOUND_SPU').value = "false";
		alert(document.getElementById('IDC_MSG_NOT_FOUND_SPU').value);
		ekSubmit('CONTINUE_AFTER_MESSAGE');
	}
	
    handleBSpindelUnterstuetzung(strSPUCheck);
    moveLagerseite2(dialog["*.DLGDATA.KGTSYSTEM.LAGERART"].getValue());
}

function changeLagerArt(objCombo)
{
    var objGUICombo         = dialog[objCombo.id];
    var strSPUCheck         = "*.DLGDATA.KGTSYSTEM.BSPINDELUNTERSTUETZUNG";
    var str2RotlagerCheck   = "*.DLGDATA.KGTSYSTEM.FL2ROTATIONSLAGER";
    if (objGUICombo != null && (objGUICombo.getValue() == "FEST_FREI" || objGUICombo.getValue() == "FEST_FEST"))    {
        var objSPUCheck = $(strSPUCheck);
        objSPUCheck.checked = false;
        handleBSpindelUnterstuetzung(strSPUCheck);
        componentDisable(strSPUCheck);
        showSPUKomponenten(false);
        var obj2RotLager = $(str2RotlagerCheck);
        obj2RotLager.checked = false;
        componentDisable(str2RotlagerCheck);
    }
    else    {
        componentEnable(strSPUCheck);
        componentEnable(str2RotlagerCheck);
    }
    moveLagerseite2(objGUICombo.getValue());
    ekSubmitDialog(objCombo.id);
}

function    moveLagerseite2(strLagerart)
{
    var nMPosRLager = 750;
    var nTextwidth_2 = dialog["IDC_LAGERSEITE2_LABEL"].getOffsetWidth() / 2.;
    switch (strLagerart)    {
    case "FEST_FEST":
        nMPosRLager = 726;
        break;
    case "FEST_LOS":
        nMPosRLager = 752;
        break;
    case "FEST_FREI":
        nMPosRLager = 764;
        break;
    }

    var nLeft = nMPosRLager - nTextwidth_2 - 10;
    dialog["IDC_LAGERSEITE2_LABEL"].setPosition(144, nLeft);
}

function    changeLLager(objLLager)
{
    ekSubmitDialog(objLLager.id);
}

function    showSPUKomponenten(bShow)
{
    if (bShow)  {
        dialog["SPUImageTable"].show();
        dialog["IDC_LAGERSEITE1_LABEL2"].show();
        dialog["IDC_LAGERSEITE2_LABEL2"].show();
        dialog["IDC_LAGERLINKS_LABEL"].show();
        dialog["IDC_LAGERRECHTS_LABEL"].show();
    }
    else    {
        dialog["SPUImageTable"].hide();
        dialog["IDC_LAGERSEITE1_LABEL2"].hide();
        dialog["IDC_LAGERSEITE2_LABEL2"].hide();
        dialog["IDC_LAGERLINKS_LABEL"].hide();
        dialog["IDC_LAGERRECHTS_LABEL"].hide();
    }
}

function    exitFocus(objLLager)
{
    $("IDC_LAGER_LABEL").className = "Lager_L1";
    document.getElementById("IDC_LAGERART_IMAGE").src = strSaveImage;
}

function    changeStuetzstellenAnz(objStuetzstellenAnz)
{
    ekSubmitDialog(objStuetzstellenAnz.id);
}

function    handleBSpindelUnterstuetzung(strSPUCheck, bSubmit)
{
    var objSPUCheck= $(strSPUCheck);
    if (objSPUCheck.checked)    {
        componentEnable('*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ');
        $('*.DLGDATA.KGTSYSTEM.FL2ROTATIONSLAGER').checked = true;
        componentDisable('*.DLGDATA.KGTSYSTEM.FL2ROTATIONSLAGER');
        showSPUKomponenten(true);
    }
    else    {
        componentDisable('*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ');
        componentEnable('*.DLGDATA.KGTSYSTEM.FL2ROTATIONSLAGER');		
        
        showSPUKomponenten(false);
    }
    if (bSubmit && dialog["*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ"].getValue() != "")
        ekSubmitDialog(strSPUCheck);
    if (!objSPUCheck.checked)
        dialog["*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ"].setValue("0");
}

function    changeFocus(objCtrl, strPar)
{
    if (strPar == "L_LAGER")    {
        $("IDC_LAGER_LABEL").className = "Lager_L1_RED";
    }
    strSaveImage = document.getElementById("IDC_LAGERART_IMAGE").src;
    EKSingleSubmit("FOCUS", strPar);
}

function    checkKGTAusmasse(objSubmit)
{
    if (!checkCtrl("*.DLGDATA.KGTDATEN.PM_STEIGUNG", false)
        || !checkCtrl("*.DLGDATA.KGTSYSTEM.L_LAGER.VALUE", true)
        || !checkCtrl("*.DLGDATA.KGTSYSTEM.LS1.VALUE", true)
        || !checkCtrl("*.DLGDATA.KGTSYSTEM.LS2.VALUE", true)
        || !checkCtrl("*.DLGDATA.KGTSYSTEM.X0.VALUE", true))
        return false;

    var dTmp = parseFloat(dialog["*.DLGDATA.KGTSYSTEM.LS1.VALUE"].getValue()) + parseFloat(dialog["*.DLGDATA.KGTSYSTEM.LS2.VALUE"].getValue()) + parseFloat(dialog["*.DLGDATA.KGTSYSTEM.X0.VALUE"].getValue());
    var dLager = parseFloat(dialog["*.DLGDATA.KGTSYSTEM.L_LAGER.VALUE"].getValue());
    if (dTmp > dLager) {
        alert(document.getElementById("IDC_LS1LS2X0L_LAGERVIOLATION_MSG").value);
        return false;
    }

		return true;
}
function    checkKGTAusmasseAndSubmit(objSubmit)
{
    if (checkKGTAusmasse(objSubmit)) {
		ekSubmit(objSubmit);
	};
}

function    checkCtrl(strCtrlId, bPositive)
{
    var objCtrl = dialog[strCtrlId];
    if (objCtrl)    {
        var Value = objCtrl.getValue();
        if (Value == "") {
            var strMsgWerteingeben = document.getElementById("IDC_INPUTREQUIRED_MSG").value;
            alert(strMsgWerteingeben);
            objCtrl.element.focus();
            return false;
        }
        else if (bPositive && !checkPositive(Value, "IDC_POSVALUESONLY_MSG", true)) {
            objCtrl.element.focus();
            return false;
        }
    }
    return true;
}

