// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.12.21 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # operations for all Kraefte-Templates (Positioning,...)
// # ============================================================================

var adXPosMassX = new Array(250, 161, 78);
var adYPosMassX = new Array(133, 85, 52);
var adXPosMassY = new Array(60, 278, 465);
var adYPosMassY = new Array(118, 84, 63);
// var	adXPosMassY2 = new Array(60, 157, 243, 330, 400);
var	adXPosMassY2 = new Array(60, 60, 278, 465, 465);
var KraftYOffset_Y = 0; // Vom Script gesetzer Offset um Massengrafiken fuer LF anders zu positionieren
var KraftXOffset_Y = 0; 


function	InitKraefte()
{
	KraftXOffset_Y=ParseFloatEx(document.getElementById('IDC_KRAFTX_OFFSET_Y').value, true);
	KraftYOffset_Y=ParseFloatEx(document.getElementById('IDC_KRAFTY_OFFSET_Y').value, true);

	UpdateImagesKraefte();
	hiliteNavigation();
	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	if (document.getElementById('*.DLGDATA.BMSG_FORCE_KOORD_INCOMPLETE').value == "true")	{
		document.getElementById('*.DLGDATA.BMSG_FORCE_KOORD_INCOMPLETE').value = "false";
		alert(document.getElementById('IDC_MSG_FORCE_KOORD_INCOMPLETE').value);
	}
	if (document.getElementById('*.DLGDATA.BMSG_FORCE_INCOMPLETE').value == "true")	{
		document.getElementById('*.DLGDATA.BMSG_FORCE_INCOMPLETE').value = "false";
		alert(document.getElementById('IDC_MSG_FORCE_INCOMPLETE').value);
	}
}

function	InitKGTKraefte()
{
	hiliteNavigation();

	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	if (document.getElementById('*.DLGDATA.WINKEL.BMSG_HORIZONTAL_ONLY').value == "true")	{
		document.getElementById('*.DLGDATA.WINKEL.BMSG_HORIZONTAL_ONLY').value = "false";
		alert(document.getElementById('IDC_MSG_HORIZONTAL_ONLY').value);
	}
}

function	UpdateImagesKraefte(objEditCtrl)
{
	PositionKraftX();
	PositionKraftY();
}

function	PositionKraftX()
{
	var dFx = ParseFloatEx(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_3').value);
	var dFy = ParseFloatEx(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_4').value);
	var dFz = ParseFloatEx(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_5').value);
	var dY	= ParseFloatEx(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_8').value);
	var dZ	= ParseFloatEx(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_9').value);
	var dCharactLengthY = 0.; // parseFloat(document.getElementById('IDC_CHARACTLENGTH_Y').value) / 2.;
	var objImgFyPos	= document.getElementById('IDC_IMAGE_FYPOS');
	var objImgFyNeg	= document.getElementById('IDC_IMAGE_FYNEG');
	var objImgFzPos	= document.getElementById('IDC_IMAGE_FZPOS1');
	var objImgFzNeg	= document.getElementById('IDC_IMAGE_FZNEG1');
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_X');
	var objImgFxPos	= document.getElementById('IDC_IMAGE_CROSS');
	var objImgFxNeg	= document.getElementById('IDC_IMAGE_DOT');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);
	if (dY > dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[2];
	}
	else if (dY < -dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[0];
	}
	else	{
		dXPos = nLeft + adXPosMassX[1];
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassX[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassX[0];
	}
	else	{
		dYPos = nTop + adYPosMassX[1];
	}
//	alert(objSystemImg.style.zIndex);
//	alert(objImgMass.style.zIndex);
	if (dFx > 0.)	{
		objImgFxPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFxPos.style.top = dYPos - objImgFxPos.height / 2+KraftXOffset_Y;
		objImgFxPos.style.left = dXPos - objImgFxPos.width / 2;
		objImgFxPos.style.position = 'absolute';
		objImgFxPos.style.visibility = 'visible';
		objImgFxNeg.style.visibility = 'hidden';
	}
	else if (dFx < 0.)	{
		objImgFxNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFxNeg.style.top = dYPos - objImgFxNeg.height / 2+KraftXOffset_Y;
		objImgFxNeg.style.left = dXPos - objImgFxPos.width / 2;
		objImgFxNeg.style.position = 'absolute';
		objImgFxNeg.style.visibility = 'visible';
		objImgFxPos.style.visibility = 'hidden';
	}
	else	{
		objImgFxNeg.style.visibility = 'hidden';
		objImgFxPos.style.visibility = 'hidden';
	}

	if (dFy > 0.)	{
		objImgFyPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFyPos.style.top = dYPos - objImgFyPos.height + 5+KraftXOffset_Y;
		objImgFyPos.style.left = dXPos - objImgFyPos.width;
		objImgFyPos.style.position = 'absolute';
		objImgFyPos.style.visibility = 'visible';
		objImgFyNeg.style.visibility = 'hidden';
	}
	else if (dFy < 0.)	{
		objImgFyNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFyNeg.style.top = dYPos - objImgFyNeg.height + 5+KraftXOffset_Y;
		objImgFyNeg.style.left = dXPos;
		objImgFyNeg.style.position = 'absolute';
		objImgFyNeg.style.visibility = 'visible';
		objImgFyPos.style.visibility = 'hidden';
	}
	else	{
		objImgFyNeg.style.visibility = 'hidden';
		objImgFyPos.style.visibility = 'hidden';
	}
	if (dFz > 0.)	{
		objImgFzPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzPos.style.top = dYPos - objImgFzPos.height+KraftXOffset_Y;
		objImgFzPos.style.left = dXPos - 6;
		objImgFzPos.style.position = 'absolute';
		objImgFzPos.style.visibility = 'visible';
		objImgFzNeg.style.visibility = 'hidden';
	}
	else if (dFz < 0.)	{
		objImgFzNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzNeg.style.top = dYPos+KraftXOffset_Y;
		objImgFzNeg.style.left = dXPos - 6;
		objImgFzNeg.style.position = 'absolute';
		objImgFzNeg.style.visibility = 'visible';
		objImgFzPos.style.visibility = 'hidden';
	}
	else	{
		objImgFzNeg.style.visibility = 'hidden';
		objImgFzPos.style.visibility = 'hidden';
	}
}

function	PositionKraftY()
{
	var dFx = ParseFloatEx(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_3').value);
	var dFy = ParseFloatEx(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_4').value);
	var dFz = ParseFloatEx(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_5').value);
	var dX	= ParseFloatEx(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_7').value);
	var dZ	= ParseFloatEx(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_9').value);
	var dCharactLengthX = 0.; // parseFloat(document.getElementById('IDC_CHARACTLENGTH_X').value) / 2.;
	var nFWAnz = document.getElementById('IDC_FWANZ').value;
	var objImgFxPos	= document.getElementById('IDC_IMAGE_FXPOS');
	var objImgFxNeg	= document.getElementById('IDC_IMAGE_FXNEG');
	var objImgFzPos	= document.getElementById('IDC_IMAGE_FZPOS2');
	var objImgFzNeg	= document.getElementById('IDC_IMAGE_FZNEG2');
	var objImgFyPos	= document.getElementById('IDC_IMAGE_CROSS2');
	var objImgFyNeg	= document.getElementById('IDC_IMAGE_DOT2');
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_Y');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);
	if (nFWAnz == 8)	{
		var dCharactLengthX2 = 0.;	// parseFloat(document.getElementById('IDC_CHARACTLENGTH_X2').value) / 2.;
		if (dX < -dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[0];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[1];
		}
		else if (dX > dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[4];
		}
		else if (dX > dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[3];
		}
		else	{
			dXPos = nLeft + adXPosMassY2[2];
		}
	}
	else	{
		if (dX > dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[2];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[0];
		}
		else	{
			dXPos = nLeft + adXPosMassY[1];
		}
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassY[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassY[0];
	}
	else	{
		dYPos = nTop + adYPosMassY[1];
	}
//	alert(objSystemImg.style.zIndex);
//	alert(objImgMass.style.zIndex);
	if (dFx > 0.)	{
		objImgFxPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFxPos.style.top = dYPos - objImgFxPos.height + 5+KraftYOffset_Y;
		objImgFxPos.style.left = dXPos;
		objImgFxPos.style.position = 'absolute';
		objImgFxPos.style.visibility = 'visible';
		objImgFxNeg.style.visibility = 'hidden';
	}
	else if (dFx < 0.)	{
		objImgFxNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFxNeg.style.top = dYPos - objImgFxNeg.height + 5+KraftYOffset_Y;
		objImgFxNeg.style.left = dXPos - objImgFxNeg.width;
		objImgFxNeg.style.position = 'absolute';
		objImgFxNeg.style.visibility = 'visible';
		objImgFxPos.style.visibility = 'hidden';
	}
	else	{
		objImgFxNeg.style.visibility = 'hidden';
		objImgFxPos.style.visibility = 'hidden';
	}

	if (dFy > 0.)	{
		objImgFyPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFyPos.style.top = dYPos - objImgFyPos.height / 2+KraftYOffset_Y;
		objImgFyPos.style.left = dXPos - objImgFyPos.width / 2;
		objImgFyPos.style.position = 'absolute';
		objImgFyPos.style.visibility = 'visible';
		objImgFyNeg.style.visibility = 'hidden';
	}
	else if (dFy < 0.)	{
		objImgFyNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFyNeg.style.top = dYPos - objImgFyNeg.height / 2+KraftYOffset_Y;
		objImgFyNeg.style.left = dXPos - objImgFyPos.width / 2;
		objImgFyNeg.style.position = 'absolute';
		objImgFyNeg.style.visibility = 'visible';
		objImgFyPos.style.visibility = 'hidden';
	}
	else	{
		objImgFyNeg.style.visibility = 'hidden';
		objImgFyPos.style.visibility = 'hidden';
	}

	if (dFz > 0.)	{
		objImgFzPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzPos.style.top = dYPos - objImgFzPos.height+KraftYOffset_Y;
		objImgFzPos.style.left = dXPos - 6;
		objImgFzPos.style.position = 'absolute';
		objImgFzPos.style.visibility = 'visible';
		objImgFzNeg.style.visibility = 'hidden';
	}
	else if (dFz < 0.)	{
		objImgFzNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzNeg.style.top = dYPos+KraftYOffset_Y;
		objImgFzNeg.style.left = dXPos - 6;
		objImgFzNeg.style.position = 'absolute';
		objImgFzNeg.style.visibility = 'visible';
		objImgFzPos.style.visibility = 'hidden';
	}
	else	{
		objImgFzNeg.style.visibility = 'hidden';
		objImgFzPos.style.visibility = 'hidden';
	}
}

function	UpdateKoordKraefte(objEditKraefte)
{
	var objKraftX = document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_3');
	var objKraftY = document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_4');
	var objKraftZ = document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_5');
	var objKoordX = document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_7');
	var objKoordY = document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_8');
	var objKoordZ = document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_9');
	if (objKraftX.value == "" && objKraftY.value == "" && objKraftZ.value == "")	{
		objKoordX.value = "";
		objKoordY.value = "";
		objKoordZ.value = "";
	}
	/*
	else	{
		if (objKoordX.value == "")
			objKoordX.value = 0.;
		if (objKoordY.value == "")
			objKoordY.value = 0.;
		if (objKoordZ.value == "")
			objKoordZ.value = 0.;
	}
	*/
}

/*
function	ParseFloatEx(Value)
{
	Value		= Value.replace(',', '.');
	return parseFloat(Value);
}
*/