// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.10.14 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # Initialize Masse-Template (Message,...)
// # ============================================================================

var adXPosMassX = new Array(200, 100, 0);
var adYPosMassX = new Array(150, 75, 0);
var adXPosMassY = new Array(0, 100, 200);
var adYPosMassY = new Array(150, 75, 0);
var	adXPosMassY2 = new Array(400, 300, 200, 100, 0);


function	InitMassen()
{
	UpdateImagesMassen();
}

function	InitKraefte()
{
	UpdateImagesKraefte();
}

function	UpdateImagesMassen(objEditCtrl)
{
	PositionMassX();
	PositionMassY();
}

function	UpdateImagesKraefte(objEditCtrl)
{
	PositionKraftX();
	PositionKraftY();
}

function	PositionMassX()
{
	var dMass = parseFloat(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_2').value);
	var dY	= parseFloat(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_4').value);
	var dZ	= parseFloat(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_5').value);
	var dCharactLengthY = parseFloat(document.getElementById('IDC_CHARACTLENGTH_Y').value);
	var objImgMass	= document.getElementById('IDC_IMAGE_MASSX');
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_X');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);
	if (dY > dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[2];
	}
	else if (dY < -dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[0];
	}
	else	{
		dXPos = nLeft + adXPosMassX[1];
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassX[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassX[0];
	}
	else	{
		dYPos = nTop + adYPosMassX[1];
	}
//	alert(objSystemImg.style.zIndex);
//	alert(objImgMass.style.zIndex);
	objImgMass.style.zIndex = objSystemImg.style.zIndex + 1;
	objImgMass.style.top = dYPos;
	objImgMass.style.left = dXPos;
	objImgMass.style.position = 'absolute';
	objImgMass.style.visibility = 'visible';
}

function	PositionMassY()
{
	var objImgMass	= document.getElementById('IDC_IMAGE_MASSY');
	var dMass = parseFloat(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_2').value);
	var dX	= parseFloat(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_3').value);
	var dZ	= parseFloat(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_5').value);
	var dCharactLengthX = parseFloat(document.getElementById('IDC_CHARACTLENGTH_X').value);
	var nFWAnz = document.getElementById('IDC_FWANZ').value;
	var objImgMass	= document.getElementById('IDC_IMAGE_MASSY');
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_Y');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);

	if (nFWAnz == 8)	{
		var dCharactLengthX2 = parseFloat(document.getElementById('IDC_CHARACTLENGTH_X2').value);
		if (dX < -dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[0];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[1];
		}
		else if (dX > -dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[4];
		}
		else if (dX > -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[3];
		}
		else	{
			dXPos = nLeft + adXPosMassY2[2];
		}
	}
	else	{
		if (dX > dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[2];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[0];
		}
		else	{
			dXPos = nLeft + adXPosMassY[1];
		}
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassY[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassY[0];
	}
	else	{
		dYPos = nTop + adYPosMassY[1];
	}
	objImgMass.style.zIndex = objSystemImg.style.zIndex + 1;
	objImgMass.style.top = dYPos;
	objImgMass.style.left = dXPos;
	objImgMass.style.position = 'absolute';
	objImgMass.style.visibility = 'visible';
}

function	PositionKraftX()
{
	var dFy = parseFloat(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_4').value);
	var dFz = parseFloat(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_5').value);
	var dY	= parseFloat(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_8').value);
	var dZ	= parseFloat(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_9').value);
	var dCharactLengthY = parseFloat(document.getElementById('IDC_CHARACTLENGTH_Y').value);
	var objImgFyPos	= document.getElementById('IDC_IMAGE_FYPOS');
	var objImgFyNeg	= document.getElementById('IDC_IMAGE_FYNEG');
	var objImgFzPos	= document.getElementById('IDC_IMAGE_FZPOS1');
	var objImgFzNeg	= document.getElementById('IDC_IMAGE_FZNEG1');
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_X');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);
	if (dY > dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[2];
	}
	else if (dY < -dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[0];
	}
	else	{
		dXPos = nLeft + adXPosMassX[1];
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassX[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassX[0];
	}
	else	{
		dYPos = nTop + adYPosMassX[1];
	}
//	alert(objSystemImg.style.zIndex);
//	alert(objImgMass.style.zIndex);
	if (dFy > 0.)	{
		objImgFyPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFyPos.style.top = dYPos;
		objImgFyPos.style.left = dXPos;
		objImgFyPos.style.position = 'absolute';
		objImgFyPos.style.visibility = 'visible';
		objImgFyNeg.style.visibility = 'hidden';
	}
	else if (dFy > 0.)	{
		objImgFyNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFyNeg.style.top = dYPos;
		objImgFyNeg.style.left = dXPos;
		objImgFyNeg.style.position = 'absolute';
		objImgFyNeg.style.visibility = 'visible';
		objImgFyPos.style.visibility = 'hidden';
	}
	else	{
		objImgFyNeg.style.visibility = 'hidden';
		objImgFyPos.style.visibility = 'hidden';
	}
	if (dFz > 0.)	{
		objImgFzPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzPos.style.top = dYPos;
		objImgFzPos.style.left = dXPos;
		objImgFzPos.style.position = 'absolute';
		objImgFzPos.style.visibility = 'visible';
		objImgFzNeg.style.visibility = 'hidden';
	}
	else if (dFz > 0.)	{
		objImgFzNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzNeg.style.top = dYPos;
		objImgFzNeg.style.left = dXPos;
		objImgFzNeg.style.position = 'absolute';
		objImgFzNeg.style.visibility = 'visible';
		objImgFzPos.style.visibility = 'hidden';
	}
	else	{
		objImgFzNeg.style.visibility = 'hidden';
		objImgFzPos.style.visibility = 'hidden';
	}
}

function	PositionKraftY()
{
	var dFx = parseFloat(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_3').value);
	var dFz = parseFloat(document.getElementById('IDC_KRAFTSCHWERPUNKT_EDIT_1_5').value);
	var dX	= parseFloat(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_7').value);
	var dZ	= parseFloat(document.getElementById('IDC_KRAFT_KOORDINATEN_EDIT_1_9').value);
	var dCharactLengthX = parseFloat(document.getElementById('IDC_CHARACTLENGTH_X').value);
	var nFWAnz = document.getElementById('IDC_FWANZ').value;
	var objImgFxPos	= document.getElementById('IDC_IMAGE_FXPOS');
	var objImgFxNeg	= document.getElementById('IDC_IMAGE_FXNEG');
	var objImgFzPos	= document.getElementById('IDC_IMAGE_FZPOS2');
	var objImgFzNeg	= document.getElementById('IDC_IMAGE_FZNEG2');
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_Y');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);
	if (nFWAnz == 8)	{
		var dCharactLengthX2 = parseFloat(document.getElementById('IDC_CHARACTLENGTH_X2').value);
		if (dX < -dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[0];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[1];
		}
		else if (dX > -dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[4];
		}
		else if (dX > -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[3];
		}
		else	{
			dXPos = nLeft + adXPosMassY2[2];
		}
	}
	else	{
		if (dX > dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[2];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[0];
		}
		else	{
			dXPos = nLeft + adXPosMassY[1];
		}
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassY[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassY[0];
	}
	else	{
		dYPos = nTop + adYPosMassY[1];
	}
//	alert(objSystemImg.style.zIndex);
//	alert(objImgMass.style.zIndex);
	if (dFx > 0.)	{
		objImgFxPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFxPos.style.top = dYPos;
		objImgFxPos.style.left = dXPos;
		objImgFxPos.style.position = 'absolute';
		objImgFxPos.style.visibility = 'visible';
		objImgFxNeg.style.visibility = 'hidden';
	}
	else if (dFx > 0.)	{
		objImgFxNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFxNeg.style.top = dYPos;
		objImgFxNeg.style.left = dXPos;
		objImgFxNeg.style.position = 'absolute';
		objImgFxNeg.style.visibility = 'visible';
		objImgFxPos.style.visibility = 'hidden';
	}
	else	{
		objImgFxNeg.style.visibility = 'hidden';
		objImgFxPos.style.visibility = 'hidden';
	}
	if (dFz > 0.)	{
		objImgFzPos.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzPos.style.top = dYPos;
		objImgFzPos.style.left = dXPos;
		objImgFzPos.style.position = 'absolute';
		objImgFzPos.style.visibility = 'visible';
		objImgFzNeg.style.visibility = 'hidden';
	}
	else if (dFz > 0.)	{
		objImgFzNeg.style.zIndex = objSystemImg.style.zIndex + 1;
		objImgFzNeg.style.top = dYPos;
		objImgFzNeg.style.left = dXPos;
		objImgFzNeg.style.position = 'absolute';
		objImgFzNeg.style.visibility = 'visible';
		objImgFzPos.style.visibility = 'hidden';
	}
	else	{
		objImgFzNeg.style.visibility = 'hidden';
		objImgFzPos.style.visibility = 'hidden';
	}
}