#include "CDialogBase.b"
#include "DatenAllg.b"

/* Pruefen ob Steifigkeit kleiner ist als zuletzt berechnete KGT Steifigkeit
(d.h. wenn KGT Steifigkeit !=0
*/
function CheckSteifigkeit() {
	
	var KGTSteifigkeit=getdouble ("R_TOT","DLGDATA.KGTDATEN_KRAEFTE")*1000000.0; // umrechnen in N/m;
	var PFSSteifigkeit=getdouble ("10010.BASE","DLGDATA.SYSTEM");
	
	if ((KGTSteifigkeit!=0) && (PFSSteifigkeit>KGTSteifigkeit)) {
		return false;
	} else {
		return true;
	};
	
};
//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")
	
	strIntEvent = getstring("EVENT", "");	// Internes Event
	
	
	switch (strIntEvent) {
	case "INIT":	
		
		if ((dFWAnz == 1) or ((dFWAnz == 2) and (dFSAnz == 2)))
			setstring("LW1_VISIBLE", "DLGDATA.AUSMASSE", "hidden")
		else
			setstring("LW1_VISIBLE", "DLGDATA.AUSMASSE", "visible")

		if (dFWAnz == 8)
			setstring("LW2_VISIBLE", "DLGDATA.AUSMASSE", "visible")
		else
			setstring("LW2_VISIBLE", "DLGDATA.AUSMASSE", "hidden")

		if (dFSAnz == 1)
			setstring("LS_VISIBLE", "DLGDATA.AUSMASSE", "hidden")
		else
			setstring("LS_VISIBLE", "DLGDATA.AUSMASSE", "visible")
	}

    event       = getstring("EKSUBMITEVENT",    "");
    // print event;
    CDialogBase	dlg;
	switch (event)
	{
	case "IDC_ANTRIEBSSTEIFIGKEIT_UNIT_COMBO":
		strElementIds = "IDC_ANTRIEBSSTEIFIGKEIT_EDIT";
		strResult = dlg.getDialogElementEx("IDD_AUSMASSE", strElementIds);
		return strResult;
	case "IDC_ANTRIEBSABSTAND_LY_UNIT_COMBO":
		strElementIds = "IDC_TABLE01_MASSE";
		// print getdlgvar("IDC_ANTRIEBSABSTAND_LY_UNIT_COMBO");
		strUnit = getdlgvar("IDC_ANTRIEBSABSTAND_LY_UNIT_COMBO");
		setstring("10005.UNIT", "DLGDATA.SYSTEM", strUnit);
		setstring("10006.UNIT", "DLGDATA.SYSTEM", strUnit);
		setstring("10007.UNIT", "DLGDATA.SYSTEM", strUnit);
		setstring("10008.UNIT", "DLGDATA.SYSTEM", strUnit);
		setstring("10009.UNIT", "DLGDATA.SYSTEM", strUnit);
		setstring("ANTRIEB_KOORD.UNIT", "DLGDATA.SYSTEM", strUnit);
		strResult = dlg.getDialogElementEx("IDD_AUSMASSE", strElementIds);
		return strResult;
	case "TRY_CONTINUE":
		if (CheckSteifigkeit()) {
			return "<input></input><script>EKCheckEditAndSubmit('IDC_CONTINUE_BUT')</script>";
		} else {
			return "<input></input><script> alert ('"+translate("IDS_HIGHER_STIFFNESS")+"');EKCheckEditAndSubmit('IDC_CONTINUE_BUT')</script>";
		};
		break;
	case "IDC_ANTRIEBSABSTAND_LY_EDIT":
	case  "IDC_ANTRIEBSABSTAND_LZ_EDIT":
	case  "IDC_WAGENMITTENABSTAND_LW1_EDIT":
	case  "IDC_WAGENMITTENABSTAND_LW2_EDIT":
	case  "IDC_ANTRIEBSSTEIFIGKEIT_EDIT":
	case  "IDC_SCHIENENMITTENABSTAND_EDIT":
		  ClearResult();
		  strResult = dlg.getDialogElementEx("IDD_AUSMASSE", event);			
		  return strResult;
		  break;
	
	
	}

}