#include "CDialogBase.b"
#include "DatenAllg.b"

function	initKGTAusmasse()
{
	if (getstring("L_LAGER.PROFILEID", "DLGDATA.KGTSYSTEM") == "")	{
		strUnit_mm = "284";
		createobject("DLGDATA.KGTSYSTEM", "L_LAGER", 49, "10008", "", strUnit_mm);
		//setstring("L_LAGER.UNIT", "DLGDATA.KGTSYSTEM", strUnit_mm);
		createobject("DLGDATA.KGTSYSTEM", "P", 49, "10013", "", strUnit_mm);
		// setstring("P.UNIT", "DLGDATA.KGTSYSTEM", strUnit_mm);
		createobject("DLGDATA.KGTSYSTEM", "L_SPINDEL", 49, "10008", "", strUnit_mm);
		createobject("DLGDATA.KGTSYSTEM", "LS1", 49, "10008", 0, strUnit_mm);
		createobject("DLGDATA.KGTSYSTEM", "LS2", 49, "10008", 0, strUnit_mm);
		createobject("DLGDATA.KGTSYSTEM", "X0", 49, "10008", 0, strUnit_mm);
		bestimmeLSPindelFak();
	}
	selLagerart=getstring("LAGERART", "DLGDATA.KGTSYSTEM");
	if ( selLagerart== "")	{
		setstring("LAGERART", "DLGDATA.KGTSYSTEM", "FEST_LOS");
		setstring("LAGERARTIMAGE", "DLGDATA.KGTSYSTEM", "/EKCatImage/Lagerart_fest_los.png");
		setstring("LAGERARTTEXT2", "DLGDATA.KGTSYSTEM", "LOS");
		setstring("EMPTYSPU_CBOENTRY", "DLGDATA.KGTSYSTEM", "0=|");
		setstring("BDISABLE_SPU", "DLGDATA.KGTSYSTEM", "false");
		setstring("FL2ROTATIONSLAGER", "DLGDATA.KGTSYSTEM", "false");
	} else if (selLagerart != "FEST_LOS") {
		setstring("BDISABLE_SPU", "DLGDATA.KGTSYSTEM", "true");
	};
	buildDefSPUComboEntries();
	setstring ("BMSG_NOT_FOUND_SPU","DLGDATA.KGTAUSMASSE","false");
}

function	handleLagerArt(strSelLagerart)
{
    CDialogBase	dlg;
    strSelLagerart = getstring("LAGERART", "DLGDATA.KGTSYSTEM");
    strLArtImg = bestimmeLagerArtImage(strSelLagerart, "");
	strImg = bestimmeSPUImage(strSelLagerart);
	bestimmeLagerArtChecked(strSelLagerart);
	strRet = dlg.updateImage("IDC_LAGERART_IMAGE", strLArtImg);
	strRet += dlg.updateImage("IDC_SPU_IMG", strImg);
	aLager = strSelLagerart.split("_");
	if (aLager.length > 1)	{
		setstring("LAGERARTTEXT2", "DLGDATA.KGTSYSTEM", aLager[1]);
		strRet += dlg.updateTableCellClient("IDC_Reihe3_4", translate(aLager[1]));
		// strRet += dlg.updateTableCellClient("IDC_SPUImageTable3_4", translate(aLager[1]));
	}
	if (strSelLagerart == "FEST_LOS")	{
		//setstring("EMPTYSPU_CBOENTRY", "DLGDATA.KGTSYSTEM", "0=|");
		// setstring("EMPTYSPU_CBOENTRY", "DLGDATA.KGTSYSTEM", "");
		//setint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM", 1);
		setstring("BDISABLE_SPU", "DLGDATA.KGTSYSTEM", "false");
	}
	else	{
		//setstring("EMPTYSPU_CBOENTRY", "DLGDATA.KGTSYSTEM", "0=|");
		//setint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM", 0);
		setstring("BDISABLE_SPU", "DLGDATA.KGTSYSTEM", "true");
	}
	setstring("EMPTYSPU_CBOENTRY", "DLGDATA.KGTSYSTEM", "0=|");
	setint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM", 0);
	// strRet += dlg.getDialogElementEx("IDD_KGTAUSMASSE", "*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ");
	var strItemlist = "0=|" + getstring("SPU_CBOENTRIES", "DLGDATA.KGTSYSTEM");
	strRet += dlg.setComboItemsAndValue("*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ", strItemlist, "0");
	strRet += dlg.getDialogElementEx("IDD_KGTAUSMASSE", "IDC_LS2HELPFILE");
	return strRet;
}

function	bestimmeSPUImage(strSelLagerart)
{
    nSpuAnz = getstring("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM");
	if (getstring("BSPINDELUNTERSTUETZUNG", "DLGDATA.KGTSYSTEM") == "true" && nSpuAnz != "" )	{
		strImg = strSelLagerart + "_" + nSpuAnz + ".png";
		setstring("SPU_IMAGE", "DLGDATA.KGTSYSTEM", "/EKCatImage/" + strImg);
		strImg = GetAbsPath("/EKCatImage/") + "/" + strImg;
		strImg = strImg.replace("\\", "/");
	}
	else	{
		strImg = "blank.gif";
		setstring("SPU_IMAGE", "DLGDATA.KGTSYSTEM", "/EKImage/" + strImg);
		strImg = GetAbsPath("/EKImage/") + "/" + strImg;
		strImg = strImg.replace("\\", "/");
	}
	return strImg;
}

function	bestimmeLagerArtImage(strSelLagerart, strFocus)
{
	strImg = "Lagerart_" + strSelLagerart;
	setstring("LAGERARTIMAGE", "DLGDATA.KGTSYSTEM", "/EKCatImage/" + strImg + ".png");
	strImg = GetAbsPath("/EKCatImage/") + "/" + strImg;
	strImg = strImg.replace("\\", "/");
	strImg += getLAImageSuffix(strFocus) + ".png";
	
	return strImg
}

function	getLAImageSuffix(strFocus)
{
	return strFocus == "" ? strFocus : "_" + strFocus;
}

function	bestimmeLagerArtChecked(strSelLagerart)
{
	switch (strSelLagerart)
	{
	case "LAGERART_FEST_FEST":
		setstring("BLAGERART_FEST_FEST", "DLGDATA.KGTSYSTEM", "true");
		setstring("BLAGERART_FEST_LOS", "DLGDATA.KGTSYSTEM", "false");
		setstring("BLAGERART_FEST_FREI", "DLGDATA.KGTSYSTEM", "false");
		break;
	case "LAGERART_FEST_LOS":
		setstring("BLAGERART_FEST_FEST", "DLGDATA.KGTSYSTEM", "false");
		setstring("BLAGERART_FEST_LOS", "DLGDATA.KGTSYSTEM", "true");
		setstring("BLAGERART_FEST_FREI", "DLGDATA.KGTSYSTEM", "false");
		break;
	case "LAGERART_FEST_FREI":
		setstring("BLAGERART_FEST_FEST", "DLGDATA.KGTSYSTEM", "false");
		setstring("BLAGERART_FEST_LOS", "DLGDATA.KGTSYSTEM", "false");
		setstring("BLAGERART_FEST_FREI", "DLGDATA.KGTSYSTEM", "true");
		break;
	default:
		setstring("BLAGERART_FEST_FEST", "DLGDATA.KGTSYSTEM", "false");
		setstring("BLAGERART_FEST_LOS", "DLGDATA.KGTSYSTEM", "false");
		setstring("BLAGERART_FEST_FREI", "DLGDATA.KGTSYSTEM", "false");
		break;
	}
}

function	berechneLSPindel()
{
	dLLager = getdouble("L_LAGER.RAW","DLGDATA.KGTSYSTEM");
	nSPUAnz = getint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM");
	if (nSPUAnz > 0)	{
		setdouble("L_SPINDEL.RAW", "DLGDATA.KGTSYSTEM", dLLager / (nSPUAnz + 1));
		strValue = getstring("L_SPINDEL.VALUE", "DLGDATA.KGTSYSTEM");
	}
	else	{
		strValue = "";
		setstring("L_SPINDEL.RAW", "DLGDATA.KGTSYSTEM", strValue);
	}
	return strValue;
}

function	bestimmeLSPindelFak()
{
	nSPUAnz = getint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM");
	dFak = 1/(nSPUAnz + 1);
	strValue = formatstring(dFak, "%.2f") + " L<sub>1</sub> = ";
	setstring("L_SPINDEL_FAK", "DLGDATA.KGTSYSTEM", strValue);
	return strValue;
}


function	handleStuetzstellenAnz()
{
    CDialogBase	dlg;
    strSelLagerart = getstring("LAGERART", "DLGDATA.KGTSYSTEM");
	strImg = bestimmeSPUImage("LAGERART_" + strSelLagerart)
	strLSpindel = berechneLSPindel();
	strFak = bestimmeLSPindelFak();
	strRet = dlg.updateImage("IDC_SPU_IMG", strImg);
	strRet += dlg.updateTableCellClient("IDC_Reihe10_3", strLSpindel);
	strRet += dlg.updateTableCellClient("IDC_Reihe10_2", strFak);
/*	
    strRet += dlg.updateHTML("IDC_SPINDELABSTAND_IM_BILD", strLSpindel + " " + getstring("L_SPINDEL.UNIT.VALUE", "DLGDATA.KGTSYSTEM"));
    strRet += "<SCRIPT>positionSPUAbstandBild();</SCRIPT>";
*/    
	return strRet;
}

function	handleLLager()
{
	strValue = berechneLSPindel();
    CDialogBase	dlg;
    strRet = "<input></input>" + dlg.updateTableCellClient("IDC_Reihe10_3", strValue);
    strRet += dlg.updateHTML("IDC_SPINDELABSTAND_IM_BILD", strValue + " " + getstring("L_SPINDEL.UNIT.VALUE", "DLGDATA.KGTSYSTEM"));
    return strRet;
}

function	handleBSPU()
{
    CDialogBase	dlg;
	
	var strItemlist = "";
	var strSPUAnz = "0";
	var strRet = "<input></input>";
	if (getstring("BSPINDELUNTERSTUETZUNG", "DLGDATA.KGTSYSTEM") != "true")	{
		strItemlist = "0=|";
		setstring("EMPTYSPU_CBOENTRY", "DLGDATA.KGTSYSTEM", "0=|");
		setint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM", 0);		
		setstring ("KGTSYSTEM.FL2ROTATIONSLAGER","DLGDATA","false");
		
	}
	else	{
		setstring("EMPTYSPU_CBOENTRY", "DLGDATA.KGTSYSTEM", "");
		setint("STUETZSTELLENANZ", "DLGDATA.KGTSYSTEM", 1);
		setstring ("KGTDATEN.PM_BAUREIHE","DLGDATA","Antriebseinheit AGK");
		setstring ("KGTDATEN.PM_ANTRIEBSART","DLGDATA","Angetriebene Spindel");
		
		
		strSPUAnz = "1";
	}
	strLSpindel = berechneLSPindel();
	strFak = bestimmeLSPindelFak();
	strRet += dlg.updateTableCellClient("IDC_Reihe10_3", strLSpindel);
	strRet += dlg.updateTableCellClient("IDC_Reihe10_2", strFak);
    strSelLagerart = getstring("LAGERART", "DLGDATA.KGTSYSTEM");
	strImg = bestimmeSPUImage("LAGERART_" + strSelLagerart)
	strRet += dlg.updateImage("IDC_SPU_IMG", strImg);

	strItemlist += getstring("SPU_CBOENTRIES", "DLGDATA.KGTSYSTEM");
	strRet += dlg.setComboItemsAndValue("*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ", strItemlist, strSPUAnz);
	if (getstring ("KGTSYSTEM.FL2ROTATIONSLAGER","DLGDATA")=="true") {
		strRet +="<script>document.getElementById('*.DLGDATA.KGTSYSTEM.FL2ROTATIONSLAGER').checked = true;</script>";
	} else {
		strRet +="<script>document.getElementById('*.DLGDATA.KGTSYSTEM.FL2ROTATIONSLAGER').checked = false;</script>";
	};
	return strRet;
}

function	handleFocus()
{
    CDialogBase	dlg;
	strLArtImg = bestimmeLagerArtImage(getstring("LAGERART", "DLGDATA.KGTSYSTEM"), getdlgvar("EKSUBMITEVENTPAR"));
	strRet = dlg.updateImage("IDC_LAGERART_IMAGE", strLArtImg);
	return strRet;
}

function	buildDefSPUComboEntries()
{
	var strTmp = "1=" + translate("SPU1") + "|2=" + translate("SPU2") + "|3=" + translate("SPU3") + "|4=" + translate("SPU4");
	setstring("SPU_CBOENTRIES", "DLGDATA.KGTSYSTEM", strTmp);
}

function GetAliasDir (aliasname) {
	var result="";
	var AliasConfig=Object.fromStorage("ROOT.CATALOG.ALIAS");
	for (var i=0;i<AliasConfig.length;i++) {
		if (AliasConfig[i].NAME==aliasname) {
			result=AliasConfig[i].PATH;
			break;
		};
	};
	return result;
};


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
    event       = getstring("EKSUBMITEVENT",    "");
    // print event;
	strIntEvent		= getstring("EVENT","")		
	
	switch (strIntEvent) {
	case "INIT":	
		initKGTAusmasse();
		setstring("P.RAW", "DLGDATA.KGTSYSTEM", getstring("PM_STEIGUNG", "DLGDATA.KGTDATEN"));
		break;
	}
    CDialogBase	dlg;
	switch (event)
	{
/*	
	case "LAGERART_FEST_FEST":
	case "LAGERART_FEST_LOS":
	case "LAGERART_FEST_FREI":
*/	
	case "*.DLGDATA.KGTSYSTEM.LAGERART":
		clearResultsKGT();
		return handleLagerArt(event);
		break;
	case "*.DLGDATA.KGTSYSTEM.STUETZSTELLENANZ":
		clearResultsKGT();
		return handleStuetzstellenAnz();
		break;
	case "*.DLGDATA.KGTSYSTEM.L_LAGER.VALUE":
		clearResultsKGT();
		return handleLLager();
		break;
	case "*.DLGDATA.KGTSYSTEM.BSPINDELUNTERSTUETZUNG":
		clearResultsKGT();
		return handleBSPU();
		break;
	case "FOCUS":
		return handleFocus();
		break;
	case "IDC_ENGLISCH_BUT":
		var bRet = changelanguage("EN"); // Muss hier umgeschaltet werden und nicht erst in Process.b um Comboboxen korrekt zu befuellen
		buildDefSPUComboEntries();
		break;
	case "IDC_DEU_BUT":
		var bRet = changelanguage("DE"); // s.o.
		buildDefSPUComboEntries();
		break;
	case "IDC_SPINDELUNTERSTUETZUNG_INFO":
		var d=GetAliasDir ("EKCatHelp");
		d=replace(d,"/","\\");
		var pdfFile=d+"\\Vorteile_Spindelunterstuetzung_"+getlanguage()+".pdf";
		shellexecute (pdfFile,"","");
		return "";
		break;
	case "FESTLAGER_LS1":
		var d=GetAliasDir ("EKCatHelp");
		d=replace(d,"/","\\");
		var pdfFile=d+"\\Festlager_LS1_"+getlanguage()+".pdf";
		shellexecute (pdfFile,"","");
		return "";
		break;
	case "LS2_HELPFILE":
		var d=GetAliasDir ("EKCatHelp");
		d=replace(d,"/","\\");
		var pdfFile=d+"\\"+getstring ("KGTSYSTEM.LAGERART","DLGDATA")+"_LS2_"+getlanguage()+".pdf";
		shellexecute (pdfFile,"","");
		return "";
		break;
	}
	return false;
}