#include "CDialogBase.b"
#include "KGTCalc.b"
#include "Zyklus.b"
#include "CheckFunctions.b"
#include "DatenAllg.b"
#include "Massen.b"

/* Liefert true gdw. fuer alle zur KGT Bestimmung relevanten Comboxen eine Eintrag ausgewaehlt ist
*/
function    verifySelection () {
	var antriebsart=getstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN");
	var baureihe=getstring("PM_BAUREIHE", "DLGDATA.KGTDATEN");
	var mutter=getstring("PM_BR_MUTTER", "DLGDATA.KGTDATEN");
	var vorspann=getstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN");
	var vertrieb=getstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN");
	var selectionComplete=true;
	/*
	if (vertrieb=="") {
		selectionComplete=false;
	};
	*/
	if (vorspann=="") {
		selectionComplete=false;
		setstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN","");
	};
	if (mutter=="") {
		selectionComplete=false;
		setstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN","");
		setstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN","");
	};
	if (baureihe=="") {
		selectionComplete=false;
		setstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN","");
		setstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN","");
		setstring("PM_BR_MUTTER", "DLGDATA.KGTDATEN","");
	};
	if (antriebsart=="") {
		selectionComplete=false;
		setstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN","");
		setstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN","");
		setstring("PM_BR_MUTTER", "DLGDATA.KGTDATEN","");
		setstring("PM_BAUREIHE", "DLGDATA.KGTDATEN","");
	};
	return selectionComplete;

};
// Pruefen, ob aktuell ausgewehlte Eingragte in Comboboxen mit ausgewahelter Steigung
// moeglich sind. Wenn nicht, Eintraege  zuruecksetzen 
// Wird gebraucht, falls Steigung ausserhalb Maske Daten geaendert wird;
verifyCompatibilitySteigung() {
	var testComboList=CreateCombobox1('XML', 'KGT', 'PM_STEIGUNG', 0, 'abs(PM_STEIGUNG)', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE', 'PM_BR_MUTTER', 'P_VORSPANNKLASSE_BEZ_C', 'PM_ANTRIEBSART', 'PM_KATEGORIE_VERTRIEB','PM_STEIGUNG');
	if (testComboList=="") {
		// Steigung nicht kompatibel
		clearResultsKGT();
		setstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN","");
		setstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN","");
		setstring("PM_BR_MUTTER", "DLGDATA.KGTDATEN","");
		setstring("PM_BAUREIHE", "DLGDATA.KGTDATEN","");
		setstring("PM_ANTRIEBSART","DLGDATA.KGTDATEN","");
	};
};

function	onComboChange(event)
{
/*
	setdlgvar("IDC_ANGETRIEBENESELEMENT_COMBO_ITEMS", CreateCombobox1("XML", "KGT", "PM_ANTRIEBSART", 0, "", "DLGDATA.KGTDATEN", "PM_BAUREIHE", "PM_BR_MUTTER", "P_VORSPANNKLASSE_BEZ_C", "PM_STEIGUNG"));
	setdlgvar("IDC_BAUART_COMBO_ITEMS", CreateCombobox1("XML", "KGT", "PM_BAUREIHE", 0, "", "DLGDATA.KGTDATEN", "PM_ANTRIEBSART", "PM_BR_MUTTER", "P_VORSPANNKLASSE_BEZ_C", "PM_STEIGUNG"));
	setdlgvar("IDC_BAUREIHEMUTTER_COMBO_ITEMS", CreateCombobox1("XML", "KGT", "PM_BR_MUTTER", 0, "", "DLGDATA.KGTDATEN", "PM_BAUREIHE", "PM_ANTRIEBSART", "P_VORSPANNKLASSE_BEZ_C", "PM_STEIGUNG"));
	setdlgvar("IDC_VORSPANNUNG_COMBO_ITEMS", CreateCombobox1("XML", "KGT", "P_VORSPANNKLASSE_BEZ_C", 0, "", "DLGDATA.KGTDATEN", "PM_BAUREIHE", "PM_BR_MUTTER", "PM_ANTRIEBSART", "PM_STEIGUNG"));
	setdlgvar("IDC_SPSTEIGUNG_COMBO_ITEMS", CreateCombobox1("XML", "KGT", "PM_STEIGUNG", 0, "", "DLGDATA.KGTDATEN", "PM_BAUREIHE", "PM_BR_MUTTER", "P_VORSPANNKLASSE_BEZ_C", "PM_ANTRIEBSART"));
*/	
	clearResultsKGT();
	verifySelection();
	setbool ("NEWWARNHINWEIS","DLGDATA.KGTDATEN",false);
	/*
	if (verifySelection()) {
		ZTable	Tab("DLGDATA.KGTDATEN.SEARCHRESULT", "KGT", "SQL_KGTSEARCH");
		Tab.update(true);
		checkLebensdauer(Tab);
		selectFirstResultRow(Tab);
	} else {
		setbool ("NEWWARNHINWEIS","DLGDATA.KGTDATEN",false);
	}
	*/
	// strElementIds = "IDC_SEARCH_TAB|IDC_WARNHINWIESE_TAB|*.DLGDATA.KGTDATEN.PM_ANTRIEBSART|*.DLGDATA.KGTDATEN.PM_BAUREIHE|*.DLGDATA.KGTDATEN.PM_BR_MUTTER|*.DLGDATA.KGTDATEN.P_VORSPANNKLASSE_BEZ_C|*.DLGDATA.KGTDATEN.PM_STEIGUNG|*.DLGDATA.KGTDATEN.PM_KATEGORIE_VERTRIEB";
	strElementIds = "IDC_SEARCH_TAB|IDC_SEARCH_TAB_SONDER|IDC_WARNHINWIESE_TAB|IDC_LEBENSDAUER_TAB";
	CDialogBase	dlg;
	strResult = dlg.getDialogElementEx("IDD_KGTDATEN", strElementIds);
	// strResult += dlg.getDialogElementEx("IDD_KGTDATEN", "IDC_WARNHINWIESE_TAB");
	// strResult += dlg.getDialogElementEx("IDD_KGTDATEN", "IDC_SEARCH_TAB");
	strResult += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_ANTRIEBSART", "=|" + CreateCombobox1('XML', 'KGT', 'PM_ANTRIEBSART', 1, '', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE', 'PM_BR_MUTTER', 'P_VORSPANNKLASSE_BEZ_C', 'PM_STEIGUNG', 'PM_KATEGORIE_VERTRIEB'), getstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN"));
	strResult += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_BAUREIHE", "=|" + CreateCombobox1('XML', 'KGT', 'PM_BAUREIHE', 1, '', 'DLGDATA.KGTDATEN', 'PM_ANTRIEBSART', 'PM_BR_MUTTER', 'P_VORSPANNKLASSE_BEZ_C', 'PM_STEIGUNG', 'PM_KATEGORIE_VERTRIEB'), getstring("PM_BAUREIHE", "DLGDATA.KGTDATEN"));
	strResult += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_BR_MUTTER", "=|" + CreateCombobox1('XML', 'KGT', 'PM_BR_MUTTER', 0, '', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE', 'PM_ANTRIEBSART', 'P_VORSPANNKLASSE_BEZ_C', 'PM_STEIGUNG', 'PM_KATEGORIE_VERTRIEB'), getstring("PM_BR_MUTTER", "DLGDATA.KGTDATEN"));
	strResult += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.P_VORSPANNKLASSE_BEZ_C", "=|" + CreateCombobox1('XML', 'KGT', 'P_VORSPANNKLASSE_BEZ_C', 0, 'abs(P_VORSPANNKLASSE_BEZ_C)', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE', 'PM_BR_MUTTER', 'PM_ANTRIEBSART', 'PM_STEIGUNG', 'PM_KATEGORIE_VERTRIEB'), getstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN"));
	//strResult += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_KATEGORIE_VERTRIEB", "=|" + CreateCombobox1('XML', 'KGT', 'PM_KATEGORIE_VERTRIEB', 1, 'PM_KATEGORIE_VERTRIEB', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE',  'PM_BR_MUTTER','PM_ANTRIEBSART', 'P_VORSPANNKLASSE_BEZ_C', 'PM_STEIGUNG'), getstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN"));
	strResult += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_STEIGUNG", "=|" + CreateCombobox1('XML', 'KGT', 'PM_STEIGUNG', 0, 'abs(PM_STEIGUNG)', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE', 'PM_BR_MUTTER', 'P_VORSPANNKLASSE_BEZ_C', 'PM_ANTRIEBSART', 'PM_KATEGORIE_VERTRIEB'), getstring("PM_STEIGUNG", "DLGDATA.KGTDATEN"));
	strResult += "<input></input>";
	strResult += dlg.updateTableCellClient("IDC_KRAFTBELASTUNG", getstring("F_AEQUI_EXT.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strResult += dlg.updateTableCellClient("IDC_GESAMTBELASTUNG", getstring("F_AEQUI_GES.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strResult += dlg.updateTableCellClient("IDC_FMAX", getstring("F_GESMAX.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strResult += dlg.updateTableCellClient("IDC_FMAX_IN_T", getstring("PHASE_F_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE"));
	strResult += dlg.updateTableCellClient("IDC_CFMAX", formatstring(getdouble('CFMAX_VRHLTNS','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	strResult += dlg.updateTableCellClient("IDC_C0FMAX", formatstring(getdouble('C0FMAX_VRHLTNS','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	strResult += dlg.updateTableCellClient("IDC_MMAX", getstring("M_GESMAX.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strResult += dlg.updateTableCellClient("IDC_MMAX_IN_T", getstring("PHASE_M_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE"));
	strResult += dlg.updateTableCellClient("IDC_CREDFAEQUI_VRHLTNS", formatstring(getdouble('CFAEQUI_VRHLTNS','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	/*
	strResult += dlg.updateTableCellClient("IDC_L10_KM", formatstring(getdouble('L_KM10','DLGDATA.KGTDATEN_KRAEFTE'),'%.1e'));
	strResult += dlg.updateTableCellClient("IDC_L10_U", formatstring(getdouble('L_10','DLGDATA.KGTDATEN_KRAEFTE'),'%.1e'));
	strResult += dlg.updateTableCellClient("IDC_L10_H", formatstring(getdouble('L_H10','DLGDATA.KGTDATEN_KRAEFTE'),'%.1e'));
	strResult += dlg.updateTableCellClient("IDC_R_TOT", formatstring(getdouble('R_TOT','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	*/
	strResult += dlg.updateTableCellClient("IDC_FQ", formatstring(getdouble('F_AEQUI_GES.VALUE','DLGDATA.KGTDATEN_KRAEFTE'),'%.0f'));
		/*
	var newwarnhinweis=getbool ("NEWWARNHINWEIS","DLGDATA.KGTDATEN");
	if (newwarnhinweis) {
	    var script='<script>alert ("'+translate("IDC_WARNHINWEISE_BEACHTEN")+'")</script>';
		strResult +=  script;
	};
	*/
	return strResult;
}
// Nach Edit von Sondermutter Daten in KGTDaten aktualisieren
function updateWithSondermutter() {
	var strRet="";
	CDialogBase	dlg;
	strElementIds = "IDC_SEARCH_TAB_SONDER|IDC_SEARCH_TAB";
	
	// Daten in Ergebnistabelle uebernehmen
	setstring ("P_MATERIALNR","DLGDATA.KGTDATEN.DATEN_SONDERMUTTER[0]",getstring ("P_MATERIALNR","DLGDATA.KGTDATEN.KGT_SONDER"));
	setstring ("P_C.VALUE","DLGDATA.KGTDATEN.DATEN_SONDERMUTTER[0]",getstring ("P_C.VALUE","DLGDATA.KGTDATEN.KGT_SONDER"));
	setstring ("P_C0.VALUE","DLGDATA.KGTDATEN.DATEN_SONDERMUTTER[0]",getstring ("P_C0.VALUE","DLGDATA.KGTDATEN.KGT_SONDER"));
	setstring ("PM_D0.VALUE","DLGDATA.KGTDATEN.DATEN_SONDERMUTTER[0]",getstring ("PM_D0.VALUE","DLGDATA.KGTDATEN.KGT_SONDER"));
	//setstring ("PM_KATEGORIE_VERTRIEB","DLGDATA.KGTDATEN.DATEN_SONDERMUTTER[0]",getstring ("PM_KATEGORIE_VERTRIEB.VALUE","DLGDATA.KGTDATEN.KGT_SONDER"));
	
	
	strRet += dlg.getDialogElementEx("IDD_KGTDATEN", strElementIds);

	strRet += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_ANTRIEBSART", "=|" + CreateCombobox1('XML', 'KGT', 'PM_ANTRIEBSART'), getstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN"));
	strRet += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_BAUREIHE", "=|" + CreateCombobox1('XML', 'KGT', 'PM_BAUREIHE'), getstring("PM_BAUREIHE", "DLGDATA.KGTDATEN"));
	strRet += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_STEIGUNG", "=|" + CreateCombobox1('XML', 'KGT', 'PM_STEIGUNG', 0, 'abs(PM_STEIGUNG)', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE', 'PM_BR_MUTTER', 'P_VORSPANNKLASSE_BEZ_C', 'PM_ANTRIEBSART', 'PM_KATEGORIE_VERTRIEB'), getstring("PM_STEIGUNG", "DLGDATA.KGTDATEN"));
	//strRet += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.PM_STEIGUNG", "=|" + CreateCombobox1('XML', 'KGT', 'PM_STEIGUNG', 0, 'abs(PM_STEIGUNG)', 'DLGDATA.KGTDATEN', 'PM_BAUREIHE', 'PM_BR_MUTTER', 'P_VORSPANNKLASSE_BEZ_C', 'PM_ANTRIEBSART', 'PM_KATEGORIE_VERTRIEB'), getstring("PM_STEIGUNG", "DLGDATA.KGTDATEN"));
	strRet += updateResultsClient(true);
	
	return strRet;
};
function	updateVInZyklus()
{
}

function	updateNInZyklus()
{
	var nAnz = getint("SIZE", "DLGDATA.DYNZYKLUS.PROFIL");
	for (var i = 0; i < nAnz; i++)	{
		calcNE(nProfilIndex);
		calcNM(nProfilIndex);
	}
}

function	selectFirstResultRow(objTab)
{
	var bRet = false;
	kgtid		=getstring ("ID","KGT");
	kgtid		=getstring ("ID","KGT");
	if (objTab.size() > 0)	{
		objTab.goTop();
		objTab.instProduct("DLGDATA.KGTDATEN.KGT_STANDARD");
		kgtid		=getstring ("ID","KGT");
		setalias("KGT", "DLGDATA.KGTDATEN.KGT_STANDARD");
		CKGTCalc	Calc("KGT");
		var F_Aequi = Calc.berechneKGTDaten();
		Calc.generiereWarnhinweise();
		setstring("SEARCHSELECTED", "DLGDATA.KGTDATEN", "IDC_SEARCH_TAB_0");
		bRet = true;
	}
	else
		setstring("SEARCHSELECTED", "DLGDATA.KGTDATEN", "");
	return bRet;
}

function	updateResultsClient(delayWarnmessage)
{
	CDialogBase	dlg;
	strRet = "<input></input>";
	strRet += dlg.updateTableCellClient("IDC_KRAFTBELASTUNG", getstring("F_AEQUI_EXT.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strRet += dlg.updateTableCellClient("IDC_GESAMTBELASTUNG", getstring("F_AEQUI_GES.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strRet += dlg.updateTableCellClient("IDC_FMAX", getstring("F_GESMAX.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strRet += dlg.updateTableCellClient("IDC_FMAX_IN_T", getstring("PHASE_F_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE"));
	strRet += dlg.updateTableCellClient("IDC_MMAX", getstring("M_GESMAX.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
	strRet += dlg.updateTableCellClient("IDC_MMAX_IN_T", getstring("PHASE_M_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE"));
	
	strRet += dlg.updateTableCellClient("IDC_CFMAX", formatstring(getdouble('CFMAX_VRHLTNS','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	strRet += dlg.updateTableCellClient("IDC_C0FMAX", formatstring(getdouble('C0FMAX_VRHLTNS','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	strRet += dlg.updateTableCellClient("IDC_CREDFAEQUI_VRHLTNS", formatstring(getdouble('CFAEQUI_VRHLTNS','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	/*
	strRet += dlg.updateTableCellClient("IDC_L10_U", formatstring(getdouble('L_10','DLGDATA.KGTDATEN_KRAEFTE'),'%.1e'));
	strRet += dlg.updateTableCellClient("IDC_L10_H", formatstring(getdouble('L_H10','DLGDATA.KGTDATEN_KRAEFTE'),'%.1e'));
	strRet += dlg.updateTableCellClient("IDC_L10_KM", formatstring(getdouble('L_KM10','DLGDATA.KGTDATEN_KRAEFTE'),'%.1e'));
	*/
	strRet += dlg.updateTableCellClient("IDC_R_TOT", formatstring(getdouble('R_TOT','DLGDATA.KGTDATEN_KRAEFTE'),'%.1f'));
	strRet += dlg.updateTableCellClient("IDC_FQ", formatstring(getdouble('F_AEQUI_GES.VALUE','DLGDATA.KGTDATEN_KRAEFTE'),'%.0f'));
	strRet += dlg.getDialogElementEx("IDD_KGTDATEN", "IDC_WARNHINWIESE_TAB|IDC_LEBENSDAUER_TAB");
	var newwarnhinweis=getbool ("NEWWARNHINWEIS","DLGDATA.KGTDATEN");
	var automatictest = getstring("CATALOG.AUTOMATICTEST","ROOT");		// -mw- Popup-Meldungen nicht hochfahren, wenn automatisierte Tests laufen
	if (newwarnhinweis && (automatictest != "true")) {
		if (!delayWarnmessage) {
			var script='<script>alert ("'+translate("IDC_WARNHINWEISE_BEACHTEN")+'")</script>';
		}  else {
			var script='<script>setTimeout(function () {alert ("'+translate("IDC_WARNHINWEISE_BEACHTEN")+'")},500)</script>';
		};
		strRet +=  script;
	};

	return strRet;
}

/* Label fuer diverse Kraftverhaeltnisse setzen, abhaengig davon ob Tragzahlabschlag vorliegt
*/
function setLabelsForceRatios() {
	CKGTCalc	Calc("KGT");
 if (Calc.getKFTragabFak()<0.99999999) { //1.0-eps
	setstring ("C_FMAX_LABEL","DLGDATA.KGTDATEN","C&lt;sub&gt;red&lt;/sub&gt;/F&lt;sub&gt;max&lt;/sub&gt;");
	setstring ("C0_FMAX_LABEL","DLGDATA.KGTDATEN","C&lt;sub&gt;0,red&lt;/sub&gt;/F&lt;sub&gt;max&lt;/sub&gt;");
	setstring ("C_FQ_LABEL","DLGDATA.KGTDATEN","C&lt;sub&gt;red&lt;/sub&gt;/F&lt;sub&gt;q&lt;/sub&gt;");
 } else {
	setstring ("C_FMAX_LABEL","DLGDATA.KGTDATEN","C/F&lt;sub&gt;max&lt;/sub&gt;");
	setstring ("C0_FMAX_LABEL","DLGDATA.KGTDATEN","C&lt;sub&gt;0&lt;/sub&gt;/F&lt;sub&gt;max&lt;/sub&gt;");
	setstring ("C_FQ_LABEL","DLGDATA.KGTDATEN","C/F&lt;sub&gt;q&lt;/sub&gt;");
 };
};
main()
{
    PATH		= "DLGDATA.KGTDATEN";  
    event       = getstring("EKSUBMITEVENT",    "");
	kgtid		=getstring ("ID","KGT");
	
/*    
    if (getstring("SEARCHRESULT.ID", "DLGDATA.KGTDATEN") == "")
		dscopy("KGT", "DLGDATA.KGTDATEN.SEARCHRESULT");
*/		
	strIntEvent = getstring("EVENT", "");	// Internes Event
	if (strIntEvent == "INIT")	{
		verifyCompatibilitySteigung();
		bRet	= execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCVM");
		initKGTCalcKraefte();
		if (getstring("GEF_LEBENSDAUER.PROFILEID","DLGDATA.DATEN") == "")	{
			bRet = createobject("DLGDATA.DATEN","GEF_LEBENSDAUER", 49, "10010", "", "281");
			bRet = createobject("DLGDATA.DATEN","GEF_LEBENSDAUER_H", 49, "22", "", "315");
		}
		if (getstring("F_AEQUI_GES.PROFILEID", "DLGDATA.KGTDATEN_KRAEFTE") == "")	{
			dRet = createobject("DLGDATA.KGTDATEN_KRAEFTE", "F_AEQUI_GES", 49, "11");
		}
		if (getstring("F_AEQUI_EXT.PROFILEID", "DLGDATA.KGTDATEN_KRAEFTE") == "")	{
			dRet = createobject("DLGDATA.KGTDATEN_KRAEFTE", "F_AEQUI_EXT_GES", 49, "11");
		}

		
		if (getstring("KEEPKONST", "DLGDATA.KGTDATEN") == "")	{
			setstring("KEEPKONST", "DLGDATA.KGTDATEN", "V_KONST");
			setstring("VKONST_CHECK", "DLGDATA.KGTDATEN", "true");
			setstring("NKONST_CHECK", "DLGDATA.KGTDATEN", "false");
		}
		if (getalias("KGT") == "")	{
			if (getstring("SONDERMUTTER", "DLGDATA.KGTDATEN") == "true")	{
				setalias("KGT", "DLGDATA.KGTDATEN.KGT_SONDER");
			}
			else	{
				setalias("KGT", "DLGDATA.KGTDATEN.KGT_STANDARD");
			}
		}
		baureiheCurrent =getstring ("KGTDATEN.PM_BAUREIHE","DLGDATA"); // Aktuelle gewaehlte Baureihe bei Dialogstart merken
		setstring ("KGTDATEN.PM_BAUREIHE_CURRENT","DLGDATA",baureiheCurrent);
		
		// Einheit fuer Lebensdauer synchronisieren
		var strUnit = getstring("GEF_LEBENSDAUER.UNIT", "DLGDATA.DATEN");
		setstring('L_DIST.UNIT','DLGDATA.KGTDATEN_KRAEFTE',strUnit);
		
		// Durch die Abhaengigkeiten zwischen den Comboboxen gehen aus noch nicht voellig erforschten Gruenden
		// teilweise die bei der Spindeluntersutzung voreingestellten Werte verloren (insbesondere bei Steigungen
		// zu denen es keine zu den Defaultwerten passenden KGTs gibt)
		if (getstring("BSPINDELUNTERSTUETZUNG", "DLGDATA.KGTSYSTEM") == "true")	{
			setstring ("KGTDATEN.PM_BAUREIHE","DLGDATA","Antriebseinheit AGK");
			setstring ("KGTDATEN.PM_ANTRIEBSART","DLGDATA","Angetriebene Spindel");
		};
		setLabelsForceRatios();
		CheckSPU();
		
		
		// Berechnung aktualisieren, wenn Ergebnisse vorhanden
		
		if (getstring('SEARCHSELECTED','DLGDATA.KGTDATEN')!='') {
			TransferAxAlleMassen(false);
			berechneFAequiInKGTMassen();
			berechneFAequiInKGTKraefte();
			CKGTCalc	Calc("KGT");
			Calc.berechneKGTDaten();
			Calc.generiereWarnhinweise();
		};
		
	
		
		
	}
    
    switch (event)	{
    case "*.DLGDATA.DATEN.GEF_LEBENSDAUER_H.VALUE":
		berechneLebensdauer();
		CDialogBase	dlg;
		strRet = "<input></input>";
		strRet += dlg.updateCtrlValue("*.DLGDATA.DATEN.GEF_LEBENSDAUER.VALUE", getstring("GEF_LEBENSDAUER.VALUE", "DLGDATA.DATEN"));
		return strRet;
		break;
    case "*.DLGDATA.DATEN.GEF_LEBENSDAUER.VALUE":
		berechneLebensdauerH();
		CDialogBase	dlg;
		strRet = "<input></input>";
		strRet += dlg.updateCtrlValue("*.DLGDATA.DATEN.GEF_LEBENSDAUER_H.VALUE", getstring("GEF_LEBENSDAUER_H.VALUE", "DLGDATA.DATEN"));
		return strRet;
		break;
	case "*.DLGDATA.KGTDATEN.PM_BAUREIHE":
		baureiheCurrent=getstring ("KGTDATEN.PM_BAUREIHE_CURRENT","DLGDATA");
		baureiheNew=getstring ("KGTDATEN.PM_BAUREIHE","DLGDATA");
		if (baureiheNew=="Antriebseinheit AGK") {
			setstring ("KGTSYSTEM.FL2ROTATIONSLAGER","DLGDATA","true");
		};
		if ((baureiheCurrent=="Antriebseinheit AGK") and (baureiheNew=="Standard KGT")) {
			setstring ("KGTSYSTEM.FL2ROTATIONSLAGER","DLGDATA","false");
		};
		baureiheCurrent=baureiheNew; 
		setstring ("KGTDATEN.PM_BAUREIHE_CURRENT","DLGDATA",baureiheCurrent);
		return onComboChange(event);
		break;
	case "*.DLGDATA.KGTDATEN.PM_ANTRIEBSART":
	case "*.DLGDATA.KGTDATEN.PM_BR_MUTTER":
	case "*.DLGDATA.KGTDATEN.P_VORSPANNKLASSE_BEZ_C":
	case "*.DLGDATA.KGTDATEN.PM_KATEGORIE_VERTRIEB":
		return onComboChange(event);
		break;
	case "*.DLGDATA.KGTDATEN.PM_STEIGUNG":
		var strKonst = getstring("KEEPKONST", "DLGDATA.KGTDATEN");
		setstring("P.RAW", "DLGDATA.KGTSYSTEM", getstring("PM_STEIGUNG", "DLGDATA.KGTDATEN"));
/*		
		if (strKonst == "N_KONST")
			updateVInZyklus();
		else
*/		
			updateNInZyklus();
		return onComboChange(event);
		break;
	case "IDC_V_KONST":
	case "*.DLGDATA.KGTDATEN.VKONST_CHECK":
		return 2;
		break;
	case "IDC_N_KONST":
	case "*.DLGDATA.KGTDATEN.NKONST_CHECK":
		updateVInZyklus();
		return 2;
		break;		
	case "IDC_SEARCH_BUT":
		clearResultsKGT();
		ZTable	Tab("DLGDATA.KGTDATEN.SEARCHRESULT", "KGT", "SQL_KGTSEARCH");
		Tab.update(true);
		checkLebensdauer(Tab);
		selectFirstResultRow(Tab);
		setLabelsForceRatios();
		break;
	case "IDC_SEARCH_TAB":
		var	strSelRow = getdlgvar("IDC_SEARCH_TAB");
		setstring("SEARCHSELECTED", "DLGDATA.KGTDATEN", strSelRow);
		var nRow = (strSelRow == "") ? 0 : strSelRow.replace("IDC_SEARCH_TAB_", "");
		ZTable	Tab("DLGDATA.KGTDATEN.SEARCHRESULT", "KGT", "SQL_KGTSEARCH");
		Tab.goTop();
		Tab.go(nRow);
		Tab.instProduct("DLGDATA.KGTDATEN.KGT_STANDARD");
		setalias("KGT", "DLGDATA.KGTDATEN.KGT_STANDARD");
		CKGTCalc	Calc("KGT");
		var F_Aequi = Calc.berechneKGTDaten();
		Calc.generiereWarnhinweise();
		strRet = updateResultsClient(false);
		return strRet;
		break;
	case "*.DLGDATA.DATEN.GEF_LEBENSDAUER.UNIT":
		CDialogBase	dlg;
		// copyLebensdauerUnit();
		
		//var strRet = getstring("GEF_LEBENSDAUER.VALUE", "DLGDATA.DATEN");
		var strUnit = getstring("GEF_LEBENSDAUER.UNIT", "DLGDATA.DATEN");
		setstring('L_DIST.UNIT','DLGDATA.KGTDATEN_KRAEFTE',strUnit);
		var strRet = "<input></input>";
		strRet += dlg.updateCtrlValue("*.DLGDATA.DATEN.GEF_LEBENSDAUER.VALUE", getstring("GEF_LEBENSDAUER.VALUE", "DLGDATA.DATEN"));
		strRet += dlg.updateTableCellClient("IDC_L10_KM",formatstring(getdouble('L_DIST.VALUE','DLGDATA.KGTDATEN_KRAEFTE'),'%.1e'));
		strRet += dlg.updateTableCellClient("IDC_L10_UNIT","L<sub>10</sub> ["+translate(getstring('L_DIST.UNIT','DLGDATA.KGTDATEN_KRAEFTE'))+"]");
		return strRet;
		break;
	case "IDC_ENGLISCH_BUT":
		var bRet = changelanguage("EN"); // Muss hier umgeschaltet werden und nicht erst in Process.b um Warnhinweise korrekt zu generieren
		CKGTCalc	Calc("KGT");
		var F_Aequi = Calc.berechneKGTDaten();
		ZTable	Tab("DLGDATA.KGTDATEN.SEARCHRESULT", "KGT", "SQL_KGTSEARCH");
		if (Tab.size()>0) {
			Calc.generiereWarnhinweise();
		};
		break;
	case "IDC_DEU_BUT":
		var bRet = changelanguage("DE"); // s.o.
		CKGTCalc	Calc("KGT");
		var F_Aequi = Calc.berechneKGTDaten();
		ZTable	Tab("DLGDATA.KGTDATEN.SEARCHRESULT", "KGT", "SQL_KGTSEARCH");
		// Generieren, wenn 
		if (Tab.size()>0) {
			Calc.generiereWarnhinweise();
		};
		break;
		
		
	case "*.DLGDATA.KGTDATEN.SONDERMUTTER":
		if (getstring("SONDERMUTTER", "DLGDATA.KGTDATEN") == "true")	{
			setalias("KGT", "DLGDATA.KGTDATEN.KGT_SONDER");
			clearResultsKGT();
		}
		else	{
			setalias("KGT", "DLGDATA.KGTDATEN.KGT_STANDARD");
			delete ("DATEN_SONDERMUTTER","DLGDATA.KGTDATEN");
		}
			
		CKGTCalc	Calc("KGT");
		var F_Aequi = Calc.berechneKGTDaten();
		Calc.generiereWarnhinweise();
		if (getstring("SONDERMUTTER", "DLGDATA.KGTDATEN") == "true")	{
			strRet = updateWithSondermutter();
		} else	{
			strRet = onComboChange(event);
		}
		return strRet;
		break;
    }
}