#include "CDialogBase.b"
#include "4DMotionProfiler.b"
#include "DatenAllg.b"


calcImage() {
	var profiler = new MotionProfiler();
	profiler.disableKraft();
	profiler.disableMasse();
	profiler.disableTitle();
	profiler.initData();
	profiler.calcStartPosition(525);
	profiler.waitForImage();

};
updateMotionProfile() {
	calcImage();
	var strImg = GetAbsPath("/EKTemp/",true) + "\\"+getstring("STARTPOSIMAGEFILE","DLGDATA.4DMOTION");
	strImg=strImg.replace ("\\","/");
	var strResult=<<|<input></input><script>document.getElementById("IDC_4DMOTION_PROFILE").src="";document.getElementById("IDC_4DMOTION_PROFILE").src="$strImg$";</script>|;
    return strResult;	
};
setWinkelDefault() {
	// Lesen und Ruecksetzen als double fuerhrt dazu, da Leerstring auf 0 gesetzt werden
	var Alpha=getdouble ("10003.VALUE","DLGDATA.SYSTEM");
	var Beta=getdouble("10004.VALUE","DLGDATA.SYSTEM");
	var Gamma=getdouble("GAMMA","DLGDATA.WINKEL");
	
	setdouble ("10003.VALUE","DLGDATA.SYSTEM",Alpha);
	setdouble("10004.VALUE","DLGDATA.SYSTEM",Beta);
	setdouble("GAMMA","DLGDATA.WINKEL",Gamma);
	
	
};


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	strIntEvent = getstring("EVENT", "");
	switch (strIntEvent) {
		case "INIT":	
			calcImage();
			setWinkelDefault();
			break;
		case "IDC_CONTINUE_BUT":
			setWinkelDefault();
			break;
	}
	
	
	switch (event)	{
	case "IDC_ALPHA_EDIT":
	case "IDC_BETA_EDIT":
	case "IDC_GAMMA_EDIT":
		ClearResult();
		clearResultsKGT();
		return updateMotionProfile();
		break;
	};

}