#include "Allgemein.b"

initKraefte()
{

	nAnzKraefte = 12
	nAnzZyklen = 18
	nAnz = getsize("DLGDATA.KRAEFTE", "")

	strKoordUnit = getstring("S_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL")
	strAUnit	 = getstring("A_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL")
	# Kraefte initialisieren
	if (nAnz <= 0)
	{
		for i = 0 to (nAnzKraefte - 1)
		{
			strPath = "DLGDATA.KRAEFTE[" + i + "]"
			dRet = createobject(strPath, "KRAFT", 63)
			dRet = createobject(strPath, "KOORD", 63)
			setstring("KRAFT.PROFILEID", strPath, "11")
			setstring("KOORD.PROFILEID", strPath, "10001")
			setstring("KOORD.UNIT", strPath, "284")
			setstring("id", strPath, i)
			strText = translate(("IDC_KRAFT_K" + (i + 1) + "_LABEL"))
			setstring("text", strPath, strText)

			# Zyklus bezogene Daten pro Masse initialisieren
			for n = 0 to (nAnzZyklen - 1)
			{
				strZyklusDatenPath = strPath + ".ZYKLUSDATEN[" + n +"]"
				setstring("ACTIVE", strZyklusDatenPath, "false")
				dRet = createobject(strZyklusDatenPath, "A", 63)
				setstring("A.PROFILEID", strZyklusDatenPath, "10003")
			}
		}
		setalias("SELKRAFT", "DLGDATA.KRAEFTE[0]")
		setstring("SELKRAFTID", "DLGDATA", 0);
	}

	for i = 0 to (nAnzKraefte - 1)
	{
		strPath = "DLGDATA.KRAEFTE[" + i + "]"
		for n = 0 to (nAnzZyklen - 1)
		{
			strZyklusDatenPath = strPath + ".ZYKLUSDATEN[" + n +"]"
			setstring("A.UNIT", strZyklusDatenPath, strAUnit)
		}
	}
	strAlias = getalias("SELKRAFT")
	if (strAlias == "")
		setalias("SELKRAFT", "DLGDATA.KRAEFTE[0]")

	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")
	showMomente1(dFWAnz, dFSAnz);
}

// ----------------------------------------------------------------------------------
// Initialisierung der Items einer erweiterten Combobox fr die Kraefte
//
// Schreibt die Information zu den Items in die Variable "DLGDATA.KRAEFTE_COMBOITEMS"
// ----------------------------------------------------------------------------------
InitKraefteComboItems()
{
	//Combobox-Items neu zusammenstellen:
	nAnzKraefte = getsize("DLGDATA.KRAEFTE", "")
	strItems = "";
	strTrenn = "";
	strZeile = "";
	strKoordin = "";
	iItemWidht = 100;
	for i = 0 to (nAnzKraefte - 1)
	{
		strZeile += i;
		strZeile += "=";
		strZeile += translate(("IDC_KRAFT_K" + (i + 1) + "_LABEL"));
		if (getbool("ENHANCEDCOMBO", "DLGDATA"))		// Nur, wenn "erweiterte Combobox" eingestellt!
		{
			strZeile += "#";
			strZeile += getstring("KRAEFTE[" + i + "].NAME", "DLGDATA") + "#";
			strKoordin = getstring("KRAEFTE[" + i + "].KRAFT.X.VALUE", "DLGDATA");
			if (strKoordin!= "")
			{
				strZeile += "Fx: " + strKoordin;
				strZeile += getstring("KRAEFTE[" + i + "].KRAFT.UNIT.VALUE", "DLGDATA") + " ";
			}
			if(getbool("ISKGT", "DLGDATA") == false)		// Nur, wenn nicht KGT !
			{
				strZeile += "#"
				strKoordin = getstring("KRAEFTE[" + i + "].KRAFT.Y.VALUE", "DLGDATA");
				if (strKoordin!= "")
				{
					strZeile += "Fy: " + strKoordin;
					strZeile += getstring("KRAEFTE[" + i + "].KRAFT.UNIT.VALUE", "DLGDATA") + " ";
				}

				strZeile += "#"
				strKoordin = getstring("KRAEFTE[" + i + "].KRAFT.Z.VALUE", "DLGDATA");
				if (strKoordin!= "")
				{
					strZeile += "Fz: " + strKoordin;
					strZeile += getstring("KRAEFTE[" + i + "].KRAFT.UNIT.VALUE", "DLGDATA") + " ";
				}

				strZeile += "#"
				strKoordin = getstring("KRAEFTE[" + i + "].KOORD.X.VALUE", "DLGDATA");
				if (strKoordin != "")
				{
					strZeile += "x: " + strKoordin + getstring("KRAEFTE[" + i + "].KOORD.UNIT.VALUE", "DLGDATA");
				}
				strZeile += "#"
				strKoordin = getstring("KRAEFTE[" + i + "].KOORD.Y.VALUE", "DLGDATA");
				if (strKoordin != "")
				{
					strZeile += "y: " + strKoordin + getstring("KRAEFTE[" + i + "].KOORD.UNIT.VALUE", "DLGDATA");
				}
				strZeile += "#"
				strKoordin = getstring("KRAEFTE[" + i + "].KOORD.Z.VALUE", "DLGDATA");
				if (strKoordin != "")
				{
					strZeile += "z: " + strKoordin + getstring("KRAEFTE[" + i + "].KOORD.UNIT.VALUE", "DLGDATA");
				}
			}
		}
		strItems += strTrenn + strZeile;
		strZeile = "";
		strTrenn="|";
		iItemWidht = (iItemWidht > strZeile.length) ? iItemWidht : strZeile.length
	}
	setstring("KRAEFTE_COMBOITEMS", "DLGDATA", strItems);
}

