#include "CDialogBase.b"
#include "Kraefte.b"
#include "KraefteDynZyklus_Calc.b"
#include "DatenAllg.b"


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");	// Internes Event
	if (strIntEvent == "INIT")	{
		initKraefte();	
		InitKraefteComboItems();
		specialexec("DRAW_MP");
		specialexec("CALC_KRAEFTEKRAEFTE");
		KraefteDynZyklus_Calc();
	}

    CDialogBase	dlg;
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	switch (event)	{
	case "IDC_KRAFT_UNIT_COMBO_T1_1":
		strUnitID = getstring("KRAFT.UNIT", "SELKRAFT")
		nAnz = getsize("DLGDATA.KRAEFTE", "")
		for i = 0 to (nAnz - 1)
		{
			strPath = "DLGDATA.KRAEFTE[" + i + "]"
			setstring("KRAFT.UNIT", strPath, strUnitID)
		}
		InitKraefteComboItems();
		strResult = dlg.getDialogElementEx("IDD_KRAEFTEDYNZYKLUS", "IDC_KRAFTSCHWERPUNKT_EDIT_1_3|IDC_KRAFTSCHWERPUNKT_EDIT_1_4|IDC_KRAFTSCHWERPUNKT_EDIT_1_5|IDC_KRAEFTE_COMBO");
		strUnit = "[" + getstring("KRAFT.UNIT.VALUE", "SELKRAFT") + "]";
		strResult += dlg.updateTableCellClient("IDC_KRAFTSCHWERPUNKT_T1_2", strUnit);
		strResult += dlg.updateTableCellClient("IDC_KRAFTSCHWERPUNKT_T1_3", strUnit);
		return strResult;
		break;
	
	
	case "IDC_KRAFTSCHWERPUNKT_EDIT_1_3":
		clearResultsKGT(); // KGT Ergebnis nur bei Aenderungen in X Richtung loeschen
    case "IDC_KRAFTSCHWERPUNKT_EDIT_1_4":
	case "IDC_KRAFTSCHWERPUNKT_EDIT_1_5":
	case "IDC_KRAFT_KOORDINATEN_EDIT_1_7":
	case "IDC_KRAFT_KOORDINATEN_EDIT_1_8":
	case "IDC_KRAFT_KOORDINATEN_EDIT_1_9":			
		ClearResult();
	case "IDC_KRAFTNAME_EDIT":
		InitKraefteComboItems();
		strResult = dlg.getDialogElementEx("IDD_KRAEFTEDYNZYKLUS", "IDC_KRAEFTE_COMBO");
		return strResult;
		break;
	case "IDC_KRAFT_UNIT_COMBO_T1_5":
		strUnitID = getstring("KOORD.UNIT", "SELKRAFT")
		nAnz = getsize("DLGDATA.KRAEFTE", "")
		for i = 0 to (nAnz - 1)
		{
			strPath = "DLGDATA.KRAEFTE[" + i + "]"
			setstring("KOORD.UNIT", strPath, strUnitID)
		}
		InitKraefteComboItems();
		strResult = dlg.getDialogElementEx("IDD_KRAEFTEDYNZYKLUS", "IDC_KRAFT_KOORDINATEN_EDIT_1_7|IDC_KRAFT_KOORDINATEN_EDIT_1_8|IDC_KRAFT_KOORDINATEN_EDIT_1_9|IDC_KRAEFTE_COMBO");
		strUnit = "[" + getstring("KOORD.UNIT.VALUE", "SELKRAFT") + "]";
		strResult += dlg.updateTableCellClient("IDC_KRAFTKOORDINATEN_T1_6", strUnit);
		strResult += dlg.updateTableCellClient("IDC_KRAFTKOORDINATEN_T1_7", strUnit);
		return strResult;
		break;
	case "IDC_CALC_BUT":
		specialexec("CALC_KRAEFTEKRAEFTE");
		KraefteDynZyklus_Calc();
		
		strResult = dlg.getDialogElementEx("IDD_KRAEFTEDYNZYKLUS", "IDC_KRAFTBELASTUNG_TAB|IDC_MOMENTBELASTUNG_TAB");
		return strResult;
		break;
	case "IDC_KRAEFTE_COMBO":
		strSelKraftID = getstring("", "DLGDATA.SELKRAFTID")
		setalias("SELKRAFT", "DLGDATA.KRAEFTE[" + strSelKraftID + "]")
		InitKraefteComboItems();
		// kein return -> kompletter Refresh!
		break;
	case "IDC_ENGLISCH_BUT":
		var bRet = changelanguage("EN"); // Muss hier umgeschaltet werden und nicht erst in Process.b um Comboboxen korrekt zu befuellen
		InitKraefteComboItems();
		break;
	case "IDC_DEU_BUT":
		var bRet = changelanguage("DE"); // s.o.
		InitKraefteComboItems();
		break;
	case "IDC_CONTINUE_BUT":
		specialexec("CALC_KRAEFTEKRAEFTE");
		KraefteDynZyklus_Calc();
		break;
/*
	case "TRY_CONTINUE":
		specialexec("CALC_KRAEFTEKRAEFTE");
		KraefteDynZyklus_Calc();
		return "<input></input><script>ekSubmit('IDC_CONTINUE_BUT')</script>";
		
		if (CheckKraefteKoords()) {
			return "<input></input><script>ekSubmit('IDC_CONTINUE_BUT')</script>";
		} else {
			return "<input></input><script> alert ('"+translate("IDS_NO_FORCE_COORD")+"');</script>";
		};
		break;
		*/

	}
}