#include "Allgemein.b"

ResetAxAlleMassen()
{
	nAnzZyklen = getsize("DLGDATA.MASSENCALC", "")
	nAnzMassen = getsize("DLGDATA.MASSEN", "")
	for n = 0 to (nAnzZyklen - 1)	
	{
		for i = 0 to (nAnzMassen - 1)
		{
			setdouble("ZYKLUSDATEN[" + n + "].A.X.RAW", "DLGDATA.MASSEN[" + i + "]", 0)
		}
	}
}

TransferAxAlleMassen(bFromProfil)
{
	// nAnzZyklen = getsize("DLGDATA.MASSENCALC", "")
	var nAnzZyklen = getint("SIZE", "DLGDATA.DYNZYKLUS.PROFIL");
	var nAnzMassen = getsize("DLGDATA.MASSEN", "");
	if (bFromProfil)	{
		for (n = 0; n < nAnzZyklen; n++)	{
			dAx		= getdouble("AE.RAW", "DLGDATA.DYNZYKLUS.PROFIL." + n);
			strAx	= getstring("AE.RAW", "DLGDATA.DYNZYKLUS.PROFIL." + n);
			if (strAx != "")	{
				for (i = 0; i < nAnzMassen; i++)	{
					setdouble("ZYKLUSDATEN[" + n + "].A.X.RAW", "DLGDATA.MASSEN[" + i + "]", dAx);
				}
			}
			else	{
				for (i = 0; i < nAnzMassen; i++)	{
					setstring("ZYKLUSDATEN[" + n + "].A.X.RAW", "DLGDATA.MASSEN[" + i + "]", "");
				}
			}
		}
	}
	else	{
		for (n = 0; n < nAnzZyklen; n++)	{
			dAx		= getdouble("ZYKLUSDATEN[" + n + "].A.X.RAW", "SELMASSE");
			strAx	= getstring("ZYKLUSDATEN[" + n + "].A.X.RAW", "SELMASSE");
			if (strAx != "")	{
				for (i = 0; i < nAnzMassen; i++)	{
					setdouble("ZYKLUSDATEN[" + n + "].A.X.RAW", "DLGDATA.MASSEN[" + i + "]", dAx);
				}
				setdouble("AE.RAW", "DLGDATA.DYNZYKLUS.PROFIL." + n, dAx);
			}
			else	{
				for (i = 0; i < nAnzMassen; i++)	{
					setstring("ZYKLUSDATEN[" + n + "].A.X.RAW", "DLGDATA.MASSEN[" + i + "]", "");
				}
				setstring("AE.RAW", "DLGDATA.DYNZYKLUS.PROFIL." + n, "");
			}
		}
	}
}

initMassen()
{

	nAnzMassen = 9
	nAnzZyklen = 18
	nAnz = getsize("DLGDATA.MASSEN", "")
#	print nAnz
#	print getstring("KOORD.X.VALUE", "DLGDATA.MASSEN[0]")

	strKoordUnit = getstring("S_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL")
	strAUnit	 = getstring("A_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL")
	# Massen initialisieren
	if (nAnz <= 0)
	{
		for i = 0 to (nAnzMassen - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			dRet = createobject(strPath, "MASSE", 49)
			dRet = createobject(strPath, "KOORD", 63)
			setstring("MASSE.PROFILEID", strPath, "15")
			setstring("MASSE.RAW", strPath, "")
			setstring("KOORD.PROFILEID", strPath, "10001")
			setstring("KOORD.UNIT", strPath, "284")
			setstring("id", strPath, i)
			strText = translate(("IDC_MASSE_M" + (i + 1) + "_LABEL"))
			setstring("text", strPath, strText)

			# Zyklus bezogene Daten pro Masse initialisieren
			for n = 0 to (nAnzZyklen - 1)
			{
				strZyklusDatenPath = strPath + ".ZYKLUSDATEN[" + n +"]"
				setstring("ACTIVE", strZyklusDatenPath, "true")
				dRet = createobject(strZyklusDatenPath, "A", 63)
				setstring("A.PROFILEID", strZyklusDatenPath, "10003")
			}
		}
		setalias("SELMASSE", "DLGDATA.MASSEN[0]")

		setstring("SELMASSEID", "DLGDATA", 0);
	}

	for i = 0 to (nAnzMassen - 1)
	{
		strPath = "DLGDATA.MASSEN[" + i + "]"
#		setstring("KOORD.UNIT", strPath, strKoordUnit)
		for n = 0 to (nAnzZyklen - 1)
		{
			strZyklusDatenPath = strPath + ".ZYKLUSDATEN[" + n +"]"
			setstring("A.UNIT", strZyklusDatenPath, strAUnit)
		}
	}
	strAlias = getalias("SELMASSE")
	if (strAlias == "")
		setalias("SELMASSE", "DLGDATA.MASSEN[0]")

/*
	setstring("MX_VISIBLE_START", "DLGDATA.MASSEN_MOMENTE", "")
	setstring("MX_VISIBLE_END", "DLGDATA.MASSEN_MOMENTE", "")
	setstring("MY_VISIBLE_START", "DLGDATA.MASSEN_MOMENTE", "")
	setstring("MY_VISIBLE_END", "DLGDATA.MASSEN_MOMENTE", "")
	setstring("MZ_VISIBLE_START", "DLGDATA.MASSEN_MOMENTE", "")
	setstring("MZ_VISIBLE_END", "DLGDATA.MASSEN_MOMENTE", "")
*/	

	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")
/*
	if (dFWAnz == 2)
	{
		if (dFSAnz == 1)
		{
			setstring("MY_VISIBLE_START", "DLGDATA.MASSEN_MOMENTE", "<!--")
			setstring("MY_VISIBLE_END", "DLGDATA.MASSEN_MOMENTE", "-->")
			setstring("MZ_VISIBLE_START", "DLGDATA.MASSEN_MOMENTE", "<!--")
			setstring("MZ_VISIBLE_END", "DLGDATA.MASSEN_MOMENTE", "-->")
		}
		else
		{
			setstring("MX_VISIBLE_START", "DLGDATA.MASSEN_MOMENTE", "<!--")
			setstring("MX_VISIBLE_END", "DLGDATA.MASSEN_MOMENTE", "-->")
		}
	}

	if (dFWAnz <= 2)
		setstring("MOMENTE_VISIBLE", "DLGDATA.SYSTEM", "visible")
	else
		setstring("MOMENTE_VISIBLE", "DLGDATA.SYSTEM", "hidden")
*/		
		
	showMomente1(dFWAnz, dFSAnz);

	dXStep = 56
	nLeftMargin = getbool("ISKGT", "DLGDATA") ? 95 : 105;
	nMPSize = 18
	nWidth = dXStep * nMPSize + nLeftMargin + 1
#	setint("LEFTMARGIN","DLGDATA.MASSENDYNZYKLUS.GRAPH", getint("LEFTMARGIN","DLGDATA.DYNZYKLUS.GRAPH"));
	setint("LEFTMARGIN","DLGDATA.MASSENDYNZYKLUS.GRAPH", nLeftMargin);
	setint("TOPMARGIN", "DLGDATA.MASSENDYNZYKLUS.GRAPH", getint("TOPMARGIN","DLGDATA.DYNZYKLUS.GRAPH"));
	setint("BOTTOMMARGIN", "DLGDATA.MASSENDYNZYKLUS.GRAPH", getint("BOTTOMMARGIN","DLGDATA.DYNZYKLUS.GRAPH"));
#	setdouble("XSTEP", "DLGDATA.MASSENDYNZYKLUS.GRAPH", getdouble("XSTEP","DLGDATA.DYNZYKLUS.GRAPH"));
	setdouble("XSTEP", "DLGDATA.MASSENDYNZYKLUS.GRAPH", dXStep);

#	setint("WIDTH", "DLGDATA.MASSENDYNZYKLUS.GRAPH", getint("WIDTH","DLGDATA.DYNZYKLUS.GRAPH"));
	setint("WIDTH", "DLGDATA.MASSENDYNZYKLUS.GRAPH", nWidth);
	setint("HEIGHT", "DLGDATA.MASSENDYNZYKLUS.GRAPH", 115);
	setalias("MPGRAPH", "DLGDATA.MASSENDYNZYKLUS.GRAPH");

#	Testdaten
#	setstring("MASSE.VALUE","SELMASSE","10")
#	setstring("KOORD.X.VALUE","SELMASSE","1")
#	setstring("KOORD.Y.VALUE","SELMASSE","2")
#	setstring("KOORD.Z.VALUE","SELMASSE","3")
#	setint("ZYKLUSDATEN[0].ACTIVE","SELMASSE", 1)
#	setstring("ZYKLUSDATEN[0].A.Y.VALUE","SELMASSE", "4")
#	setstring("ZYKLUSDATEN[0].A.Z.VALUE","SELMASSE", "5")
}

// ----------------------------------------------------------------------------------
// Initialisierung der Items einer erweiterten Combobox fr die Massen
//
// Schreibt die Information zu den Items in die Variable "DLGDATA.MASSEN_COMBOITEMS"
// ----------------------------------------------------------------------------------
InitMassenComboItems()
{
	//Combobox-Items neu zusammenstellen:
	nAnzMassen = getsize("DLGDATA.MASSEN", "")
	strItems = "";
	strTrenn = "";
	strZeile = "";
	strKoordin = "";
	iItemWidht = 100;
	for i = 0 to (nAnzMassen - 1)
	{
		strZeile += i;
		strZeile += "=";
		strZeile += translate(("IDC_MASSE_M" + (i + 1) + "_LABEL")); 
		if (getbool("ENHANCEDCOMBO", "DLGDATA"))		// Nur, wenn "erweiterte Combobox" eingestellt!
		{
			strZeile += "#";
			strZeile += getstring("MASSEN[" + i + "].NAME", "DLGDATA") + "#";
			strZeile += getstring("MASSEN[" + i + "].MASSE", "DLGDATA");
			if (getstring("MASSEN[" + i + "].MASSE", "DLGDATA")!= "")
				strZeile += getstring("MASSEN[" + i + "].MASSE.UNIT.VALUE", "DLGDATA") + " ";
			if(getbool("ISKGT", "DLGDATA") == false)		// Nur, wenn nicht KGT !
			{
				strZeile += "#"
				strKoordin = getstring("MASSEN[" + i + "].KOORD.X.VALUE", "DLGDATA");
				if (strKoordin != "")
				{
					strZeile += "x: " + strKoordin + getstring("MASSEN[" + i + "].KOORD.UNIT.VALUE", "DLGDATA");
				}
				strZeile += "#"
				strKoordin = getstring("MASSEN[" + i + "].KOORD.Y.VALUE", "DLGDATA");
				if (strKoordin != "")
				{
					strZeile += "y: " + strKoordin + getstring("MASSEN[" + i + "].KOORD.UNIT.VALUE", "DLGDATA");
				}
				strZeile += "#"
				strKoordin = getstring("MASSEN[" + i + "].KOORD.Z.VALUE", "DLGDATA");
				if (strKoordin != "")
				{
					strZeile += "z: " + strKoordin + getstring("MASSEN[" + i + "].KOORD.UNIT.VALUE", "DLGDATA");
				}
			}
		}
		strItems += strTrenn + strZeile;
		strZeile = "";
		strTrenn="|";
		iItemWidht = (iItemWidht > strZeile.length) ? iItemWidht : strZeile.length
	}
	setstring("MASSEN_COMBOITEMS", "DLGDATA", strItems);
	setint("MASSEN_COMBOITEMS.WIDTH", "DLGDATA", iItemWidht*6);
	setint("MASSEN_COMBOITEMS.HEIGHT", "DLGDATA", nAnzMassen*12);
}
// ----------------------------------------------------------------------------------
// Prueft, ob fuer alle definierte Massen (d.h. Wert fuer Gewicht eingetragen)
// auch koorinaten eingetragen sind
//
// ----------------------------------------------------------------------------------
function CheckMassenKoords()
{
	
	nAnzMassen = getsize("DLGDATA.MASSEN", "")
	result=true;
	for i = 0 to (nAnzMassen - 1)
	{
		strPath="DLGDATA.MASSEN[" + i + "]";
		Masse=getstring ("MASSE",strPath);
		if (Masse!="") {
			xKoord=getstring ("KOORD.X.VALUE",strPath);
			yKoord=getstring ("KOORD.Y.VALUE",strPath);
			zKoord=getstring ("KOORD.Z.VALUE",strPath);
			if (xKoord=="" || yKoord=="" || zKoord=="") {
				result=false; // Koordinaten unvollstaendig
			};
		}
	};
	return result;
}
