#include "CDialogBase.b"
#include "Massen.b"
#include "MassenDynZyklus_Calc.b"
#include "DatenAllg.b"


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");	// Internes Event
	if (strIntEvent == "INIT")	{
		initMassen();	
		InitMassenComboItems();
		specialexec("DRAW_MP");
		specialexec("CALC_MASSENKRAEFTE");
		TransferAxAlleMassen(true);
		MassenDynZyklus_Calc();
	}
	
	var dTest = getdouble("KOORD.X.BASE","SELMASSE");
	CheckMassenKoords();

    CDialogBase	dlg;
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	switch (event)	{
	case "IDC_MASSE_UNIT_COMBO":
		strUnitID = getstring("MASSE.UNIT", "SELMASSE")
		nAnz = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnz - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			setstring("MASSE.UNIT", strPath, strUnitID)
		}
		InitMassenComboItems();
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZYKLUS", "IDC_MASSENSCHWERPUNKT_EDIT_1_2|IDC_MASSEN_COMBO");
		return strResult;
		break;
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_2":
		clearResultsKGT(); // KGT Ergebnisse nur bei Massenaenderungen ruecksetzen
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_3":
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_4":
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_5":
		ClearResult();
	case "IDC_MASSENNAME_EDIT":
		InitMassenComboItems();
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZYKLUS", "IDC_MASSEN_COMBO");
		return strResult;
		break;
	case "IDC_MASSENSCHWERPUNKT_T1_1_UNIT_COMBO":
		strUnitID = getstring("KOORD.UNIT", "SELMASSE")
		nAnzMassen = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnzMassen - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			setstring("KOORD.UNIT", strPath, strUnitID)
		}
		InitMassenComboItems();
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZYKLUS", "IDC_MASSENSCHWERPUNKT_EDIT_1_3|IDC_MASSENSCHWERPUNKT_EDIT_1_4|IDC_MASSENSCHWERPUNKT_EDIT_1_5|IDC_MASSEN_COMBO");
		strUnit = "[" + getstring("KOORD.UNIT.VALUE", "SELMASSE") + "]";
		strResult += dlg.updateTableCellClient("IDC_MASSENSCHWERPUNKT_T1_2", strUnit);
		strResult += dlg.updateTableCellClient("IDC_MASSENSCHWERPUNKT_T1_3", strUnit);
		return strResult;
		break;
	case "IDC_MASSENDYN_3_0_COMBO":
		strUnitID = getstring("A_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL")
		nAnzMassen = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnzMassen - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			nAnzZyklen = getsize(strPath + ".ZYKLUSDATEN", "")
			for n = 0 to (nAnzZyklen - 1)
			{
				strZyklusDatenPath = strPath + ".ZYKLUSDATEN[" + n +"]"
				setstring("A.UNIT", strZyklusDatenPath, strUnitID)
			}
		}
		strElementIds = "";
		for (n = 1; n <= nAnzZyklen; ++n)	{
			strElementIds += "IDC_MASSENDYN_3_" + n + "_EDIT|";
			strElementIds += "IDC_MASSENDYN_4_" + n + "_EDIT|";
		}
		strElementIds.trimRight("|");
		//strElementIds += "IDC_MASSENDYN_BESCHLEUNIGUNG_Y_UNIT|IDC_MASSENDYN_BESCHLEUNIGUNG_Z_UNIT";
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZYKLUS", strElementIds);
		strUnit = "[" + getstring("A_PROTOTYPE.UNIT.VALUE", "DLGDATA.DYNZYKLUS.PROFIL") + "]";
		strUnit = strUnit.replace("&amp;", "&");
		strResult += dlg.updateTableCellClient("IDC_MASSENDYN_BESCHLEUNIGUNG_Y_UNIT", strUnit);
		strResult += dlg.updateTableCellClient("IDC_MASSENDYN_BESCHLEUNIGUNG_Z_UNIT", strUnit);
		strResult += dlg.updateTableCellClient("IDC_MASSENDYN_BESCHLEUNIGUNG_Z2_UNIT", strUnit);
		return strResult;
		break;
	case "IDC_CALC_BUT":
		TransferAxAlleMassen(true);
		specialexec("CALC_MASSENKRAEFTE");
		MassenDynZyklus_Calc();
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZYKLUS", "IDC_KRAFTBELASTUNG_TAB|IDC_MOMENTBELASTUNG_TAB");
		return strResult;
		break;
	case "IDC_MASSEN_COMBO":
		strSelMasseID = getstring("", "DLGDATA.SELMASSEID")
		setalias("SELMASSE", "DLGDATA.MASSEN[" + strSelMasseID + "]")
		TransferAxAlleMassen(true);
		InitMassenComboItems();
		// kein return -> kompletter Refresh!
		break;
	case "IDC_ENGLISCH_BUT":
		var bRet = changelanguage("EN"); // Muss hier umgeschaltet werden und nicht erst in Process.b um Comboboxen korrekt zu befuellen
		InitMassenComboItems();
		break;
	case "IDC_DEU_BUT":
		var bRet = changelanguage("DE"); // s.o.
		InitMassenComboItems();
		break;
	};
	
}