// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.10.14 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # Initialize DynStrecken-Template (Message,...)
// # ============================================================================

function	InitDynStrecken()
{
	InitFocus("INPUT_FOCUS");
	hiliteNavigation();
	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "" || document.getElementById('BMSG_SYSTEM_CHANGED').value == "" )	{
	}
	if (document.getElementById('*.DLGDATA.DYNZYKLUS.BMSG_HUB_RANGE').value == "true")	{
		document.getElementById('*.DLGDATA.DYNZYKLUS.BMSG_HUB_RANGE').value = "false";
		alert(document.getElementById('IDC_MSG_HUB_RANGE').value);
	}

}

function	EKCheckEditAndSubmitDynStrecken(obj, bCheckSumQs, bAjax)
{
	var objTable = document.getElementById('IDC_STRECKEN_TAB_TABLE');
	if (objTable == null)	{
		alert('Error: Table not found');
		return;
	}
//	alert(objTable.rows.length);

	strMsgBothValuesSameSign= document.getElementById('IDC_VALUESSAMESIGN_MSG').value;
	strMsgBothValuesNotNull	= document.getElementById('IDC_VALUESNOTNULL_MSG').value;
	var dSMin = document.getElementById('IDC_SMIN').value;
	var objUnitCombo = document.isycat['IDC_STRECKEN_STRECKE_UNIT_COMBO'];
	var strSUnit = objUnitCombo.options[objUnitCombo.selectedIndex].text;
	var strMsgValueReplace = dSMin + " " + strSUnit;
	dSMin = dSMin.replace(',', '.');
	dSMin = parseFloat(dSMin);
	if (document.getElementById('IDC_STRECKEN_EDIT_1_1').value == "" || document.getElementById('IDC_STRECKEN_EDIT_1_2').value == "" )	{
		alert (strMsgBothValuesNotNull);
		var objEdit1 = document.getElementById('IDC_STRECKEN_EDIT_1_1');
		objEdit1.focus();
		return;
	}
	var dSumQs = 0.;
	for (i = 1; i < objTable.rows.length; ++i)	{
		var objEdit1 = document.getElementById('IDC_STRECKEN_EDIT_' + i + '_1');
		var Value1 = objEdit1.value;
		if (Value1 == "")
			continue;
		Value1 = Value1.replace(',', '.');
		Value1 = parseFloat(Value1);

		if (Math.abs(Value1) < dSMin)	{
			var strMsg = document.getElementById('IDC_SMIN_MSG').value;
			strMsg = strMsg.replace("1 mm", strMsgValueReplace);
			alert(strMsg);
			return;
		}
/*
		if (Value1 < 0. && strMsgPosValues != "")	{
			alert(strMsgPosValues + ' [' +objTable.rows(i).cells(0).innerText + ']');
			objEdit1.focus();
			return;
		}
*/
		var objEdit2 = document.getElementById('IDC_STRECKEN_EDIT_' + i + '_2');
		var Value2 = objEdit2.value;
		if (Value2 == "")
			continue;
		Value2 = Value2.replace(',', '.');
		Value2 = parseFloat(Value2);
		if (Value1*Value2 < 0. && strMsgBothValuesSameSign != "")	{
			alert(strMsgBothValuesSameSign + ' [' +objTable.rows(i).cells(0).innerText + ']');
			objEdit2.focus();
			return;
		}

		if (bCheckSumQs == true)	{
			var Value3 = document.getElementById("IDC_STRECKEN_LABEL" + i + "_4").innerHTML;
			if (Value3 != "")	{
				Value3.replace(",",".");
				Value3 = parseFloat(Value3);
				dSumQs += Value3;
			}

		}

		if (strMsgBothValuesNotNull != "")	{
			if (Value1 == 0. && Value2 != 0.)	{
				alert(strMsgBothValuesNotNull);
				objEdit1.focus();
				return;
			}
			else if (Value1 != 0. && Value2 == 0.)	{
//				alert(Value1);
				alert(strMsgBothValuesNotNull);
				objEdit2.focus();
				return;
			}
		}
	}
	var dEps = 0.5
	if (bCheckSumQs == true && (dSumQs < (100 - dEps) || dSumQs > (100 + dEps)))	{
		strMsgTotalValueExceeds100	= document.getElementById('IDC_SUMME_QS_MSG').value;
		alert(strMsgTotalValueExceeds100);
		return;
	}
	// ekSubmit(obj);
	if (bAjax)
	    ekSubmitDialog(obj.id);
	else
	    ekSubmit(obj);
}

function	ResetTableContent(nRow)
{
	var objTable = document.getElementById('IDC_STRECKEN_TAB_TABLE');
	for (i = nRow; i < objTable.rows.length; ++i)	{
		document.getElementById('IDC_STRECKEN_EDIT_' + i + '_1').value = "";
		document.getElementById('IDC_STRECKEN_EDIT_' + i + '_2').value = "";
		document.getElementById('IDC_STRECKEN_EDIT_' + i + '_N').value = "";
		document.getElementById('IDC_STRECKEN_LABEL' + i + '_3').innerHTML = "&nbsp;";
		document.getElementById('IDC_STRECKEN_LABEL' + i + '_4').innerHTML = "&nbsp;";
	}
}

function	EKEditSubmit(strEvent, strCtrlID)
{
	// document.getElementById("dontsubmit").value = "1";
	// document.getElementById("dontsubmit").value = "0";
	var objCtrl = document.getElementById(strCtrlID);
	var strValue = objCtrl.value + "";
	strValue = strValue.replace(".", "");
	strValue = strValue.replace(",", "");
	strValue = strValue.replace("-", "");
	var Number = /\D/;
	if (strValue.match(Number) != null)	{
		objCtrl.focus();
		alert(document.getElementById("IDC_NAN_MSG").value);
		objCtrl.focus();
		//document.getElementById("dontsubmit").value = "0";
		return true;
	}
	EKSingleSubmit(strEvent, strCtrlID);
}
