// ##############################################################################
// #													
// # Author:		D. Weber
// # Copyright:		Plan Software GmbH, Saarbrcken
// # 
// # Last Change:	2004.12.20 <DW>
// #													
// ##############################################################################




// # ============================================================================
// # operations for all Masse-Templates (Positioning,...)
// # ============================================================================

var adXPosMassX = new Array(240, 150, 50);
var adYPosMassX = new Array(130, 72, 30);
var adXPosMassY = new Array(50, 267, 470);
var adYPosMassY = new Array(140, 71, 30);
// var	adXPosMassY2 = new Array(40, 145, 233, 318, 420);
var	adXPosMassY2 = new Array(50, 50, 267, 470, 470);
var MasseYOffset_Y = 0; // Vom Script gesetzer Offset um Massengrafiken fuer LF anders zu positionieren
var MasseXOffset_Y = 0; 


function	InitMassen()
{
	MasseXOffset_Y=ParseFloatEx(document.getElementById('IDC_MASSEX_OFFSET_Y').value, true);
	MasseYOffset_Y=ParseFloatEx(document.getElementById('IDC_MASSEY_OFFSET_Y').value, true);
	UpdateImagesMassen();
	hiliteNavigation();

	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	if (document.getElementById('*.DLGDATA.BMSG_MASS_KOORD_INCOMPLETE').value == "true")	{
		document.getElementById('*.DLGDATA.BMSG_MASS_KOORD_INCOMPLETE').value = "false";
		alert(document.getElementById('IDC_MSG_MASS_KOORD_INCOMPLETE').value);
	}
	

}

function	InitKGTMassen()
{
	hiliteNavigation();

	if (document.getElementById('BMSG_SYSTEM_CHANGED').value == "true")	{
		document.getElementById('BMSG_SYSTEM_CHANGED').value = "false";
		alert(document.getElementById('IDC_MSG_SYSTEM_CHANGED').value);
	}
	if (document.getElementById('*.DLGDATA.WINKEL.BMSG_HORIZONTAL_ONLY').value == "true")	{
		document.getElementById('*.DLGDATA.WINKEL.BMSG_HORIZONTAL_ONLY').value = "false";
		alert(document.getElementById('IDC_MSG_HORIZONTAL_ONLY').value);
	}
}

function	UpdateImagesMassen(objEditCtrl)
{
	PositionMassX();
	PositionMassY();
}

function	PositionMassX()
{
	var dMass = ParseFloatEx(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_2').value);
	var objImgMass	= document.getElementById('IDC_IMAGE_MASSX');
	if (dMass <= 0.)	{
		objImgMass.style.visibility = 'hidden';
		return;
	}
	var dY	= ParseFloatEx(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_4').value);
	var dZ	= ParseFloatEx(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_5').value);
	var dCharactLengthY = 0.;	// parseFloat(document.getElementById('IDC_CHARACTLENGTH_Y').value) / 2.;
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_X');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);
	if (dY > dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[2];
	}
	else if (dY < -dCharactLengthY)	{
		dXPos = nLeft + adXPosMassX[0];
	}
	else	{
		dXPos = nLeft + adXPosMassX[1];
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassX[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassX[0];
	}
	else	{
		dYPos = nTop + adYPosMassX[1];
	}
//	alert(objSystemImg.style.zIndex);
//	alert(objImgMass.style.zIndex);
	objImgMass.style.zIndex = objSystemImg.style.zIndex + 1;
	objImgMass.style.top = dYPos+MasseXOffset_Y;
	objImgMass.style.left = dXPos;
	objImgMass.style.position = 'absolute';
	objImgMass.style.visibility = 'visible';
}

function	PositionMassY()
{
	var objImgMass	= document.getElementById('IDC_IMAGE_MASSY');
	var dMass = ParseFloatEx(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_2').value);
	if (dMass <= 0.)	{
		objImgMass.style.visibility = 'hidden';
		return;
	}
	var dX	= ParseFloatEx(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_3').value);
	var dZ	= ParseFloatEx(document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_5').value);
	var dCharactLengthX = 0.;	// parseFloat(document.getElementById('IDC_CHARACTLENGTH_X').value) / 2.;
	var nFWAnz = document.getElementById('IDC_FWANZ').value;
	var objSystemImg= document.getElementById('IDC_MASSENDYN_IMG_Y');
	var nLeft = parseInt(objSystemImg.style.left);
	var nTop = parseInt(objSystemImg.style.top);

	if (nFWAnz == 8)	{
		var dCharactLengthX2 = 0.;	// parseFloat(document.getElementById('IDC_CHARACTLENGTH_X2').value) / 2.;
		if (dX < -dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[0];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[1];
		}
		else if (dX > dCharactLengthX2)	{
			dXPos = nLeft + adXPosMassY2[4];
		}
		else if (dX > dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY2[3];
		}
		else	{
			dXPos = nLeft + adXPosMassY2[2];
		}
	}
	else	{
		if (dX > dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[2];
		}
		else if (dX < -dCharactLengthX)	{
			dXPos = nLeft + adXPosMassY[0];
		}
		else	{
			dXPos = nLeft + adXPosMassY[1];
		}
	}
	if (dZ > 0)	{
		dYPos = nTop + adYPosMassY[2];
	}
	else if (dZ < 0)	{
		dYPos = nTop + adYPosMassY[0];
	}
	else	{
		dYPos = nTop + adYPosMassY[1];
	}
	objImgMass.style.zIndex = objSystemImg.style.zIndex + 1;
	objImgMass.style.top = dYPos+MasseYOffset_Y;
	objImgMass.style.left = dXPos;
	objImgMass.style.position = 'absolute';
	objImgMass.style.visibility = 'visible';
}

/*
function	ParseFloatEx(Value)
{
	Value		= Value.replace(',', '.');
	return parseFloat(Value);
}
*/

function	UpdateKoordMassen(objEditMasse)
{
	var objKoordX = document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_3');
	var objKoordY = document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_4');
	var objKoordZ = document.getElementById('IDC_MASSENSCHWERPUNKT_EDIT_1_5');
	if (objEditMasse.value == "")	{
		objKoordX.value = "";
		objKoordY.value = "";
		objKoordZ.value = "";
	}
	/*
	else	{
		if (objKoordX.value == "")
			objKoordX.value = 0.;
		if (objKoordY.value == "")
			objKoordY.value = 0.;
		if (objKoordZ.value == "")
			objKoordZ.value = 0.;
	}
	*/
}