#include "CDialogBase.b"
#include "Allgemein.b"
#include "4DMotionProfiler.b"





//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");
	if (strIntEvent == "INIT")	{
		setbool ("ANIMATIONRUNNING","DLGDATA.4DMOTION",true);
	}
		
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	CDialogBase	dlg;
	var strResult="";
	switch (event)	{
	case "IDC_4DPROFILER":
		var srcDlg=getstring ("SRCDLG","DLGDATA.4DMOTION");
	    var profiler=new MotionProfiler();
		profiler.disableKoordSys();
		switch (srcDlg) {
			case "IDD_KGTMASSENDYNZEITANTEILE":
			case "IDD_KGTMASSENDYNSTRECKEN":
			case "IDD_KGTMASSENDYNZYKLUS":
				profiler.disableKraft();
				break;
			case "IDD_KGTKRAEFTEDYNZEITANTEILE":
			case "IDD_KGTKRAEFTEDYNZYKLUS":
			case "IDD_KGTKRAEFTEDYNSTRECKEN":
				profiler.disableMasse();
				break;
			default:
				profiler.disableMasse();
				profiler.disableKraft();
				break;
		};
		// Darzustellende Elemente waehlen
		
		profiler.initData();
		if (profiler.checkHub()) {
			setstring("PREVENTHUBWARNUNG","DLGDATA.4DMOTION","true");
		} else {
			setstring("PREVENTHUBWARNUNG","DLGDATA.4DMOTION","false5	5");
		};
		
		profiler.calc4DProfile(530);
		profiler.waitForImage();
		break;
	case "IDC_IMG_FORWARD":
		strResult=<<|<input></input><script>Animator.nextImage();</script>|;
		return strResult;
		break;
	case "IDC_IMG_BACK":
		strResult=<<|<input></input><script>Animator.prevImage();</script>|;
		return strResult;
		break;
	case "IDC_IMG_ANIMATION":
		var ImgPath = GetAbsPath("/EKImage/",true) + "\\";
	     if (getbool ("ANIMATIONRUNNING","DLGDATA.4DMOTION")) {
			setbool ("ANIMATIONRUNNING","DLGDATA.4DMOTION",false);
			setstring ("PLAYBUTTONIMAGE","DLGDATA.4DMOTION","img_play.png");
			strResult=dlg.getDialogElementEx("IDD_4DPROFILE", "IDC_IMG_ANIMATION");
			strResult+=<<|<script>Animator.stop();</script>|;
		 } else {
			setbool ("ANIMATIONRUNNING","DLGDATA.4DMOTION",true);
			setstring ("PLAYBUTTONIMAGE","DLGDATA.4DMOTION","img_pause.png");
			strResult=dlg.getDialogElementEx("IDD_4DPROFILE", "IDC_IMG_ANIMATION");
			strResult+=<<|<script>Animator.start();</script>|;
		 };
		 return strResult
	}

}