##############################################################################
#                                                   
# Author:       D. Weber
# Copyright:    Plan Software GmbH, Saarbrcken
#                           
##############################################################################

class	CDialogBase
{
	var m_Path;
	var m_KompID;

	CDialogBase()
	{
	}

	getDialogElement(dlgId, elementIds)
	{
		templateFile=getstring("CATALOG.TEMPLATES.DIR","ROOT")+dlgId+".xml";
		path="EASYGUITRANSFORM";
		
		setstring("DLG_ID", path, dlgId);
		setstring("INFILE", path, templateFile);
		setstring("RESULT_TYPE", path, "HTML");
		setstring("ALIAS_METHOD", path, "FILE");
		
		elementIds+="|END"; id="";
		logtraceln("elementIds="+elementIds);
		while( split(elementIds, id, elementIds, "|") )
		{	
			//logtraceln("BUILD_ONLY"~id);
			setint("BUILD_ONLY"~id, path, 1);
		}
		
		return scriptexec("EASYGUITRANSFORM");
	}

	getDialogElementEx(dlgId, elementIds)
	{
		strInternalTransform =getstring("CATALOG.UI.INTERNALTRANSFORM","ROOT");
		setstring("CATALOG.UI.INTERNALTRANSFORM","ROOT", "true");

		strResult = getDialogElement(dlgId, elementIds);
		strResult = readfile(strResult);
		setstring("CATALOG.UI.INTERNALTRANSFORM","ROOT", strInternalTransform);

		return strResult;
	}
	
	updateTableCellClient(strCellId, strValue)
	{
		strRet =<<|<SCRIPT>
				var objCell = document.getElementById('$strCellId$');
				if (objCell != null)	{
					objCell.innerHTML ='$strValue$';
				}
				</SCRIPT>|;
//					objCell.innerText ='$strValue$';
//					objRow.cells[objCell.cellIndex].innerHTML='$strValue$';
		return strRet;
	}
	
	updateTableCellClient(strCellId, strValue, strWnd)
	{
		strRet =<<|<SCRIPT>
				var objCell = $strWnd$.document.getElementById('$strCellId$');
				if (objCell != null)	{
					objCell.innerHTML ='$strValue$';
				}
				</SCRIPT>|;
		return strRet;
	}
	
	updateTableCellClient2(strRowId, strColIndex, strValue)
	{
		strRet =<<|<SCRIPT>
				var objRow = document.getElementById('$strRowId$');
				if (objRow != null)	{
					objRow.cells[$strColIndex$].innerHTML ='$strValue$';
				}
				</SCRIPT>|;
		return strRet;
	}
	
	updateHTML(strCtrlID, strValue)
	{
		strRet =<<|<SCRIPT>
				var objCtrl = document.getElementById('$strCtrlID$');
				if (objCtrl != null)	{
					objCtrl.innerHTML ='$strValue$';
				}
				</SCRIPT>|;
//					objCell.innerText ='$strValue$';
//					objRow.cells[objCell.cellIndex].innerHTML='$strValue$';
		return strRet;
	}
	
	updateImage(strImgID, strImgSrc)
	{
	strRet =<<|<input></input><SCRIPT>
	var objImg		= document.getElementById('$strImgID$');
    if (objImg != null)
		objImg.src = '$strImgSrc$';
	</SCRIPT>|;
	return strRet;
	}
	
	setComboItems(strComboID, strItemlist)
	{
		strRet =<<|<input></input><SCRIPT>
					dialog["$strComboID$"].setNewItemList("$strItemlist$");
				</SCRIPT>|;
		return strRet;
	}
	
	setComboItemsAndValue(strComboID, strItemlist, strValue)
	{
		strRet =<<|<input></input><SCRIPT>
					dialog["$strComboID$"].setNewItemList("$strItemlist$");
					dialog["$strComboID$"].setValue("$strValue$");
				</SCRIPT>|;
		return strRet;
	}
	
	updateCtrlValue(strCtrlId, strValue)
	{
		strRet =<<|<SCRIPT>
					dialog["$strCtrlId$"].setValue("$strValue$");
				</SCRIPT>|;
		return strRet;
	}
}

