#include "CDialogBase.b"
#include "DatenAllg.b"
#include "Daten_BerechneAlles.b"
#include "Daten_Calc.b"

{
	strIntEvent = getstring("EVENT", "");	// Internes Event
	CDialogBase	dlg;
	event		= getstring("EKSUBMITEVENT","");		// Event aus der aktuellen Maske
	
	switch (strIntEvent) {
	case "INIT":	
		initDaten();	
		break;
	case "IDC_SEARCH_BUT":
	case "IDC_SEARCH_TAB":
		event=strIntEvent;
		break;
	
	}
	
	
    
	strResult = "";
	switch (event)	{
	case "IDC_SEARCH_BUT":
		berechneAllesDaten();
		specialexec("SEARCH");
		selectDatenTable();
		specialexec("CALC_GESAMTBELASTUNG");
		calcDaten();
		
		strResult = dlg.getDialogElementEx("IDD_DATEN", "IDC_SEARCH_TAB");
		var newwarnhinweis=getbool ("NEWWARNHINWEIS","DLGDATA.DATEN");
		var automatictest = getstring("CATALOG.AUTOMATICTEST","ROOT");		// -mw- Popup-Meldungen nicht hochfahren, wenn automatisierte Tests laufen
		/* -mw- 2012-10-28 wg Testautomatisierung */
		if (newwarnhinweis && (automatictest != "true")) {
			var script='<script>alert ("'+translate("IDC_WARNHINWEISE_BEACHTEN")+'")</script>';
			strResult +=  script;
		};
		
		return strResult;
		break;
	case "IDC_SEARCH_TAB":
		selectDatenTable();
		specialexec("CALC_GESAMTBELASTUNG");
		calcDaten();
		// strResult = "<input></input>" + dlg.updateTableCellClient("IDC_HOEHENVERSATZ", getstring("10026.VALUE", "DLGDATA.DATEN.WAGEN")); // funzt nicht, weiss der Geier warum ?!(grrrrgrrrr)
		strResult += dlg.getDialogElementEx("IDD_DATEN", "IDC_KRAEFTE_TAB|IDC_MOMENTBELASTUNG_TAB|IDC_MAXBELASTUNGEN_TAB|IDC_LEBENSDAUER_TAB|IDC_WARNHINWIESE_TAB|IDC_HOEHENVERSATZ_TAB");
		var newwarnhinweis=getbool ("NEWWARNHINWEIS","DLGDATA.DATEN");
		var automatictest = getstring("CATALOG.AUTOMATICTEST","ROOT");		// -mw- Popup-Meldungen nicht hochfahren, wenn automatisierte Tests laufen
		/* -mw- 2012-10-28 wg Testautomatisierung */
		if (newwarnhinweis && (automatictest != "true")) {
			var script='<script>alert ("'+translate("IDC_WARNHINWEISE_BEACHTEN")+'")</script>';
			strResult +=  script;
		};

		return strResult;
		break;
	case "IDC_WAGENTYP_COMBO":
		strSelBauartID = getstring("", "DLGDATA.DATEN.SELBAUARTID");
		for i = 0 to (getsize("DLGDATA.DATEN.BAUARTEN","") - 1)
		{
			if (getstring("EKSR_IDENT", "DLGDATA.DATEN.BAUARTEN[" + i + "]") == strSelBauartID)
			{
				setalias("SELBAUART", "DLGDATA.DATEN.BAUARTEN[" + i + "]");
			}
		}
		ClearResult();
		strElementIds = "IDC_VORSPANNUNG_COMBO|IDC_GENAUIGKEITSKLASSE_COMBO|IDC_AUSFUEHRUNG_COMBO|IDC_SEARCH_TAB|IDC_KRAEFTE_TAB|IDC_MOMENTBELASTUNG_TAB|IDC_MAXBELASTUNGEN_TAB|IDC_LEBENSDAUER_TAB|IDC_WARNHINWIESE_TAB|IDC_HOEHENVERSATZ_TAB";
		strResult += dlg.getDialogElementEx("IDD_DATEN", strElementIds);
		return strResult;
		break;
	case "IDC_VORSPANNUNG_COMBO":
		strSelBauartID = getstring("", "DLGDATA.DATEN.SELBAUARTID");
		for i = 0 to (getsize("DLGDATA.DATEN.BAUARTEN","") - 1)
		{
			if (getstring("EKSR_IDENT", "DLGDATA.DATEN.BAUARTEN[" + i + "]") == strSelBauartID)
			{
				setalias("SELBAUART", "DLGDATA.DATEN.BAUARTEN[" + i + "]");
			}
		}
		ClearResult();
		strElementIds = "IDC_GENAUIGKEITSKLASSE_COMBO|IDC_AUSFUEHRUNG_COMBO|IDC_SEARCH_TAB|IDC_KRAEFTE_TAB|IDC_MOMENTBELASTUNG_TAB|IDC_MAXBELASTUNGEN_TAB|IDC_LEBENSDAUER_TAB|IDC_WARNHINWIESE_TAB|IDC_HOEHENVERSATZ_TAB";
		strResult += dlg.getDialogElementEx("IDD_DATEN", strElementIds);
		return strResult;
		break;
	case "IDC_GENAUIGKEITSKLASSE_COMBO":
		strSelBauartID = getstring("", "DLGDATA.DATEN.SELBAUARTID");
		for i = 0 to (getsize("DLGDATA.DATEN.BAUARTEN","") - 1)
		{
			if (getstring("EKSR_IDENT", "DLGDATA.DATEN.BAUARTEN[" + i + "]") == strSelBauartID)
			{
				setalias("SELBAUART", "DLGDATA.DATEN.BAUARTEN[" + i + "]");
			}
		}
		ClearResult();
		strElementIds = "IDC_AUSFUEHRUNG_COMBO|IDC_SEARCH_TAB|IDC_KRAEFTE_TAB|IDC_MOMENTBELASTUNG_TAB|IDC_MAXBELASTUNGEN_TAB|IDC_LEBENSDAUER_TAB|IDC_WARNHINWIESE_TAB|IDC_HOEHENVERSATZ_TAB";
		strResult += dlg.getDialogElementEx("IDD_DATEN", strElementIds);
		return strResult;
		break;
	case "IDC_BAUART_COMBO":
		strSelBauartID = getstring("", "DLGDATA.DATEN.SELBAUARTID");
		for i = 0 to (getsize("DLGDATA.DATEN.BAUARTEN","") - 1)
		{
			if (getstring("EKSR_IDENT", "DLGDATA.DATEN.BAUARTEN[" + i + "]") == strSelBauartID)
			{
				setalias("SELBAUART", "DLGDATA.DATEN.BAUARTEN[" + i + "]");
			}
		}
		ClearResult();
		strElementIds = "IDC_WAGENTYP_COMBO|IDC_VORSPANNUNG_COMBO|IDC_GENAUIGKEITSKLASSE_COMBO|IDC_AUSFUEHRUNG_COMBO|IDC_SEARCH_TAB|IDC_KRAEFTE_TAB|IDC_MOMENTBELASTUNG_TAB|IDC_MAXBELASTUNGEN_TAB|IDC_LEBENSDAUER_TAB|IDC_WARNHINWIESE_TAB|IDC_HOEHENVERSATZ_TAB|IMG_BAUART";
		strResult += dlg.getDialogElementEx("IDD_DATEN", strElementIds);
		return strResult;
		break;
	case "IDC_AUSFUEHRUNG_COMBO":	// event wird im Moment nicht ausgelst
		strSelBauartID = getstring("", "DLGDATA.DATEN.SELBAUARTID");
		for i = 0 to (getsize("DLGDATA.DATEN.BAUARTEN","") - 1)
		{
			if (getstring("EKSR_IDENT", "DLGDATA.DATEN.BAUARTEN[" + i + "]") == strSelBauartID)
			{
				setalias("SELBAUART", "DLGDATA.DATEN.BAUARTEN[" + i + "]");
			}
		}
		ClearResult();
		return 2;
		break;	
	case "IDC_GEF_LEBENSDAUER_UNIT_COMBO":
		copyLebensdauerUnit();
		strResult += dlg.getDialogElementEx("IDD_DATEN", "IDC_GEF_LEBENSDAUER_EDIT");
		return strResult;
		break;
	}
return false;
};