#include "Allgemein.b"
#include "KGTCalc.b"

ClearResult()
{
	delete("WAGEN", "DLGDATA.DATEN")
	delete("SEARCHRESULT", "DLGDATA.DATEN")
	delete("MAXIMA", "DLGDATA.DATEN")
	delete("DATEN_FW", "DLGDATA")
	if (getstring("LEBENSDAUER_LAENGE.PROFILEID", "DLGDATA.DATEN") != "")
	{
		setdouble("LEBENSDAUER_LAENGE.RAW", "DLGDATA.DATEN", 0)
	}
	delete("LEBENSDAUER_ZEIT", "DLGDATA.DATEN")
	if (getstring("MTTF_LAENGE.PROFILEID", "DLGDATA.DATEN") != "")
		setdouble("MTTF_LAENGE.RAW", "DLGDATA.DATEN", 0)
	delete("MTTF_ZEIT", "DLGDATA.DATEN")
	delete("WARNHINWEISE","DLGDATA.DATEN")
	setstring ("WARNHINWEISCOUNT","DLGDATA.DATEN",0);

	setstring("SELSEARCHTABLE_ROW", "DLGDATA.DATEN", "")

	setstring("BCONTINUE_DISABLED", "DLGDATA.DATEN", "true")

	dCurrentMaxOrdNo	= getdouble("MAXDLGORDNUMBER", "DLGDATA")
	dDatenOrdNo			= getdouble("DLGORDNUMBERS.IDD_DATEN", "ROOT")
	if (dCurrentMaxOrdNo > dDatenOrdNo)
		setdouble("MAXDLGORDNUMBER", "DLGDATA", dDatenOrdNo)
	initDaten();
}
function	clearResultsKGT()
{
	
	ZTable	Tab("DLGDATA.KGTDATEN.SEARCHRESULT", "KGT", "SQL_KGTSEARCH");
	// Ohne update vor dem clear funktioniert ggfs. das Tabellenloeschen nicht (da nach Laden vom File
	// noch ein Ergebnis gespeichert ist aber noch kein Recordset geoeffent ?)
	Tab.update(true);
	Tab.clear();
	initKGTCalcKraefte();
	setstring("SEARCHSELECTED", "DLGDATA.KGTDATEN", "");
	setstring("F_AEQUI_EXT.RAW", "DLGDATA.KGTDATEN_KRAEFTE", "");
	//clearTechval("F_AEQUI", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("F_AEQUI_GES.RAW", "DLGDATA.KGTDATEN_KRAEFTE", "");
	//clearTechval("F_AEQUI_GES", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("F_GESMAX.RAW", "DLGDATA.KGTDATEN_KRAEFTE", "");
	//clearTechval("F_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("PHASE_F_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("CFMAX_VRHLTNS", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("C0FMAX_VRHLTNS", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("M_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("PHASE_M_GESMAX", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("CFAEQUI_VRHLTNS", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("L_10", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("L_H10", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("L_KM10", "DLGDATA.KGTDATEN_KRAEFTE", "");
	setstring("R_TOT", "DLGDATA.KGTDATEN_KRAEFTE", "");
	delete("WARNHINWEISE", "DLGDATA.KGTDATEN");
	setstring ("WARNHINWEISCOUNT","DLGDATA.KGTDATEN",0);
	delete ("KGT_STANDARD","DLGDATA.KGTDATEN");
	//delete ("KGT_SONDER","DLGDATA.KGTDATEN");
};
function clearTechval (path1,path2) {
	if (getstring (path1~"PROFILEID",path2)!="") {  // Nur ruecksetzen, wenn Techwert angelegt
		setstring (path1~"RAW",path2,"");
	};
};

Daten_InitBauarten(strPathBauarten)
{
	strRootNodeID = "10013"

	dscopychildren(strRootNodeID, strPathBauarten)
	nAnz = getsize(strPathBauarten, "")
#	print nAnz
	strSelBauartID = getstring("", "DLGDATA.DATEN.SELBAUARTID")
	if (strSelBauartID != "") 
	{
		for i = 0 to (nAnz - 1)
		{
			strPath = strPathBauarten + "[" + i + "]"
#			setstring("id", strPath, getstring("EKSR_IDENT", strPath))
#			strText = getstring("1.VALUE", strPath)
#			print strText
#			setstring("text", strPath, strText)
			if (getstring("EKSR_IDENT", strPath) == strSelBauartID)
			{
				setalias("SELBAUART", "DLGDATA.DATEN.BAUARTEN[" + i + "]")
			}
		}
	}
}

initDaten()
{
	strUnitProfileID = getstring("GEF_LEBENSDAUER.PROFILEID", "DLGDATA.DATEN")
	current_dlg=getstring("AKTUELLE_MASKE","")	# Die aktuelle Maske (sofern vorhanden)

	if (strUnitProfileID == "")
	{
		bRet = createobject("DLGDATA.DATEN","GEF_LEBENSDAUER", 49)
		bRet = createobject("DLGDATA.DATEN","GEF_LEBENSDAUER_H", 49, "22", "", "315");
		bRet = createobject("DLGDATA.DATEN","LEBENSDAUER_LAENGE", 49)
		bRet = createobject("DLGDATA.DATEN","MTTF_LAENGE", 49)
		setstring("GEF_LEBENSDAUER.PROFILEID", "DLGDATA.DATEN", "10010")
		setstring("LEBENSDAUER_LAENGE.PROFILEID", "DLGDATA.DATEN", "10010")
		setstring("MTTF_LAENGE.PROFILEID", "DLGDATA.DATEN", "10010")
		setstring("GEF_LEBENSDAUER.UNIT", "DLGDATA.DATEN", "281")
		setstring("GEF_LEBENSDAUER_H.UNIT", "DLGDATA.DATEN", "315")
		setstring("LEBENSDAUER_LAENGE.UNIT", "DLGDATA.DATEN", "281")
		setstring("MTTF_LAENGE.UNIT", "DLGDATA.DATEN", "281")
	}

	strUnitProfileID = getstring("LEBENSDAUER_LAENGE.PROFILEID", "DLGDATA.DATEN")
	if (strUnitProfileID == "")
	{
		bRet = createobject("DLGDATA.DATEN","LEBENSDAUER_LAENGE", 49, "10010", "", "281");
		bRet = createobject("DLGDATA.DATEN","MTTF_LAENGE", 49, "10010", "", "281");
	}
	
	strUnitProfileID = getstring("F_VORSP.PROFILEID", "DLGDATA.DATEN")
	if (strUnitProfileID == "")
	{
		bRet = createobject("DLGDATA.DATEN","F_VORSP", 49)
		setstring("F_VORSP.PROFILEID", "DLGDATA.DATEN", "11")
		setstring("F_VORSP.UNIT", "DLGDATA.DATEN", "292")
	}

	dFWAnz = getdouble("10001", "DLGDATA.SYSTEM")
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")
	strLebensDauerUnit = getstring("LEBENSDAUER_LAENGE.UNIT", "DLGDATA.DATEN")
	for n = 0 to (dFWAnz - 1)
	{
		pathFW = "DLGDATA.DATEN_FW[" + n + "]"
		strUnitProfileID = getstring("LEBENSDAUER_LAENGE.PROFILEID", pathFW)
		if (strUnitProfileID == "")	
		{
			bRet = createobject(pathFW,"LEBENSDAUER_LAENGE", 49)
			setstring("LEBENSDAUER_LAENGE.PROFILEID", pathFW, "10010")
		}
		setstring("LEBENSDAUER_LAENGE.UNIT", pathFW, strLebensDauerUnit)

		strUnitProfileID = getstring("MTTF_LAENGE.PROFILEID", pathFW)
		if (strUnitProfileID == "")	
		{
			bRet = createobject(pathFW,"MTTF_LAENGE", 49)
			setstring("MTTF_LAENGE.PROFILEID", pathFW, "10010")
		}
		setstring("MTTF_LAENGE.UNIT", pathFW, strLebensDauerUnit)
	}

	showMomente1(dFWAnz, dFSAnz);

	nAnz = getsize("DLGDATA.DATEN.BAUARTEN", "")

	# Bauarten initialisieren
	strPathBauarten = "DLGDATA.DATEN.BAUARTEN"
	bInit = 0
	if (nAnz <= 0)
	{
		Daten_InitBauarten(strPathBauarten)
		setalias("SELBAUART", strPathBauarten + "[0]")
		bInit = 1
	}

	if (getalias("SELBAUART") == "")
	{
		setalias("SELBAUART", strPathBauarten + "[0]")
	}

	if (bInit == 0)
	{
		for i = 0 to (nAnz - 1)
		{
			strPath = strPathBauarten + "[" + i + "]"
			strText = getstring("1.VALUE", strPath)
			setstring("text", strPath, strText)
		}
	}
	bRet	= execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCVM")
	if (getstring("BMTTF", "DLGDATA.DATEN") == "true")
		setstring("BMTTF_VISIBLE", "DLGDATA.DATEN", "visible")
	else
		setstring("BMTTF_VISIBLE", "DLGDATA.DATEN", "hidden")

	if (getstring("C_FORMEL", "DLGDATA.DATEN") == "")
		setstring("C_FORMEL", "DLGDATA.DATEN", "C")
	if (getstring("C0_FORMEL", "DLGDATA.DATEN") == "")
		setstring("C0_FORMEL", "DLGDATA.DATEN", translate("IDC_C0_FORMEL"))

	if (getdouble("INIT_MOMENTE", "PRG") == 1)
	{
		copy("DLGDATA.KRAEFTE_MOMENTE.MAEQUI", "DLGDATA.DATEN_FW[0].MAEQUI_MITDELTAZ")
		setstring("X.RAW", "DLGDATA.DATEN_FW[0].MAEQUI_MITDELTAZ", "")
		setstring("Y.RAW", "DLGDATA.DATEN_FW[0].MAEQUI_MITDELTAZ", "")
		setstring("Z.RAW", "DLGDATA.DATEN_FW[0].MAEQUI_MITDELTAZ", "")
		setdouble("INIT_MOMENTE", "PRG", 0.)
		//setstring("LEBENSDAUER_LAENGE.RAW", "DLGDATA.DATEN", "")
	}

	if (getstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE") == "")
	{
		setstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "visible")
		setstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BVERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "true")
	}
}

selectDatenTable()
{
	strMatNr = getstring("SELSEARCHTABLE_ROW", "DLGDATA.DATEN")
	strMatNr = replace(strMatNr, "IDC_SEARCH_TAB_", "")
	strClassID = dsqueryclassidfromident(strMatNr)
	if (strClassID != "")
	{
		dscopy(strClassID, "DLGDATA.DATEN.WAGEN")
 	}
	else
	{
		delete("WAGEN", "DLGDATA.DATEN")
	}
}

copyLebensdauerUnit()
{
	strUnitID = getstring("GEF_LEBENSDAUER.UNIT", "DLGDATA.DATEN")
	dFWAnz = getdouble("10001", "DLGDATA.SYSTEM")
	for n = 0 to (dFWAnz - 1)
	{
		pathFW = "DLGDATA.DATEN_FW[" + n + "]"
		setstring("LEBENSDAUER_LAENGE.UNIT", pathFW, strUnitID)
		setstring("MTTF_LAENGE.UNIT", pathFW, strUnitID)
	}
	
	strUnit = getstring("GEF_LEBENSDAUER.UNIT", "DLGDATA.DATEN");
	setstring("MTTF_LAENGE.UNIT", "DLGDATA.DATEN", strUnit);
	setstring("LEBENSDAUER_LAENGE.UNIT", "DLGDATA.DATEN", strUnit);
}