writeResults()
{
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")
	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	dAlpha	= getdouble("10003.VALUE", "DLGDATA.SYSTEM")
	dBeta	= getdouble("10004.VALUE", "DLGDATA.SYSTEM")
	dLY		= getdouble("10005.RAW", "DLGDATA.SYSTEM")
	dLZ		= getdouble("10006.RAW", "DLGDATA.SYSTEM")
	dLW1	= getdouble("10007.RAW", "DLGDATA.SYSTEM")
	dLW2	= getdouble("10008.RAW", "DLGDATA.SYSTEM")
	dLS		= getdouble("10009.RAW", "DLGDATA.SYSTEM")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "SystemDaten:\r\n", "")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "FS-Anz:\t" + dFSAnz + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "FW-Anz:\t" + dFWAnz + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Alpha:\t" + dAlpha + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Beta:\t" + dBeta + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "LY:\t" + dLY + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "LZ:\t" + dLZ + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "LW1:\t" + dLW1 + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "LW2:\t" + dLW2 + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "LS:\t" + dLS + "\r\n", "a")
	writefile(".\\debug\\KraefteDynZyklusCalc.txt", "\r\nBerechnungen:\r\n", "a")

	nAnzZyklen = getsize("DLGDATA.KRAEFTECALC", "")
	for i = 0 to (nAnzZyklen - 1)
	{
		pathCalcData = "DLGDATA.KRAEFTECALC[" + i + "]"
		Fx = getdouble("F.X.RAW", pathCalcData)
		Fy = getdouble("F.Y.RAW", pathCalcData)
		Fz = getdouble("F.Z.RAW", pathCalcData)
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft Fx:\t" + Fx + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft Fy:\t" + Fy + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft Fz:\t" + Fz + "\r\n", "a")
		
		Fx = getdouble("F_GESAMT.X.RAW", pathCalcData)
		Fy = getdouble("F_GESAMT.Y.RAW", pathCalcData)
		Fz = getdouble("F_GESAMT.Z.RAW", pathCalcData)
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft incl. Massen Fx:\t" + Fx + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft incl. Massen Fy:\t" + Fy + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft incl. Massen Fz:\t" + Fz + "\r\n", "a")

		Mx = getdouble("MOMENT.X.RAW", pathCalcData)
		My = getdouble("MOMENT.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENT.Z.RAW", pathCalcData)
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) Mx:\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) Mz:\t" + Mz + "\r\n", "a")

		Mx = getdouble("MOMENT_GESAMT.X.RAW", pathCalcData)
		My = getdouble("MOMENT_GESAMT.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENT_GESAMT.Z.RAW", pathCalcData)
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) incl. Massen Mx:\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) incl. Massen My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) incl. Massen Mz:\t" + Mz + "\r\n", "a")

		Mx = getdouble("MOMENTANTRIEB.X.RAW", pathCalcData)
		My = getdouble("MOMENTANTRIEB.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENTANTRIEB.Z.RAW", pathCalcData)
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment Antrieb Mx (nur zur Info):\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment Antrieb My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment Antrieb Mz:\t" + Mz + "\r\n", "a")

		Mx = getdouble("MOMENTMITANTRIEB.X.RAW", pathCalcData)
		My = getdouble("MOMENTMITANTRIEB.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENTMITANTRIEB.Z.RAW", pathCalcData)
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) Mx:\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) Mz:\t" + Mz + "\r\n", "a")

		Mx = getdouble("MOMENTMITANTRIEB_GESAMT.X.RAW", pathCalcData)
		My = getdouble("MOMENTMITANTRIEB_GESAMT.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENTMITANTRIEB_GESAMT.Z.RAW", pathCalcData)
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) incl. Massen Mx:\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) incl. Massen My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) incl. Massen Mz:\t" + Mz + "\r\n", "a")

		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "\r\nKraefte auf Fuehrungswagen:\r\n", "a")
		for n = 0 to (dFWAnz - 1)
		{
			pathFW = pathCalcData +".FW[" + n + "]"

			FSeitl		= getdouble("FSEITL.RAW", pathFW)
			FZugDruck	= getdouble("FZUGDRUCK.RAW", pathFW)
			FExtern		= getdouble("FEXTERN.RAW", pathFW)
			writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "," + (n+1) + "\tFSeitl:\t" + FSeitl + "\r\n", "a")
			writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "," + (n+1) + "\tFZugDruck:\t" + FZugDruck + "\r\n", "a")
			writefile(".\\debug\\KraefteDynZyklusCalc.txt", "Zykl. " + (i+1) + "," + (n+1) + "\tFExtern:\t" + FExtern + "\r\n", "a")
		}
		writefile(".\\debug\\KraefteDynZyklusCalc.txt", "\r\n", "a")
	}
}

BestimmeNFS(nFW)
{
	dB1		= getdouble("10024.BASE", "DLGDATA.DATEN.WAGEN")
	dLW1	= getdouble("10007.BASE", "DLGDATA.SYSTEM")
	dLW2	= getdouble("10008.BASE", "DLGDATA.SYSTEM")
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")
	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	nNFS	= 1

	if (dLW1 < (1.5 * dB1))
	{
		if ((dFSAnz == 1) and (dFWAnz == 2))
		{
			nNFS = 2
		}
		else if ((dFSAnz == 2) and (dFWAnz == 4))
		{
			nNFS = 2
		}
		else if ((dFSAnz == 2) and (dFWAnz == 6))
		{
			nNFS = 3
		}
		else if ((dFSAnz == 2) and (dFWAnz == 8))
		{
			if (((dLW2 - dLW1) / 2) > (1.5 * dB1))
			{
#				bInnererFW = IsInnererFW(nFW)
#				if (bInnererFW == 1)
					nNFS = 2
			}
			else	{
				nNFS = 4
			}
		}
	}
	else
	{
		if ((dFSAnz == 2) and (dFWAnz == 8) and (((dLW2 - dLW1) / 2) <= (1.5 * dB1)))
			nNFS = 2
	}

#	print nNFS
	return nNFS
}

IsInnererFW(nFW)
{
	if ((nFW == 2) or (nFW == 3) or (nFW == 6) or (nFW == 7))
	{
		return 1
	}
	return 0
}

IsVerformungsdiagrammHinterlegt()
{
	dA1_Druck	= getdouble("10027.RAW", "DLGDATA.DATEN.WAGEN")
	dA2_Druck	= getdouble("10028.RAW", "DLGDATA.DATEN.WAGEN")
	dA3_Druck	= getdouble("10029.RAW", "DLGDATA.DATEN.WAGEN")
	dA1_Zug		= getdouble("10030.RAW", "DLGDATA.DATEN.WAGEN")
	dA2_Zug		= getdouble("10031.RAW", "DLGDATA.DATEN.WAGEN")
	dA3_Zug		= getdouble("10032.RAW", "DLGDATA.DATEN.WAGEN")
	dA1_Seitl	= getdouble("10033.RAW", "DLGDATA.DATEN.WAGEN")
	dA2_Seitl	= getdouble("10034.RAW", "DLGDATA.DATEN.WAGEN")
	dA3_Seitl	= getdouble("10035.RAW", "DLGDATA.DATEN.WAGEN")

	if ((dA1_Druck == 0) and (dA2_Druck == 0) and (dA3_Druck == 0) and (dA1_Zug == 0) and (dA2_Zug == 0) and (dA3_Zug == 0) and (dA1_Seitl == 0) and (dA2_Seitl == 0) and (dA3_Seitl == 0))
		return 0
	return 1
}

BestimmeVmax()
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL."
	nAnzZyklen = getsize("DLGDATA.KRAEFTECALC", "")

	if (getstring("EINGABEART","DLGDATA") == "DYNAMIKZYKLUS")
		strAttr = "VE.RAW"
	else
		strAttr = "VM.RAW"

	dVmax = 0
	for n = 0 to (nAnzZyklen - 1)
	{
		dV = getdouble(strAttr, strProfilePath + n)
		dV = abs(dV)
		if (dV > dVmax)
			dVmax = dV
	}
	return dVmax
}

BestimmeSmax()
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL."
	nAnzZyklen = getsize("DLGDATA.KRAEFTECALC", "")

	if (getstring("EINGABEART","DLGDATA") == "DYNAMIKZYKLUS")
		strAttr = "SE.RAW"
	else
		strAttr = "SE.RAW"

	dSmax = 0
	for n = 0 to (nAnzZyklen - 1)
	{
		dS = getdouble(strAttr, strProfilePath + n)
		dS = abs(dS)
		if (dS > dSmax)
			dSmax = dS
	}
	return dSmax
}

BestimmeDynZyklusMaxima()
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL."
	// nAnzZyklen = getsize("DLGDATA.KRAEFTECALC", "")
	nAnzZyklen = getint("SIZE", strProfilePath)

	if (getstring("EINGABEART","DLGDATA") == "DYNAMIKZYKLUS")
		strVAttr = "VE.RAW"
	else
		strVAttr = "VM.RAW"

	if (getstring("EINGABEART","DLGDATA") == "DYNAMIKZYKLUS")
		strSAttr = "SE.RAW"
	else
		strSAttr = "SE.RAW"

	strAAttr	= "AE.RAW"

	dVmax		= 0
	dSmax_Abs	= 0
	dSmax		= 0
	dSmin		= 0
	dAmax		= 0
	for n = 0 to (nAnzZyklen - 1)
	{
		dV = getdouble(strVAttr, strProfilePath + n)
		dV = abs(dV)
		if (dV > dVmax)
			dVmax = dV

		dS = getdouble(strSAttr, strProfilePath + n)
		if (dS > dSmax)
			dSmax = dS
		if (dS < dSmin)
			dSmin = dS

		dA = getdouble(strAAttr, strProfilePath + n)
		dA = abs(dA)
		if (dA > dAmax)
			dAmax = dA
		dS = abs(dS)
		if (dS > dSmax_Abs)
			dSmax_Abs = dS
	}

	setdouble("SMAX", "DLGDATA.DYNZYKLUS.MAXIMA", dSmax_Abs)
	setdouble("VMAX", "DLGDATA.DYNZYKLUS.MAXIMA", dVmax)
	setdouble("AMAX", "DLGDATA.DYNZYKLUS.MAXIMA", dAmax)
	setdouble("HUBMAX", "DLGDATA.DYNZYKLUS.MAXIMA", dSmax - dSmin)
	var P = getdouble("PM_STEIGUNG.BASE", "KGT");
	if (P > 0)	{
		var dVm = getdouble("VM.BASE", "DLGDATA.DYNZYKLUS.PROFIL");
		setdouble("NMAX", "DLGDATA.DYNZYKLUS.MAXIMA", dVmax / P);
		setdouble("NM.BASE", "DLGDATA.DYNZYKLUS.PROFIL", dVm / P);
	}
}

BestimmeDynamikDiverseMaxima()
{
	dMmax = 0
	dMymax = 0
	dFzPosmax = 0
	dBelastung_xy_max = 0
	dFWAnz	   = getdouble("10001", "DLGDATA.SYSTEM")
	nAnzZyklen = getsize("DLGDATA.KRAEFTECALC", "")
	for n = 0 to nAnzZyklen - 1
	{
		pathZyklus = "DLGDATA.KRAEFTECALC[" + n + "]"
		for i = 0 to dFWAnz - 1
		{
			pathFW = pathZyklus + ".FW[" + i + "]"
			dM = getdouble("CALC_MOMENT.Y.RAW", pathFW)
			dM = abs(dM)
			if (dM > dMmax)
				dMmax = dM
			if (dM > dMymax)
				dMymax = dM

			dM = getdouble("CALC_MOMENT.Z.RAW", pathFW)
			dM = abs(dM)
			if (dM > dMmax)
				dMmax = dM
			dFz = getdouble("FZUGDRUCK_SEITL_KOMPLETT.Z.RAW", pathFW)
			if (dFz > dFzPosmax)
				dFzPosmax = dFz
			dFy = getdouble("FZUGDRUCK_SEITL_KOMPLETT.Y.RAW", pathFW)
			dFz = abs(dFz)
			dFy = abs(dFy)
			if (dFy > dBelastung_xy_max)
				dBelastung_xy_max = dFy
			if (dFz > dBelastung_xy_max)
				dBelastung_xy_max = dFz
		}
	}
	setdouble("MMAX_YZ", "DLGDATA.DATEN.MAXIMA", dMmax)
	setdouble("MMAX_Y", "DLGDATA.DATEN.MAXIMA", dMymax / dFWAnz)
	setdouble("FPOSMAX_Z", "DLGDATA.DATEN.MAXIMA", dFzPosmax)
	setdouble("BELASTUNGMAX_YZ", "DLGDATA.DATEN.MAXIMA", dBelastung_xy_max)

	return dMmax
}

GeneriereWarnhinweise()
{
	delete("WARNHINWEISE","DLGDATA.DATEN")
	var oldHinweisCount=getdouble ("WARNHINWEISCOUNT","DLGDATA.DATEN");
	if (getstring("ID", "DLGDATA.DATEN.WAGEN") == "")
	{
		nStatus = -1073741824
		setint("STATUS", "DLGDATA.DATEN", nStatus)
		setstring("BCONTINUE_DISABLED", "DLGDATA.DATEN", "true")

		return nStatus
	}
	dB1			= getdouble("10024.BASE", "DLGDATA.DATEN.WAGEN")
	dLW1		= getdouble("10007.BASE", "DLGDATA.SYSTEM")
	dLW2		= getdouble("10008.BASE", "DLGDATA.SYSTEM")
	dLS			= getdouble("10009.BASE", "DLGDATA.SYSTEM")
	dFSAnz		= getdouble("10002", "DLGDATA.SYSTEM")
	dFWAnz		= getdouble("10001", "DLGDATA.SYSTEM")
	dFWLaenge	= getdouble("10025.BASE", "DLGDATA.DATEN.WAGEN")
	dFWBreite	= getdouble("10062.BASE", "DLGDATA.DATEN.WAGEN")
	dVmaxzul	= getdouble("10023.RAW", "DLGDATA.DATEN.WAGEN")
	dAmaxzul	= getdouble("10061.RAW", "DLGDATA.DATEN.WAGEN")
	dML			= getdouble("10021.RAW", "DLGDATA.DATEN.WAGEN")
	dC			= getdouble("10016.RAW", "DLGDATA.DATEN.WAGEN")
	dFmaxDiagramm = getdouble("10064.RAW", "DLGDATA.DATEN.WAGEN")
	dC0			= getdouble("10017.RAW", "DLGDATA.DATEN.WAGEN")

	BestimmeDynZyklusMaxima()
	BestimmeDynamikDiverseMaxima()

	dVmaxZyklus		= getdouble("VMAX", "DLGDATA.DYNZYKLUS.MAXIMA")
	dHubmaxZyklus	= getdouble("HUBMAX", "DLGDATA.DYNZYKLUS.MAXIMA")
	dAmaxZyklus		= getdouble("AMAX", "DLGDATA.DYNZYKLUS.MAXIMA")
	bSevereError = 0
	n = 0
	
	var KGTSteifigkeit=getdouble ("R_TOT","DLGDATA.KGTDATEN_KRAEFTE")*1000000.0; // umrechnen in N/m
	var PFSSteifigkeit=getdouble ("10010.BASE","DLGDATA.SYSTEM");

	// Zusaetzlicher Warnhinweis (Feedback 5431)
	if ((KGTSteifigkeit!=0) && (PFSSteifigkeit>KGTSteifigkeit)) {
		setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDS_HIGHER_STIFFNESS")
		n = n + 1
	};

	#Kinematik
	if ((dVmaxZyklus > dVmaxzul) or (dAmaxZyklus > dAmaxzul))
	{
		setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_KINEMATIK")
		nStatus = 1
		n = n + 1
	}
#	if (dAmaxzul <= 0)
#		print "Amax,zul = 0 oder nicht definiert!"
#	if (dFmaxDiagramm <= 0)
#		print "Fmax,Diagramm = 0 oder nicht definiert!"

	#Geometrie
	if ((dFWAnz > 2) or ((dFWAnz == 2) and (dFSAnz == 1)))
		bLW1Valid = 1
	else
		bLW1Valid = 0

	bGeometrieError = 0
	if (bLW1Valid == 1)
	{
		if (dLW1 < dFWLaenge)
		{
			setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_LW1_ZUKLEIN")
			bGeometrieError = 1
			n = n + 1
		}
		if ((dFWAnz == 8) and (((dLW2-dLW1)/2) < dFWLaenge))
		{
			setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_LW1LW2_ZUKLEIN")
			bGeometrieError = 1
			n = n + 1
		}
	}
	if ((dFSAnz > 1) and (dLS < dFWBreite))
	{
		setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_LS_ZUKLEIN")
		bGeometrieError = 1
		n = n + 1
	}
	if (bGeometrieError == 1)	
	{
		nStatus			= nStatus + 2
		bSevereError	= 1
	}

	#Kurzhub
	strEingabeart = getstring("EINGABEART","DLGDATA")
	if ((strEingabeart != "ZEITANTEILE") and (dHubmaxZyklus <= (2 * dFWLaenge)))
	{
		setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_KURZHUB")
		nStatus = nStatus + 4
		n = n + 1
	}

	#Maximal zulaessige Werte Linearfuehrung
	bMaxzulWerteLinfuehrung = 0
	if (dC0 == 0)
	{
#		strCRedFqAttr = "C0REDFQ"
		strCRedFqAttr = "C0FGESAMT"
		dCRedFqGrenze = 1. / 0.7
	}
	else
	{
#		strCRedFqAttr = "CREDFQ"
		strCRedFqAttr = "CREDFGESAMT"
		dCRedFqGrenze = 2.
	}

#	for i = 0 to (dFWAnz - 1)
#	{
#		pathFW = "DLGDATA.DATEN_FW[" + i + "]"
#		dCredFq = getdouble(strCRedFqAttr, pathFW)
#		if (dCredFq < dCRedFqGrenze)
#			bMaxzulWerteLinfuehrung = 1
#	}

	dCredFq		= getdouble(strCRedFqAttr, "DLGDATA.DATEN.MAXIMA")
#	print (dCredFq)
	dFGesamtMax = getdouble("FGESAMT", "DLGDATA.DATEN.MAXIMA")
	dFqMax		= getdouble("FQMAX", "DLGDATA.DATEN.MAXIMA")

	if ((dFGesamtMax > 0) and (dFqMax > 0) and (dCredFq < dCRedFqGrenze))
		bMaxzulWerteLinfuehrung = 1

	if (dML == 0)		# Superfuehrungswagen koennen keine "seitl." Momente aufnehmen
	{
		dMmaxSeitl	= getdouble("MMAX_YZ", "DLGDATA.DATEN.MAXIMA")
		if (dMmaxSeitl > 0)
			bMaxzulWerteLinfuehrung = 1
	}

	if (bMaxzulWerteLinfuehrung > 0)
	{
		setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_MAXZULWERTELINFUEHRUNG")
		nStatus = nStatus + 8
		n = n + 1
	}

	# Sicherheitsabfragen fuer extremste Belastungen der Schraubenverbindungen
	bExtremsteBelastungen = 0
	dFzPosmax = getdouble("FPOSMAX_Z", "DLGDATA.DATEN.MAXIMA")
	dFZusatz = getdouble("ZUSATZLAST.RAW", "DLGDATA.HINWEISE")
	if ((dFZusatz + dFzPosmax) > (dC / 2))
		bExtremsteBelastungen = 1

	if (((dFWAnz == 1) and (dFSAnz == 1)) or ((dFWAnz == 2) and (dFSAnz == 2)))
	{
		dMymax = getdouble("MMAX_Y", "DLGDATA.DATEN.MAXIMA")
		if (dMymax > (dML / 2))
			bExtremsteBelastungen = 1

		if (bExtremsteBelastungen == 0)
		{
			nAnzZyklen = getsize("DLGDATA.KRAEFTECALC", "")
			for k = 0 to nAnzZyklen - 1
			{
				pathZyklus = "DLGDATA.KRAEFTECALC[" + k + "]"
				for i = 0 to dFWAnz - 1
				{
					pathFW = pathZyklus + ".FW[" + i + "]"
					dFz = getdouble("FZUGDRUCK_SEITL_KOMPLETT.Z.RAW", pathFW)
					if (dFz < 0)
						dFz = 0
					dFVerh = (dFz + dFZusatz) * 2 / dC
					dM = getdouble("CALC_MOMENT.Y.RAW", pathFW)
					dM = abs(dM) / dFWAnz
					dMVerh = dM * 2 / dML
					if ((dFVerh + dMVerh) > 1)
						bExtremsteBelastungen = 1
				}
			}
		}
	}
	if (bExtremsteBelastungen > 0)
	{
		setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_EXTREMBELASTUNG")
		nStatus = nStatus + 16
		n = n + 1
	}


	# Andere Kriterien
	dFVorsp = getdouble("F_VORSP.RAW", "DLGDATA.DATEN")
	dFGesamtMax = getdouble("FGESAMT", "DLGDATA.DATEN.MAXIMA")
	if (dFGesamtMax >= 2.5 * dFVorsp) {
		setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_ANDEREKRITERIEN")
		nStatus = nStatus + 32
		n = n + 1			
	}
	
	
	
	
	
	
	# Dynamisches Lastverhaeltnis pruefen
	for i = 0 to (dFWAnz - 1)
	{
		pathFW = "DLGDATA.DATEN_FW[" + i + "]"
		dCRed=getdouble("CRED", pathFW);		
		if (dCRed<dFqMax*4) {
			setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_LAST_DYNAMISCH_WARNUNG");
			n = n + 1		
			break;
		};
		
	}
	
	# Statisches Lastverhaeltnis pruefen
	for i = 0 to (dFWAnz - 1)
	{
		pathFW = "DLGDATA.DATEN_FW[" + i + "]"
		dC0Red=getdouble("C0RED", pathFW);		
		if (dC0Red<dFGesamtMax*4) {
			setstring("WARNHINWEISE[" + n +"].text", "DLGDATA.DATEN", "IDC_MSG_LAST_STATISCH_WARNUNG");
			n = n + 1		
			break;
		};
		
	}

	
	
	

	# Verlagerungsberechnung
	dFZugDruckSeitlMax = getdouble("BELASTUNGMAX_YZ", "DLGDATA.DATEN.MAXIMA")
	if (dFZugDruckSeitlMax > dFmaxDiagramm)
	{
		nStatus = nStatus + 64
#		n = n + 1
	}

    setstring ("WARNHINWEISCOUNT","DLGDATA.DATEN",n);
	if ((n>0) && (n!=oldHinweisCount)) {
		setbool ("NEWWARNHINWEIS","DLGDATA.DATEN",true);
	} else {
		setbool ("NEWWARNHINWEIS","DLGDATA.DATEN",false);
	};

	if (bSevereError > 0)
		nStatus = -nStatus
		
	setint("STATUS", "DLGDATA.DATEN", nStatus)
	if (nStatus < 0)
		setstring("BCONTINUE_DISABLED", "DLGDATA.DATEN", "true")
	else
		setstring("BCONTINUE_DISABLED", "DLGDATA.DATEN", "false")

	return nStatus
}


calcMAequiMitDeltaZ(nAnzZyklen, dPotenz)
{
	# Komponenten von MAequi berechnen
	MAequiX = 0
	MAequiY = 0
	MAequiZ = 0

	for i = 0 to (nAnzZyklen - 1)
	{
		# fuer jeden Zyklus berechnetes Moment mit Beruecksichtigung des Antriebs ausm Store holen
		pathCalcData = "DLGDATA.KRAEFTECALC[" + i + "].FW[0]"
		MZyklX = getdouble("CALC_MOMENT.X.RAW", pathCalcData)
		MZyklY = getdouble("CALC_MOMENT.Y.RAW", pathCalcData)
		MZyklZ = getdouble("CALC_MOMENT.Z.RAW", pathCalcData)
#		print MZyklX
#		print MZyklY
#		print MZyklZ
		MZyklX = abs(MZyklX)
		MZyklY = abs(MZyklY)
		MZyklZ = abs(MZyklZ)

		# Qs aus Zyklusdaten ausm Store holen
		pathZyklus = "DLGDATA.DYNZYKLUS.PROFIL." + i
		Qs = getdouble("QS.VALUE", pathZyklus)

		if (Qs > 0)
		{
			MAequiX = MAequiX + pow(MZyklX, dPotenz) * Qs
			MAequiY = MAequiY + pow(MZyklY, dPotenz) * Qs
			MAequiZ = MAequiZ + pow(MZyklZ, dPotenz) * Qs
		}
	}
	MAequiX = root((MAequiX/100), dPotenz)
	MAequiY = root((MAequiY/100), dPotenz)
	MAequiZ = root((MAequiZ/100), dPotenz)

	pathFW = "DLGDATA.DATEN_FW[0]"
	strProfID = getstring("MAEQUI_MITDELTAZ.PROFILEID", pathFW)
	if (strProfID == "")	
	{
		# 3-dim Vektor erzeugen
		dRet = createobject(pathFW, "MAEQUI_MITDELTAZ", 63)
		if (dRet == 0)
		{
			print("Error!")
		}
		# Einheitenprofil (Drehmoment) zuweisen
		setstring("pathFW.PROFILEID", pathFW, "10007")
	}
	# berechnete Komponenten im Vektor speichern
	setdouble("MAEQUI_MITDELTAZ.X.RAW", pathFW, MAequiX)
	setdouble("MAEQUI_MITDELTAZ.Y.RAW", pathFW, MAequiY)
	setdouble("MAEQUI_MITDELTAZ.Z.RAW", pathFW, MAequiZ)
}



//////////////////////////////////////////////////////////////////
// MAIN-Block
calcDaten()
{
	copy("DLGDATA.KRAEFTE_MOMENTE.MAEQUI", "DLGDATA.DATEN_FW[0].MAEQUI_MITDELTAZ")

	dFSAnz = getdouble("10002", "DLGDATA.SYSTEM")
	dFWAnz = getdouble("10001", "DLGDATA.SYSTEM")

#	print dFWAnz
#	print getstring("ID", "DLGDATA.DATEN.WAGEN")

	dC		= getdouble("10016.RAW", "DLGDATA.DATEN.WAGEN")
	dC0		= getdouble("10017.RAW", "DLGDATA.DATEN.WAGEN")
	dMttf	= getdouble("10015.RAW", "DLGDATA.DATEN.WAGEN")
	if (dC0 == 0)
	{
		dC0			= getdouble("10018.RAW", "DLGDATA.DATEN.WAGEN")		# Fmax,zul  anstelle C0 verwenden
		strC0		= getstring("10018.VALUE", "DLGDATA.DATEN.WAGEN")	# Fmax,zul
		setstring("C0FMAX_LABEL", "DLGDATA.DATEN", translate("IDC_FMAXZUL_LABEL"))
		setstring("C0FMAX_FORMEL", "DLGDATA.DATEN", translate("IDC_FMAXZUL_FORMEL"))
		setstring("C0FMAX", "DLGDATA.DATEN", strC0)
	}
	else
	{
		strC0		= getstring("10017.VALUE", "DLGDATA.DATEN.WAGEN")	# C0
		setstring("C0FMAX_LABEL", "DLGDATA.DATEN", translate("IDC_C0_LABEL"))
		setstring("C0FMAX_FORMEL", "DLGDATA.DATEN", translate("IDC_C0_FORMEL"))
		setstring("C0FMAX", "DLGDATA.DATEN", strC0)
	}

	nAnzZyklen = getsize("DLGDATA.KRAEFTECALC", "")
#	print nAnzZyklen

//	bRet	= execute("DLGDATA.DYNZYKLUS.PROFIL", "CALCVM")
	dVm		= getdouble("VM.RAW", "DLGDATA.DYNZYKLUS.PROFIL")

	if (getstring("EINGABEART","DLGDATA") == "STRECKENANTEILE")
	{
		dEinschaltdauer	= getdouble("EINSCHALTDAUER", "DLGDATA.DYNSTRECKEN")
		if (dEinschaltdauer <= 0)
		{
			dEinschaltdauer = 100
		}
		dVm = dVm * dEinschaltdauer / 100
	}

	if (getstring("EKSR_IDENT","SELBAUART") == "ROLLENWAGEN")
		dPotenz = 10 / 3
	else
		dPotenz = 3
#	print dPotenz

	dFGesamtMax = -1
	dFqMax = -1
	nZyklusMax  = 0
	nFWMax		= 0

	dFak = 1
	dBetriebsfaktor = getdouble("KF", "DLGDATA.DATEN")
	if (dBetriebsfaktor > 1)
		dFak = 1 / dBetriebsfaktor
	strbTragzahlabschlag = getstring("BTRAGZAHLABSCHLAG", "DLGDATA.DATEN")
#	if (strbTragzahlabschlag == "true")	
#	{
		dTragzahlabschlag = getdouble("TRAGZAHLABSCHLAG", "DLGDATA.DATEN")
		if ((dTragzahlabschlag >= 0) and (dTragzahlabschlag <= 100))
			dFak = dFak * (1 - dTragzahlabschlag / 100)
#	}


	for n = 0 to (dFWAnz - 1)
	{
		FAequi			= 0
		FAequiKomplett	= 0
		for i = 0 to (nAnzZyklen - 1)
		{
			pathCalcData = "DLGDATA.KRAEFTECALC[" + i + "].FW[" + n + "]"
#			FExt			= getdouble("FEXTERN.RAW", pathCalcData)
#			FExt			= getdouble("FEXTERN_KOMPLETT.RAW", pathCalcData)
			FExt			= getdouble("FEXTERN_OHNEMOMENTBELASTUNG.RAW", pathCalcData)
			FGesamtKomplett	= getdouble("FGESAMT_KOMPLETT.RAW", pathCalcData)
			if (FGesamtKomplett > dFGesamtMax)
			{
				dFGesamtMax = FGesamtKomplett
				nZyklusMax	= i + 1
				nFWMax		= n + 1
			}
#			print FExt
			pathZyklus = "DLGDATA.DYNZYKLUS.PROFIL." + i
			Qs = getdouble("QS.VALUE", pathZyklus)
			if (((FExt > 0) or (FGesamtKomplett > 0)) and (Qs > 0))
			{
				FAequi			= FAequi + pow(FExt, dPotenz) * Qs
				FAequiKomplett	= FAequiKomplett + pow(FGesamtKomplett, dPotenz) * Qs
			}
		}
#		print FAequi
		FAequi			= root((FAequi/100), dPotenz)
		FAequiKomplett	= root((FAequiKomplett/100), dPotenz)
		if (FAequiKomplett > dFqMax)
			dFqMax = FAequiKomplett
		pathFW = "DLGDATA.DATEN_FW[" + n + "]"
		strProfID = getstring("FAEQUI.PROFILEID", pathFW)
		if (strProfID == "")	
		{
			# Techwert erzeugen
			dRet = createobject(pathFW, "FAEQUI", 49)
			if (dRet == 0)
			{
				print("Error!")
			}
			# Einheitenprofil (Kraft) zuweisen
			setstring("FAEQUI.PROFILEID", pathFW, "11")
		}
		strProfID = getstring("GESAMTBELASTUNG.PROFILEID", pathFW)
		if (strProfID == "")	
		{
			# Techwert erzeugen
			dRet = createobject(pathFW, "GESAMTBELASTUNG", 49)
			if (dRet == 0)
			{
				print("Error!")
			}
			# Einheitenprofil (Kraft) zuweisen
			setstring("GESAMTBELASTUNG.PROFILEID", pathFW, "11")
		}
		
#		print FAequi
		setdouble("FAEQUI.RAW", pathFW, FAequi)
		setdouble("GESAMTBELASTUNG.RAW", pathFW, FAequiKomplett)
		setstring("id", pathFW, n)
		setstring("text", pathFW, (translate("FW") + " " + (n + 1)))
#		print FAequi
#		print FAequiKomplett

		if (strbTragzahlabschlag == "true")	
			nNFS	= BestimmeNFS((n + 1))
		else 
			nNFS = 1

		if (nNFS == 1)
		{
			dCRed	= dC
			dC0Red	= dC0
		}
		else
		{
			dCRed	= dC * pow(nNFS, -0.3)
			dC0Red	= dC0 * pow(nNFS, -0.3)
		}
		dCRed	= dFak * dCRed
		dC0Red	= dFak * dC0Red
		setdouble("CRED", pathFW, dCRed)
		setdouble("C0RED", pathFW, dC0Red)
		if (FAequiKomplett > 0)
		{
			dL10		= dCRed / FAequiKomplett
			dC0RedFq	= dC0Red / FAequiKomplett
		}
		else
		{
			dL10		= 0
			dC0RedFq	= 0
		}

		setdouble("CREDFQ", pathFW, dL10)
		setdouble("C0REDFQ", pathFW, dC0RedFq)

		dL10 = pow(dL10, dPotenz)
		dL10 = dL10 * 100000
		if (dVm > 0)
		{
			dL10_Z = dL10 / (3600 * dVm)
		}
		else
		{
			dL10_Z = 0
		}

		# Basiseinheit km !
		dL10 = dL10 / 1000

		setdouble("LEBENSDAUER_LAENGE.RAW", pathFW, dL10)
		setdouble("LEBENSDAUER_ZEIT", pathFW, dL10_Z)
		setdouble("MTTF_LAENGE.RAW", pathFW, (dL10 * dMttf))
		setdouble("MTTF_ZEIT", pathFW, (dL10_Z * dMttf))
	}

	if (dFWAnz <= 2)
		calcMAequiMitDeltaZ(nAnzZyklen, dPotenz)

	setdouble("FGESAMT", "DLGDATA.DATEN.MAXIMA", dFGesamtMax)
	setdouble("FQMAX", "DLGDATA.DATEN.MAXIMA", dFqMax)
	setint("ZYKLUS", "DLGDATA.DATEN.MAXIMA", nZyklusMax)
	setint("FW", "DLGDATA.DATEN.MAXIMA", nFWMax)
	delete("CREDFGESAMT", "DLGDATA.DATEN.MAXIMA")
	delete("CREDFQMAX", "DLGDATA.DATEN.MAXIMA")
	if ((dFGesamtMax > 0) and (dFqMax > 0))
	{
#		dC	= getdouble("10016.RAW", "DLGDATA.DATEN.WAGEN")
#		dC0 = getdouble("10017.RAW", "DLGDATA.DATEN.WAGEN")
		setdouble("C0FGESAMT", "DLGDATA.DATEN.MAXIMA", (dC0Red / dFGesamtMax))
		if (strbTragzahlabschlag == "true")	
			nNFS	= BestimmeNFS(nFWMax)
		else
			nNFS	= 1

		if (nNFS == 1)
		{
			dCRed = dC
		}
		else
		{
			dCRed = dC * pow(nNFS, -0.3)
		}
		dCRed = dFak * dCRed
		setdouble("CREDFGESAMT", "DLGDATA.DATEN.MAXIMA", (dCRed / dFGesamtMax))
		setdouble("CREDFQMAX", "DLGDATA.DATEN.MAXIMA", (dCRed / dFqMax))
	}
	else
	{
		setstring("CREDFGESAMT", "DLGDATA.DATEN.MAXIMA", "")
		setstring("CREDFQMAX", "DLGDATA.DATEN.MAXIMA", "")
	}
	if (getdouble("10017.RAW", "DLGDATA.DATEN.WAGEN") == 0)
	{
		strTmpC0 = translate("IDC_FMAXZUL_FORMEL")
	}
	else
	{
		strTmpC0 = translate("IDC_C0_FORMEL")
	}
	strTmpC = "C"
	if ((dFak != 1) or (nNFS != 1))
	{
		strTmpC = strTmpC + "<sub>red</sub>"
		strTmpC0 = replace(strTmpC0, "&lt;/sub&gt;", ",red&lt;/sub&gt;")
	}
	setstring("C_FORMEL", "DLGDATA.DATEN", strTmpC)
	setstring("C0_FORMEL", "DLGDATA.DATEN", strTmpC0)

	# Lebensdauer berechnen
	if (dFqMax > 0)
	{
		dL10_Laenge = dCRed / dFqMax
	}
	else
	{
		dL10_Laenge = 0
	}

	dL10_Laenge = pow(dL10_Laenge, dPotenz)
	dL10_Laenge = dL10_Laenge * 100000
	if (dVm > 0)
	{
		dL10_Zeit = dL10_Laenge / (3600 * dVm)
	}
	else
	{
		dL10_Zeit = 0
	}

	# Basiseinheit km !
	dL10_Laenge = dL10_Laenge / 1000

	setdouble("LEBENSDAUER_LAENGE.RAW", "DLGDATA.DATEN", dL10_Laenge)
	setdouble("LEBENSDAUER_ZEIT", "DLGDATA.DATEN", dL10_Zeit)
	setdouble("MTTF_LAENGE.RAW", "DLGDATA.DATEN", (dL10_Laenge * dMttf))
	setdouble("MTTF_ZEIT", "DLGDATA.DATEN", (dL10_Zeit * dMttf))

	// -mw- 15.11.2013: Vorspannung ist jetzt ein freier String
	// -mw- 19.11.2013: vorlufig nochmal auf alten Stand zurck gesetzt, weil auch nderungen in Exe erforderlich
	dVorspannung = getdouble("10013.RAW", "DLGDATA.DATEN.WAGEN")
	dFVorsp = dVorspannung * dC
	// dFVorsp = getdouble("10014.RAW", "DLGDATA.DATEN.WAGEN")

	setdouble("F_VORSP.RAW", "DLGDATA.DATEN", dFVorsp)

	nStatus = GeneriereWarnhinweise()

	if (dFWAnz <= 2)
	{
		setstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "visible")
		setstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BVERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "true")
	}
	else if (IsVerformungsdiagrammHinterlegt() == 0)
	{
		setstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "visible")
		setstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BVERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "true")
	}
	else if (isbitset(nStatus, 7) > 0)
	{
		setstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "visible")
		setstring("BVERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "true")
	}
	else
	{
		setstring("BVERLAGERUNGEN_NOTIMPLEMENTED", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BNO_VERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BNO_VERLAGERUNGEN_BELASTUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "hidden")
		setstring("BVERLAGERUNGEN", "DLGDATA.VERLAGERUNGEN_SONSTIGE", "false")
	}

	if ((isbitset(nStatus, 4) > 0) or (isbitset(nStatus, 1) > 0) or (isbitset(nStatus, 5) > 0))
	{
		setdouble("LEBENSDAUER_LAENGE.RAW", "DLGDATA.DATEN", 0.)
		setdouble("LEBENSDAUER_ZEIT", "DLGDATA.DATEN", 0.)
		setdouble("MTTF_LAENGE.RAW", "DLGDATA.DATEN", 0.)
		setdouble("MTTF_ZEIT", "DLGDATA.DATEN", 0.)
	}
#	writeResults()
}