#include "CDialogBase.b"

getPQFromTabRow(strRow)
{
	if (strRow == "2")
		return "V"
	else if (strRow == "3")
		return "A"
	else if (strRow == "4")
		return "S"
	else if (strRow == "5")
		return "T"
	return ""
}

onEditChanged()
{
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	eventPar	= getstring("EKSUBMITEVENTPAR","")		# Event aus der aktuellen Maske	
	eventPar	= getdlgvar("EKSUBMITEVENTPAR")		# Event aus der aktuellen Maske	
	strRowCol	= replace(eventPar,(event+"_"),"")
	strElementIds = "";

	dRet = split(strRowCol, strRow, strCol, "_")
	strModPhysValue = getPQFromTabRow(strRow)
	nProfileIndex = strCol - 3
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL"
	strPhasePath = strProfilePath + "."+ nProfileIndex
	setstring("CURRENTMODIFIED", strPhasePath, strModPhysValue)

	nNextProfileIndex = nProfileIndex + 1
	setint("RESETSTART", strProfilePath, nNextProfileIndex)
	bRet = execute(strProfilePath, "RESET")

	for i = 0 to nProfileIndex
	{
		bRet = execute(strProfilePath + "." + i, "CALCFINALVALUES")
		bRet = execute(strProfilePath + "." + i, "CALCCURVELENGTH")
	}
	bRet = execute(strProfilePath, "CALCQS")
	bRet = execute(strProfilePath, "CALCQT")
	bRet = execute(strProfilePath, "CALCTOTALCURVELENGTH")

	dTe		= getdouble("TE.VALUE", strPhasePath)
	dTDelta = getdouble("DELTAT.VALUE", strPhasePath)
	dVa		= getdouble("VA.VALUE", strPhasePath)
	dVe		= getdouble("VE.VALUE", strPhasePath)
	dSe		= getdouble("SE.VALUE", strPhasePath)
	strNextPhasePath = strProfilePath + "."+ nNextProfileIndex
	setdouble("TA.VALUE", strNextPhasePath, dTe)
	setdouble("VA.VALUE", strNextPhasePath, dVe)
	setdouble("SA.VALUE", strNextPhasePath, dSe)
	bDlgOK = 1
	if (((dVa < 0) and (dVe > 0)) or ((dVa > 0) and (dVe < 0)))
	{
		setstring("MESSAGE", "DLGDATA.DYNZYKLUS",translate("MSG_ZEROS_IN_V"))
		bDlgOK = 0
	}
	else
	{
		setstring("MESSAGE", "DLGDATA.DYNZYKLUS","")
	}
	if (dTDelta < 0)
	{
		setstring("MESSAGE", "DLGDATA.DYNZYKLUS",translate("MSG_POSVALUESONLY_IN_T"))
		bDlgOK = 0
	}
	if (bDlgOK == 0)
	{
		setstring("INPUT_FOCUS", "DLGDATA.DYNZYKLUS", eventPar)
	}
	setint("BDLGOK", "DLGDATA.DYNZYKLUS", bDlgOK)
	
	specialexec("DRAW_MP");
    CDialogBase	dlg;
    if (getstring("PREVMODIFIED", strPhasePath) != "")	{
		for (nRow = 2; nRow < 6; ++nRow)	{
			strElementIds += event + "_" + nRow + "_" + strCol + "|";
		}
		strElementIds += "IDC_DYNZYKLUS_IMG|IDC_INIT_MSG";
	}
	if (strElementIds != "")	{
		strResult = dlg.getDialogElementEx("IDD_DYNZYKLUS", strElementIds);
		nActCol = 0 + strCol;
		for (i = 3; i <= nActCol; ++i)	{
			strTmpProfilePath = strProfilePath + "." + (i - 3);
			strResult += dlg.updateTableCellClient("IDC_DYNZYKLUS_6_"  + i, getstring("QS.VALUE", strTmpProfilePath));
			strResult += dlg.updateTableCellClient("IDC_DYNZYKLUS_7_"  + i, getstring("QT.VALUE", strTmpProfilePath));
			strResult += dlg.updateTableCellClient("IDC_DYNZYKLUS_8_"  + i, getstring("TOTALCURVELENGTH.VALUE", strTmpProfilePath));
		}
		return strResult;
	}
	else
		return 2;
}


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	return onEditChanged();
}