// EASYGUITRANSFORM / EKEasyGuiTransform

#include "EASYGUITRANSFORM_BASE_OBJ"

class EasyGuiTransform : public EasyGuiTransformBaseObj
{
	// Diese 3 Werte mssen "eine Komponente lang" berleben, deshalb als Member
	var COMPONENT,EMPTY_ELEMENT,LENGTH;

	EasyGuiTransform()
	{
        // Basis-Konstruktor aufrufen
        EasyGuiTransformBaseObj();
	}


	handleEdit()
	{
		if(ATTR=="multiline" && VALUE=="true")
		{
			COMPONENT=replace(COMPONENT,"<input","<textarea");
			COMPONENT=replace(COMPONENT,"/>","></textarea>");
			COMPONENT=replace(COMPONENT,"value=","text=");
			COMPONENT=replace(COMPONENT,"!height","");
		}
	}


	handleButton()
	{
		if(ATTR=="top")
		{
			COMPONENT=replace(COMPONENT,'style="', 'style="position: absolute;');
		}
	}
	

	handleCombobox()
	{
		if(ATTR=="top")
		{
			COMPONENT=replace(COMPONENT,'style="', 'style="position: absolute;');
		}
/*
		else if(ATTR=="items")
		{
			OPTIONS="";
			ITEMS=VALUE+"|END";
			
			while(ITEMS!="" && split(ITEMS,ID,ITEMS,"=") && split(ITEMS,TXT,ITEMS,"|") )
			{
				OPTIONS+=<<|<option value="$ID$">$TXT$</option>|;
			}
			
			VALUE="";
			COMPONENT=replace(COMPONENT,"<option>&nbsp;</option>",OPTIONS);
		}
		else if(ATTR=="selected")
		{
			COMPONENT=replace(COMPONENT,<<|<option value="$VALUE$">|,<<|<option value="$VALUE$" SELECTED>|);
		}
*/
	}
	


	handleImage()
	{
		if(ATTR=="top")
		{
			COMPONENT=replace(COMPONENT,'style="', 'style="position: absolute;');
		}
	}
	
	
	handleText()
	{
		if(ATTR=="top")
		{
			COMPONENT=replace(COMPONENT,'style="', 'style="position: absolute;');
		}
	}


	labelLeft(COMPONENT)
	{
		return <<ENDHTML
		<table cellspacing="0" cellpadding="0" border="0" style="%styles%">
			<tr style="">
				<td>
					<table cellspacing="0" cellpadding="0" border="0">
						<tr >
							<td>
								<label id="%id%_LABEL" for="%id%" class="%labelstyle%" accesskey="%accesskey%" style="white-space:nowrap;">%text%</label>
							</td>
							<td>
								$COMPONENT$
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		ENDHTML;
	}


	labelRight(COMPONENT)
	{
		return <<ENDHTML
		<table cellspacing="0" cellpadding="0" border="0" style="%styles%">
			<tr style="">
				<td>
					<table cellspacing="0" cellpadding="0" border="0">
						<tr >
							<td>
								$COMPONENT$
							</td>
							<td>
								<label id="%id%_LABEL" for="%id%" class="%labelstyle%" accesskey="%accesskey%" style="white-space:nowrap;">%text%</label>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		ENDHTML;
	}
	

	handleCheckbox()
	{
		if(ATTR=="textposition")
		{
			COMPONENT=replace(COMPONENT,"{styles:","{styles:!position;");

			if (VALUE=="left")
				COMPONENT=labelLeft(COMPONENT);
			else
				COMPONENT=labelRight(COMPONENT);
		}
	}
	
	handleRadiobutton()
	{
		if(ATTR=="textposition")
		{
			// COMPONENT=replace(COMPONENT,"{styles}","{styles:!position}");
			COMPONENT=replace(COMPONENT,"{styles:","{styles:!position;");
			
			if (VALUE=="left")
				COMPONENT=labelLeft(COMPONENT);
			else
				COMPONENT=labelRight(COMPONENT);
		}
	}
	
	
	handleIFrame()
	{
		if(ATTR=="top")
		{
			COMPONENT=replace(COMPONENT,'style="', 'style="position: absolute;');
		}
	}
	
	initSpecialComponents()
	{
		// Handler fr Spezialkomponenten anmelden:
		// addHandler(COMPONENT_TAGNAME,HANDLERFUNCTION);
		//
		// COMPONENT_TAGNAME: Name der Komponente wie ind easygui/map/components.map
		// HANDLERFUNCTION: Funktionsname einer Memberfunktion ohne Parameter (als String!!!)
		// Wird COMPONENT_TAGNAME gefunden wird bei jedem Attribut HANDLERFUNCTION 
		// aufgerufen. Dabei werden diese Variablen gesetzt und wieder bernommen:
		// ATTR (Attributname), VALUE (Attributwert), COMPONENT (gesamte Komponente)
		
		// Submitfunktion ersetzen ohne in Gaetan's Scripten rumzupfuschen
		if(m_easyguiMode && getstring("CATALOG.NAME","ROOT")=="Danfoss Motion Controls")
		{
			// addAlias(alias,repl); // alias wird durch repl ersetzt
			addAlias("ekSubmit(","mySubmit("); // keine Limits also Vorsicht!!
		}
		
		// In "easygui/map/components.map" gibt es viele %name% Variablen die normalerweise
		// durch die entsprechenden Attribute ersetzt werden. Sind diese Attribute nicht
		// vorhanden so wird der Default verwendet oder %name% gelscht.
		// setDefaultValue(key, value);
		// setDefaultValue("width", "100"); // Im Zweifel 100 Pixel breit

		// Hawe easyguixp
		//addAlias("<", "\n<");
		/*
		addHandler("edit","handleEdit");
		addHandler("password","handleEdit");
		addHandler("textarea","handleEdit");
		addHandler("button","handleButton");
		addHandler("combobox","handleCombobox");
		addHandler("listbox","handleCombobox");
		addHandler("image","handleImage");
		addHandler("text","handleText");
		addHandler("iframe", "handleIFrame");
		*/
        //addHandler("edit","handleEdit");
		addHandler("checkbox","handleCheckbox");
		addHandler("radiobutton","handleRadiobutton");
	}
	
	
	
	// Spezielle Komponenten hinzufgen oder vorhandene ndern
	addUserComponents(aComponents)
	{
		if(m_easyguiXPMode)
		{
			var dialogCompont = aComponents['dialog'];
			
			if(dialogCompont.indexOf('onload="main();') > -1)
				aComponents['dialog'] = dialogCompont.replace('onload="', 'onload="eval(initFunctions);');
			else
				aComponents['dialog'] = dialogCompont.replace('%onload%', 'eval(initFunctions); %onload%');
		}
		
		aComponents['simpletable'] = <<ENDCOMPONENT
			<SPAN id="%id%_ALL_NODES" style="position:absolute; overflow:visible; width:0%; height:0%;">
			<div id='%id%' %attributes% sortarrowdown_img="%EK_PATH%/gfx/a-z.gif" sortarrowup_img="%EK_PATH%/gfx/z-a.gif" nosortarrow_img="%EK_PATH%/gfx/empty.gif"
				style="position:absolute;%styles%; overflow:auto;" %events%>
				<table border="0" id="%id%_TABLE" style="position:absolute;width: 100%" %events% cellspacing="0">%components%</table>
			</div>
			<input type="hidden" name="%id%" value="">
			<script type="text/javascript" src="%EK_PATH%/stable.js"></script>
			<script>initFunctions += "mySimpleTableInit('%id%');";</script>
			</SPAN>		
		ENDCOMPONENT;
	}
	
}




// main
{
	breakpoint("EASYGUITRANSFORM");
	setint("REQCOUNT","",1+getint("REQCOUNT",""));
	EasyGuiTransform guiTransform();
	return guiTransform.transform();  	// return Wert ist der Pfad zum erzeugten Html
}

