 {
	strKOId = getstring("SELKOSYS.ID", "DLGDATA.USER_KO")
#	print strKOId
	if (strKOId == "")
	{
		strKOId = "10063"
		dscopy(strKOId, "DLGDATA.USER_KO.SELKOSYS")
		setalias("SELKOSYS", "DLGDATA.USER_KO.SELKOSYS")
		setstring("X", "SELKOSYS", "X")
		setstring("Y", "SELKOSYS", "Y")
		setstring("Z", "SELKOSYS", "Z")
	}

	nAnzZyklen = 18
	nAnz = getsize("DLGDATA.MASSEN", "")
#	print nAnz
	strMPPath = "DLGDATA.DYNZYKLUS.PROFIL."

	for i = 0 to (nAnz - 1)
	{
		strSrcPath = "DLGDATA.MASSEN[" + i + "]"
		strDestPath = "TMPDATA.MASSEN[" + i + "]"
		for n = 0 to (nAnzZyklen - 1)
		{
			strSrcZyklusDatenPath = strSrcPath + ".ZYKLUSDATEN[" + n +"]"
			strDestZyklusDatenPath = strDestPath + ".ZYKLUSDATEN[" + n +"]"
			strActive = getstring("ACTIVE", strSrcZyklusDatenPath)
			strMasse = getstring("MASSE.RAW", strSrcPath)
			dQs	= getdouble("QS.VALUE", strMPPath + n)
			dQt	= getdouble("QT.VALUE", strMPPath + n)
			if ((strActive == "true") and (strMasse != "") and ((dQs > 0) or (dQt > 0)))
			{
				setstring("ACTIVE_", strDestZyklusDatenPath, "x")
			}
			else
			{
				setstring("ACTIVE_", strDestZyklusDatenPath, "")
			}
		}
	}
	bMttf = getstring("BMTTF", "DLGDATA.DATEN")
	nAnz = getsize("DLGDATA.DATEN_FW", "")
	if (bMttf == "true")
	{
		nStatus = getint("STATUS", "DLGDATA.DATEN")
		dMttf = getdouble("10015", "DLGDATA.DATEN.WAGEN")
		if ((dMttf != 0) and (isbitset(nStatus, 1) == 0) and (isbitset(nStatus, 4) == 0) and (isbitset(nStatus, 5) == 0))
		{
			for i = 0 to (nAnz - 1)
			{
				strSrcPath = "DLGDATA.DATEN_FW[" + i + "]"
				strDestPath = "TMPDATA.DATEN_FW[" + i + "]"
				setstring("MTTF_LAENGE.VALUE", strDestPath, getstring("MTTF_LAENGE.VALUE", strSrcPath))
				setstring("MTTF_ZEIT", strDestPath, getstring("MTTF_ZEIT", strSrcPath))
			}
		}
		else
		{
			for i = 0 to (nAnz - 1)
			{
				strDestPath = "TMPDATA.DATEN_FW[" + i + "]"
				setstring("MTTF_LAENGE.VALUE", strDestPath, "/")
				setstring("MTTF_ZEIT", strDestPath, "/")
#				print getstring("MTTF_ZEIT", strDestPath)
			}
		}

		setstring("MTTF_HEADER", "TMPDATA.DATEN", translate("TCH_MTTF"))
		strLMTTF = formatstring(getstring("LEBENSDAUER_LAENGE.UNIT.VALUE", "DLGDATA.DATEN"), "L<sub>MTTF</sub> [%s]")
		setstring("LMTTF_HEADER", "TMPDATA.DATEN", strLMTTF)
		strLHMTTF = "L<sub>h,MTTF</sub> [h]"
		setstring("LHMTTF_HEADER", "TMPDATA.DATEN", strLHMTTF)
	}
#	else
#	{
#		for i = 0 to (nAnz - 1)
#		{
#			strDestPath = "TMPDATA.DATEN_FW[" + i + "]"
#			setstring("MTTF_LAENGE.VALUE", strDestPath, "-")
#			setstring("MTTF_ZEIT", strDestPath, "-")
#		}
#	}

	nAnz = getsize("DLGDATA.KRAEFTE", "")
#	print nAnz
	for i = 0 to (nAnz - 1)
	{
		strSrcPath = "DLGDATA.KRAEFTE[" + i + "]"
		strDestPath = "TMPDATA.KRAEFTE[" + i + "]"
		for n = 0 to (nAnzZyklen - 1)
		{
			strSrcZyklusDatenPath = strSrcPath + ".ZYKLUSDATEN[" + n +"]"
			strDestZyklusDatenPath = strDestPath + ".ZYKLUSDATEN[" + n +"]"
			strActive = getstring("ACTIVE", strSrcZyklusDatenPath)
			if (strActive == "true")
			{
				setstring("ACTIVE_", strDestZyklusDatenPath, "x")
			}
			else
			{
				setstring("ACTIVE_", strDestZyklusDatenPath, "")
			}
		}
	}

	#Vmax, Amax bestimmen
	strProfilePath	= "DLGDATA.DYNZYKLUS.PROFIL"
	strSrcZyklusDatenPath = strProfilePath + "."
	dVMax = 0
	dAMax = 0
#	dXKoordFactor = getdouble("10080", "SELKOSYS")
#	print dXKoordFactor
#	if (dXKoordFactor < 0)
#	{
#		bRet = execute(strProfilePath, "REVERSESIGN")
#	}
	for n = 0 to (nAnzZyklen - 1)
	{
		dV = getdouble("VE.VALUE", strSrcZyklusDatenPath + n)
		dA = getdouble("AE.VALUE", strSrcZyklusDatenPath + n)
		if (abs(dV) > abs(dVMax))
		{
			dVMax = dV
			strVMax = getstring("VE.VALUE", strSrcZyklusDatenPath + n)
			strVMax = replace(strVMax, "-", "")
		}
		if (abs(dA) > abs(dAMax))
		{
			dAMax = dA
			strAMax = getstring("AE.VALUE", strSrcZyklusDatenPath + n)
			strAMax = replace(strAMax, "-", "")
		}
	}
	setstring("VMAX", "TMPDATA.DYNZYKLUS", strVMax)
	setstring("AMAX", "TMPDATA.DYNZYKLUS", strAMax)

	if (getstring("BTRAGZAHLABSCHLAG", "DLGDATA.DATEN") == "true")
	{
		setstring("BTRAGZAHLABSCHLAG","TMPDATA.DATEN", "x")
	}
	else	
	{
		setstring("BTRAGZAHLABSCHLAG","TMPDATA.DATEN", "")
	}

	// Vorspannung in Prozent
	// -mw- 15.11.2013: Vorspannung ist jetzt ein freier String
	// setdouble("10013", "TMPDATA.DATEN.WAGEN", (getdouble("10013", "DLGDATA.DATEN.WAGEN") * 100))
	setstring("10013", "TMPDATA.DATEN.WAGEN", getstring("10013", "DLGDATA.DATEN.WAGEN"));
}

