#include "CDialogBase.b"
#include "Kraefte.b"
#include "KraefteDynZyklus_Calc.b"
#include "KGTCalc.b"
#include "DatenAllg.b"
#include "4DMotionProfiler.b"

calcImage() {
	var profiler = new MotionProfiler();
	profiler.disableMasse();
	profiler.disableTitle();
	profiler.disableKoordSys();
	profiler.disableActiveFlag();
	profiler.setXLabel ("F");
	profiler.initData();
	profiler.calcStartPosition(300);
	profiler.waitForImage();

};

updateMotionProfile() {
	calcImage();
	var strImg = GetAbsPath("/EKTemp/",true) + "\\"+getstring("STARTPOSIMAGEFILE","DLGDATA.4DMOTION");
	strImg=strImg.replace ("\\","/");
	var strResult=<<|<input></input><script>document.getElementById("IDC_4DMOTION_PROFILE").src="";document.getElementById("IDC_4DMOTION_PROFILE").src="$strImg$";</script>|;
    return strResult;	
};


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");	// Internes Event
	if (strIntEvent == "INIT")	{
		initKraefte();	
		InitKraefteComboItems()
		F_Aequi = berechneFAequiInKGTKraefte();
		calcImage();
	}

    CDialogBase	dlg;
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	switch (event)	{
	case "IDC_KRAFT_UNIT_COMBO_T1_1":
		strUnitID = getstring("KRAFT.UNIT", "SELKRAFT")
		nAnz = getsize("DLGDATA.KRAEFTE", "")
		for i = 0 to (nAnz - 1)
		{
			strPath = "DLGDATA.KRAEFTE[" + i + "]"
			setstring("KRAFT.UNIT", strPath, strUnitID)
		}
		InitKraefteComboItems()
		strResult = dlg.getDialogElementEx("IDD_KGTKRAEFTEDYNZEITANTEILE", "IDC_KRAFTSCHWERPUNKT_EDIT_1_3|IDC_KRAEFTE_COMBO");
		return strResult;
		break;
	case "IDC_KRAFTSCHWERPUNKT_EDIT_1_3":
		clearResultsKGT();
		ClearResult();
	case "*.SELKRAFT.NAME":
		strResult=updateMotionProfile();
		InitKraefteComboItems()
		strResult += dlg.getDialogElementEx("IDD_KGTKRAEFTEDYNZEITANTEILE", "IDC_KRAEFTE_COMBO");
		return strResult;
		break;
	case "IDC_CALC_BUT":
		strResult=updateMotionProfile();
		F_Aequi = berechneFAequiInKGTKraefte();
		strResult += "<input></input>" + dlg.updateTableCellClient("IDC_KRAFTBELASTUNG", getstring("F_AEQUI_KRAEFTE.VALUE", "DLGDATA.KGTDATEN_KRAEFTE"));
		return strResult;
		break;
	case "IDC_KRAEFTE_COMBO":
		strSelKraftID = getstring("", "DLGDATA.SELKRAFTID")
		setalias("SELKRAFT", "DLGDATA.KRAEFTE[" + strSelKraftID + "]")
		InitKraefteComboItems()
		calcImage();
		// kein return -> kompletter Refresh!
		break;
	case "IDC_CONTINUE_BUT":
		F_Aequi = berechneFAequiInKGTKraefte();
		break;
	case "IDC_ALPHA_EDIT":
	case "IDC_BETA_EDIT":
	case "IDC_GAMMA_EDIT":		
		return updateMotionProfile();
		break;
	case "IDC_ENGLISCH_BUT":
		var bRet = changelanguage("EN"); // Muss hier umgeschaltet werden und nicht erst in Process.b um Comboboxen korrekt zu befuellen
		InitKraefteComboItems();
		break;
	case "IDC_DEU_BUT":
		var bRet = changelanguage("DE"); // s.o.
		InitKraefteComboItems();
		break;


	}
}