#include "CDialogBase.b"

class CSondermutterTable
{
	var m_strPath;
	
	CSondermutterTable(strPath)
	{
		init(strPath);
	}
	
	function	init(strPath)
	{
		m_strPath = (strPath == "") ? "DLGDATA.KGTDATEN.KGT_SONDER" : strPath;
	}
	
	function	buildTable()
	{
		var strRet = "";
		
		
		strRet += buildRowCombo(true,"10084","PM_ANTRIEBSART","DLGDATA.KGTDATEN.DLGSONDERMUTTER","","=|"+CreateCombobox1("XML","KGT","PM_ANTRIEBSART","1",'', "DLGDATA.KGTDATEN.DLGSONDERMUTTER", 'PM_BAUREIHE'));	// PM_ANTRIEBSART
 		//strRet += buildRow("10084","PM_ANTRIEBSART");	// PM_Antriebsart
		strRet += buildRowComboSubmit(true,"10085","PM_BAUREIHE","DLGDATA.KGTDATEN.DLGSONDERMUTTER","","=|"+CreateCombobox1("XML","KGT","PM_BAUREIHE","1",'', "DLGDATA.KGTDATEN.DLGSONDERMUTTER", 'PM_ANTRIEBSART'));	// PM_BAUREIHE
 		//strRet += buildRow("10085","PM_BAUREIHE");	// PM_Baureihe
		
		//strRet += buildRowCombo(true,"10086","PM_BR_MUTTER","",t);	// PM_BR_MUTTER
 		strRet += buildRow(true,"10086","PM_BR_MUTTER","");	// PM_BR_MUTTER
		strRet += buildRowUnit(true, "10013", "P_VORSPANNKLASSE_BEZ_C","","%");	// P_VORSPANNKLASSE_BEZ_C Vorspannklasse: Mu-Eingabe
		strRet += buildRowCombo(true,"10106","PM_KATEGORIE_VERTRIEB","DLGDATA.KGTDATEN.DLGSONDERMUTTER","",CreateCombobox1("XML","KGT","PM_KATEGORIE_VERTRIEB","1"));	// PM_KATEGORIE_VERTRIEB
 		//strRet += buildRow("10106","PM_KATEGORIE_VERTRIEB");	// PM_KATEGORIE_VERTRIEB
		//strRet += buildRow(true, "10014", "P_FV","");					// P_FV Vorspannkraft: Mu-Eingabe
		strRet += buildRow(true, "10087", "PM_D0","d<sub>0</sub>");				// PM_D0 Spindelkerndurchmesser d0: Mu-Eingabe
		strRet += buildRow(true, "10088", "PM_STEIGUNG","P");			// PM_STEIGUNG Spindelsteigung P: Mu-Einabe
		strRet += buildRow(false, "10089", "PM_DREHRICHTUNG","");		// PM_DREHRICHTUNG Drehrichtung: Kann-Eingabe
		strRet += buildRow(true, "10090", "P_DW","D<sub>w</sub>");					// P_DW Kugeldurchmesser Dw: Mu-Eingabe
		strRet += buildRow(false, "10091", "P_UML","i");				// P_UML i (Zahl der Umlufe): Kann-Eingabe
		strRet += buildRow(false, "10105", "PM_GAENGE_ANZ","b");			// PM_GAENGE_ANZ Zahl der tragenden Gnge: Kann-Eingabe
		strRet += buildRow(false, "10092", "P_MATERIALNR","");			// P_MATERIALNR Material-Nummer: Kann-Eingabe
		strRet += buildRow(true, "10016", "P_C","C");					// P_C Dynamische Tragzahl C: Mu-Eingabe
		strRet += buildRow(true, "10017", "P_C0","C<sub>0</sub>");					// P_C0 Statische Tragzahl C0: Mu-Eingabe
		strRet += buildRow(true, "10023", "P_VMAX_ZUL","v<sub>max,zul</sub>");	// P_VMAX_ZUL Maximal zulssige Geschwindigkiet vmax: Mu-Eingabe
		strRet += buildRow(true, "10061", "P_AMAX_ZUL","a<sub>max,zul</sub>");	// P_AMAX_ZUL Maximal zulssige Beschleunigung amax: Mu-Eingabe
		strRet += buildRow(true, "10093", "P_D2","d<sub>2</sub>");		// P_D2 Kerndurchmess d2: Mu-Eingabe
		strRet += buildRow(true, "10094", "P_L_GESAMT_KGT","L<sub>c</sub>");// P_L_GESAMT_KGT Gesamtlnge der KGT-Mutter: Mu-Eingabe
		strRet += buildRow(false, "10095", "P_MASSE_KGT_MUTTER","m<sub>Mutter</sub>");	// P_MASSE_KGT_MUTTER Masse der KGT-Mutter: Kann-Eingabe
		strRet += buildRow(false, "10100", "P_REIBMOM_KGT_MU","M<sub>Reib</sub>");	// P_REIBMOM_KGT_MU Reibmoment der KGT-Mutter: Kann-Eingabe
		//t=getstring("PM_BAUREIHE.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
		if (getstring("PM_BAUREIHE", "DLGDATA.KGTDATEN.DLGSONDERMUTTER")=="Antriebseinheit FAR") {
			strRet += buildRow(true, "10098", "P_MASSENTRAEGHEIT_KGT","J");	// P_MASSENTRAEGHEIT_KGT Massentrgheit der KGT-Mutter [nur bei Auswahl der Antriebseiheit FAR]: Mu-Eingabe
		} else {
			//setstring("P_SPEZ_TRAEGHEIT_SPINDEL_KGT" + ".UNIT.RAW", m_strPath,"14835");
			strRet += buildRow(true, "10099", "P_SPEZ_TRAEGHEIT_SPINDEL","");//P_SPEZ_TRAEGHEIT_SPINDEL_KGT Spez. Massentrgheit der Spindel [nicht bei einer FAR]: Mu-Eingabe
		};
		
		
		strRet += buildRow(false, "10103", "P_STEIFIGKEIT_KGT","");		// P_STEIFIGKEIT_KGT Steifigkeit der KGT-Mutter: Kann-Eingabe

		if (getbool("BSPINDELUNTERSTUETZUNG","DLGDATA.KGTSYSTEM"))	{
			strRet += buildRow(false, "10097", "P_MASSE_SPU","");			// P_MASSE_SPU Masse einer SPU: Kann-Eingabe
			strRet += buildRow(false, "10111", "PM_LNSPU4","");	// PM_LNSPU4 LN 4 x SPU: Kann-Eingabe
			strRet += buildRow(false, "10110", "PM_LNSPU3","");	// PM_LNSPU3 LN 3 x SPU: Kann-Eingabe
			strRet += buildRow(false, "10109", "PM_LNSPU2","");	// PM_LNSPU2 LN 2 x SPU: Kann-Eingabe
			strRet += buildRow(false, "10108", "PM_LNSPU1","");	// PM_LNSPU1 LN 1 x SPU: Kann-Eingabe
			strRet += buildRow(false, "10107", "PM_LNSPU0","");	// PM_LNSPU0 LN 0 x SPU: Kann-Eingabe
		}
		strRet += buildRow(false, "NAME", "NAME","");

		return strRet;
	}
	
	function buildRow(bMandatory, strAttrID, strAttrName, strSymbol)
	{
		var strRet;
		var strImg = bMandatory ? "/EKImage/Mandatory.png" : "/EKImage/NonMandatory.png";
		var strMandatory = bMandatory ? "mandatory=\"true\"" : "";
		var t=getstring(strAttrName + ".UNIT.VALUE", m_strPath);
		var brackOpen,brackClose;
		if (getstring(strAttrName + ".UNIT.VALUE", m_strPath)!="" ){
			brackOpen="[";
			brackClose="]";
		} else {
			brackOpen="";
			brackClose="";

		};
		
		strRet =<<|<tr>
			<td width="30"><image image="$strImg$"/></td>
			<td text="$TranslateEx(strAttrID)$"/>
			<td text="$strSymbol$"/>
			<td width="80"><edit id="*.$m_strPath$.$strAttrName$.VALUE" $strMandatory$ width="140" text="$getstring(strAttrName + ".VALUE", m_strPath)$"/></td>
			<td text="$brackOpen$$getstring(strAttrName + ".UNIT.VALUE", m_strPath)$$brackClose$" width="80"/>
			</tr>|;
		return strRet;
	}
	function buildRowUnit(bMandatory, strAttrID, strAttrName, strSymbol,strUnit)
	{
		var strRet;
		var strImg = bMandatory ? "/EKImage/Mandatory.png" : "/EKImage/NonMandatory.png";
		var strMandatory = bMandatory ? "mandatory=\"true\"" : "";
		var t=getstring(strAttrName + ".UNIT.VALUE", m_strPath);
		var brackOpen,brackClose;
		if (strUnit!="" ){
			brackOpen="[";
			brackClose="]";
		} else {
			brackOpen="";
			brackClose="";

		};
		
		strRet =<<|<tr>
			<td width="30"><image image="$strImg$"/></td>
			<td text="$TranslateEx(strAttrID)$"/>
			<td text="$strSymbol$"/>
			<td width="80"><edit id="*.$m_strPath$.$strAttrName$.VALUE" $strMandatory$ width="140" text="$getstring(strAttrName + ".VALUE", m_strPath)$"/></td>
			<td text="$brackOpen$$strUnit$$brackClose$" width="80"/>
			</tr>|;
		return strRet;
	}
	
	      
	function buildRowCombo(bMandatory,strAttrID, strAttrName, strPath, strSymbol,strComboFill)
	{
		var strRet;
		var strImg = bMandatory ? "/EKImage/Mandatory.png" : "/EKImage/NonMandatory.png";
		var strMandatory = bMandatory ? "mandatory=\"true\"" : "";
		strRet =<<|<tr>
			<td width="30"><image image="$strImg$"/></td>
			<td text="$TranslateEx(strAttrID)$"/>
			<td text="$strSymbol$"/>
			<td width="80"><combobox id="*.$strPath$.$strAttrName$" $strMandatory$ width="144" items="$strComboFill$" selected="\$*.$strPath$.$strAttrName$\$" onchanged="ekSubmitUpdateElement(this.id, this);"/></td>			
			<td width="80"/>
			</tr>|;
		return strRet;		
	}
	
	function buildRowComboSubmit(bMandatory,strAttrID, strAttrName,strPath,  strSymbol,strComboFill)
	{
		var strRet;
		var strImg = bMandatory ? "/EKImage/Mandatory.png" : "/EKImage/NonMandatory.png";
		var strMandatory = bMandatory ? "mandatory=\"true\"" : "";
		strRet =<<|<tr>
			<td width="30"><image image="$strImg$"/></td>
			<td text="$TranslateEx(strAttrID)$"/>
			<td text="$strSymbol$"/>
			<td width="80"><combobox id="*.$strPath$.$strAttrName$" $strMandatory$ width="144" items="$strComboFill$" selected="\$*.$strPath$.$strAttrName$\$" onchanged="ekSubmit(this);return false"/></td>			
			<td width="80"/>
			</tr>|;
		return strRet;		
	}
	
	
	
	function buildRow(strAttrID,strAttrName)
	{
		var strRet;
		strRet =<<|<tr>
			<td width="30"/>
			<td text="$TranslateEx(strAttrID)$"/>
			<td/>
			<td width="140" text="$getstring(strAttrName + ".VALUE", m_strPath)$" colspan="2"/>
			</tr>|;
		return strRet;
	}
};

function	initKGTSondermutter()
{
	if (getstring("ID", "DLGDATA.KGTDATEN.KGT_SONDER") == "" )	{
		dscopy("KGT", "DLGDATA.KGTDATEN.KGT_SONDER");
	};
	delete ("DLGSONDERMUTTER","DLGDATA.KGTDATEN");
	bRet = createobject("DLGDATA.KGTDATEN","DLGSONDERMUTTER",1);
	
	//var antrieb=getstring("PM_ANTRIEBSART.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
	//var baureihe=getstring("PM_BAUREIHE.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
	var vertrieb=getstring("PM_KATEGORIE_VERTRIEB.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
	
	
	//setstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN.DLGSONDERMUTTER",antrieb);
	//setstring("PM_BAUREIHE", "DLGDATA.KGTDATEN.DLGSONDERMUTTER",baureihe);
	setstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN.DLGSONDERMUTTER",vertrieb);
	setstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN.DLGSONDERMUTTER", getstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN"));
	setstring("PM_BAUREIHE", "DLGDATA.KGTDATEN.DLGSONDERMUTTER", getstring("PM_BAUREIHE", "DLGDATA.KGTDATEN"));
	
	//setstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN.KGT_SONDER", getstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN"));
	//setstring("PM_BR_MUTTER", "DLGDATA.KGTDATEN.KGT_SONDER", getstring("PM_BR_MUTTER", "DLGDATA.KGTDATEN"));
	//setstring("PM_BR_MUTTER_ART.RAW", "DLGDATA.KGTDATEN.KGT_SONDER", getstring("PM_BR_MUTTER_ART", "DLGDATA.KGTDATEN"));
	//if (getstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN")=="") {
	//	setdouble("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN.KGT_SONDER", getstring("P_VORSPANNKLASSE_BEZ_C", "DLGDATA.KGTDATEN"));
	//};
	
}

function	buildSondermutterTable()
{
	CSondermutterTable	SMTable("");
	return SMTable.buildTable();
}
function	UebernehmeSondermutter()
{
	var antrieb=getstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN.DLGSONDERMUTTER");
	var baureihe=getstring("PM_BAUREIHE", "DLGDATA.KGTDATEN.DLGSONDERMUTTER");
	var vertrieb=getstring("PM_KATEGORIE_VERTRIEB", "DLGDATA.KGTDATEN.DLGSONDERMUTTER");
	
	setstring ("PM_ANTRIEBSART.RAW","DLGDATA.KGTDATEN.KGT_SONDER",antrieb);
	setstring ("PM_BAUREIHE.RAW","DLGDATA.KGTDATEN.KGT_SONDER",baureihe);
	setstring ("PM_KATEGORIE_VERTRIEB.RAW","DLGDATA.KGTDATEN.KGT_SONDER",vertrieb);
	//setstring ("PM_STEIGUNG","DLGDATA.KGTDATEN",formatstring(getdouble ("PM_STEIGUNG.VALUE","DLGDATA.KGTDATEN.KGT_SONDER"),'%.0f'));
	setstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN", getstring("PM_ANTRIEBSART.RAW", "DLGDATA.KGTDATEN.KGT_SONDER"));
	setstring("PM_BAUREIHE", "DLGDATA.KGTDATEN", getstring("PM_BAUREIHE.RAW", "DLGDATA.KGTDATEN.KGT_SONDER"));
	setstring ("ID","DLGDATA.KGTDATEN.KGT_SONDER","SONDER");
	// Vorspannkraft berechnen
	var C	= getdouble("P_C.BASE","DLGDATA.KGTDATEN.KGT_SONDER");
	var Vorspannung = getdouble("P_VORSPANNKLASSE_BEZ_C.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
	
	var F_V=Vorspannung*C/100.0;
	setdouble ("P_FV.BASE","DLGDATA.KGTDATEN.KGT_SONDER",F_V);
}

function onComboChange(event) {
	CDialogBase	dlg;
	strResult = dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.DLGSONDERMUTTER.PM_ANTRIEBSART", "=|" + CreateCombobox1('XML', 'KGT', 'PM_ANTRIEBSART', 1, '', "DLGDATA.KGTDATEN.DLGSONDERMUTTER", 'PM_BAUREIHE'), getstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN.DLGSONDERMUTTER"));
	strResult += dlg.setComboItemsAndValue("*.DLGDATA.KGTDATEN.DLGSONDERMUTTER.PM_BAUREIHE", "=|" + CreateCombobox1('XML', 'KGT', 'PM_BAUREIHE', 1, '', "DLGDATA.KGTDATEN.DLGSONDERMUTTER", 'PM_ANTRIEBSART'), getstring("PM_BAUREIHE", "DLGDATA.KGTDATEN.DLGSONDERMUTTER"));
	return strResult;
};
	
function main()
{
	strIntEvent = getstring("EVENT", "");	// Internes Event
	if (strIntEvent == "INIT")	{
		initKGTSondermutter();
	}
    CDialogBase	dlg;
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	strResult = "<input></input>";
	var aa=getstring("PM_ANTRIEBSART.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
	var br=getstring("PM_BAUREIHE.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
	setstring("PM_ANTRIEBSART", "DLGDATA.KGTDATEN.KGT_SONDER.COMBOS",aa);
	setstring("PM_BAUREIHE", "DLGDATA.KGTDATEN.KGT_SONDER.COMBOS",br);
	
	var vt=getstring("PM_KATEGORIE_VERTRIEB.RAW", "DLGDATA.KGTDATEN.KGT_SONDER");
	
	switch (event)	{
	case "IDC_SAVE_BUT":
		strRetPath = filedialog(0, "ksm", "", "Project Files (*.ksm)|*.ksm|All Files(*.*)|*.*|", "");
		if (strRetPath != "")
		{
			File=new FileName(strRetPath);
			Name=File.getFullName();
			setstring ("FILENAME","DLGDATA.KGTDATEN.KGT_SONDER",Name);
			savexml("DLGDATA.KGTDATEN.KGT_SONDER", strRetPath);
		}
		// return 2;
		break;
	case "IDC_LOAD_BUT":
		strRetPath = filedialog(1, "ksm", "", "Project Files (*.ksm)|*.ksm|All Files(*.*)|*.*|", "");
		if (strRetPath != "")
		{
			var isAGK=(getstring("PM_BAUREIHE.RAW", "DLGDATA.KGTDATEN.KGT_SONDER")=="Antriebseinheit AGK");
			
			// Wenn Antriebseinheit AGK, dann duerfen auch nur Files mit Antrieb AGK nachgeladen werden
			if (isAGK) {
				loadxml("DLGDATA.KGTDATEN.KGT_SONDER_TEST", strRetPath);
				if (getstring("PM_BAUREIHE.RAW", "DLGDATA.KGTDATEN.KGT_SONDER_TEST")!="Antriebseinheit AGK") {
					setstring ("BMSG_AGK_ONLY","DLGDATA.KGTDATEN.KGT_SONDER","true");
				} else {
					loadxml("DLGDATA.KGTDATEN.KGT_SONDER", strRetPath);
					setstring ("BMSG_AGK_ONLY","DLGDATA.KGTDATEN.KGT_SONDER","false");
				};
				delete ("KGT_SONDER_TEST","DLGDATA.KGTDATEN");
			} else {
				loadxml("DLGDATA.KGTDATEN.KGT_SONDER", strRetPath);
			};
			
			
			File=new FileName(strRetPath);
			Name=File.getFullName();
			setstring ("FILENAME","DLGDATA.KGTDATEN.KGT_SONDER",Name);
		}
/*		
		strResult += dlg.getDialogElementEx("IDD_KGTSONDERMUTTER", "IDC_ATTRIBUTESTATIC_TABLE|IDC_ATTRIBUTE_TABLE");
		return strResult;
*/		
		break;
	case "IDC_UEBERNEHMEN_BUT":
		UebernehmeSondermutter();
		break;
		
	case "IDC_UEBERNEHMESTANDARD_BUT":
		copy("DLGDATA.KGTDATEN.KGT_STANDARD", "DLGDATA.KGTDATEN.KGT_SONDER");
		break;
	case "*.DLGDATA.KGTDATEN.DLGSONDERMUTTER.PM_ANTRIEBSART":
	case "*.DLGDATA.KGTDATEN.DLGSONDERMUTTER.PM_BAUREIHE":
	case "*.DLGDATA.KGTDATEN.DLGSONDERMUTTER.PM_KATEGORIE_VERTRIEB":
		return onComboChange(event);
		break;
	}
}
