// Achsenbezeichnung und Richtung unter Berucksichtigung des User Koordinatensystems ermitteln
// und fuer Ausdruck in Store ablegen
processUserCoordSysData() {
	var coord_label=new Array();
	var coord_dir=new Array();
		
	var dir_x=getdouble ("10053","SELKOSYS");
	var dir_y=getdouble ("10054","SELKOSYS");
	var dir_z=getdouble ("10055","SELKOSYS");
		
	var org_x=getstring ("10050","SELKOSYS"); // Welche urspruenglich Achse entspricht der aktuellen X-Achse
	var org_y=getstring ("10051","SELKOSYS");
	var org_z=getstring ("10052","SELKOSYS");
		
	coord_label[org_x]='X';
	coord_label[org_y]='Y';
	coord_label[org_z]='Z';
		
	coord_dir[org_x]=dir_x;
	coord_dir[org_y]=dir_y;
	coord_dir[org_z]=dir_z;
		
	// Neue Achsenbeschriftung im Store ablegen
	setstring ("KOORD_LABEL_X","DLGDATA.KGTDATEN.DATENBLATT",coord_label['X']);
	setstring ("KOORD_LABEL_Y","DLGDATA.KGTDATEN.DATENBLATT",coord_label['Y']);
	setstring ("KOORD_LABEL_Z","DLGDATA.KGTDATEN.DATENBLATT",coord_label['Z']);
		
	// Achsenrichtung
	setstring ("KOORD_DIR_X","DLGDATA.KGTDATEN.DATENBLATT",coord_dir['X']);
	setstring ("KOORD_DIR_Y","DLGDATA.KGTDATEN.DATENBLATT",coord_dir['Y']);
	setstring ("KOORD_DIR_Z","DLGDATA.KGTDATEN.DATENBLATT",coord_dir['Z']);
	
	return ({"label": coord_label,
			"dir" : coord_dir});
	};
	
		