#include "CDialogBase.b"
#include "Massen.b"
#include "MassenDynZyklus_Calc.b"
#include "DatenAllg.b"


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
	strIntEvent = getstring("EVENT", "");	// Internes Event
	if (strIntEvent == "INIT")	{
		initMassen();	
		InitMassenComboItems();
		specialexec("DRAW_MP");
		TransferAxAlleMassen(false);
		specialexec("CALC_MASSENKRAEFTE");
		MassenDynZyklus_Calc();
	}

    CDialogBase	dlg;
	event		= getstring("EKSUBMITEVENT","")		# Event aus der aktuellen Maske
	switch (event)	{
	case "IDC_MASSE_UNIT_COMBO":
		strUnitID = getstring("MASSE.UNIT", "SELMASSE")
		nAnz = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnz - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			setstring("MASSE.UNIT", strPath, strUnitID)
		}
		InitMassenComboItems(); 
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZEITANTEILE", "IDC_MASSENSCHWERPUNKT_EDIT_1_2|IDC_MASSEN_COMBO");
		return strResult;
		break;
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_2":
		clearResultsKGT(); // KGT Ergebnisse nur bei Massenaenderugen ruecksetzen
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_3":
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_4":
	case "IDC_MASSENSCHWERPUNKT_EDIT_1_5":
		ClearResult();
	case "IDC_MASSENNAME_EDIT":
		InitMassenComboItems();
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZEITANTEILE", "IDC_MASSEN_COMBO");
		return strResult;
		break;
	case "IDC_MASSENSCHWERPUNKT_T1_1_UNIT_COMBO":
		strUnitID = getstring("KOORD.UNIT", "SELMASSE")
		nAnzMassen = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnzMassen - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			setstring("KOORD.UNIT", strPath, strUnitID)
		}
		InitMassenComboItems();
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZEITANTEILE", "IDC_MASSENSCHWERPUNKT_EDIT_1_3|IDC_MASSENSCHWERPUNKT_EDIT_1_4|IDC_MASSENSCHWERPUNKT_EDIT_1_5|IDC_MASSEN_COMBO");
		strUnit = "[" + getstring("KOORD.UNIT.VALUE", "SELMASSE") + "]";
		strResult += dlg.updateTableCellClient("IDC_MASSENSCHWERPUNKT_T1_2", strUnit);
		strResult += dlg.updateTableCellClient("IDC_MASSENSCHWERPUNKT_T1_3", strUnit);
		return strResult;
		break;
	case "IDC_MASSEN_BESCHLEUNIGUNGX_PHASE_UNIT_COMBO":
		strUnitID = getstring("A_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL")
		nAnzMassen = getsize("DLGDATA.MASSEN", "")
		for i = 0 to (nAnzMassen - 1)
		{
			strPath = "DLGDATA.MASSEN[" + i + "]"
			nAnzZyklen = getsize(strPath + ".ZYKLUSDATEN", "")
			for n = 0 to (nAnzZyklen - 1)
			{
				strZyklusDatenPath = strPath + ".ZYKLUSDATEN[" + n +"]"
				setstring("A.UNIT", strZyklusDatenPath, strUnitID)
			}
		}
		
	
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZEITANTEILE", "IDC_MASSENNDYN_TAB");
		
		return strResult;
		break;
	case "IDC_CALC_BUT":
		TransferAxAlleMassen(false);
		specialexec("CALC_MASSENKRAEFTE");
		MassenDynZyklus_Calc();
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZEITANTEILE", "IDC_KRAFTBELASTUNG_TAB|IDC_MOMENTBELASTUNG_TAB");
		return strResult;
		break;
	case "IDC_MASSEN_COMBO":
		InitMassenComboItems(); 
		strSelMasseID = getstring("", "DLGDATA.SELMASSEID")
		TransferAxAlleMassen(false);
		setalias("SELMASSE", "DLGDATA.MASSEN[" + strSelMasseID + "]")
		
		// kein return -> kompletter Refresh!
		break;
		
	// Massenbersicht anzeigen!	
	case "IDC_MASSENUEBERSICHT_BUT":
	
		//CDialogBase	dlg;
		strResult = dlg.getDialogElementEx("IDD_MASSENDYNZEITANTEILE", "IDC_MASSENUEBERSICHT_TAB");
		return strResult;

		break;
	case "IDC_ENGLISCH_BUT":
		var bRet = changelanguage("EN"); // Muss hier umgeschaltet werden und nicht erst in Process.b um Comboboxen korrekt zu befuellen
		InitMassenComboItems();
		break;
	case "IDC_DEU_BUT":
		var bRet = changelanguage("DE"); // s.o.
		InitMassenComboItems();
		break;
	
	}
}