writeMassenResults()
{
	dFSAnz	= getdouble("10002", "DLGDATA.SYSTEM")
	dFWAnz	= getdouble("10001", "DLGDATA.SYSTEM")
	dAlpha	= getdouble("10003.VALUE", "DLGDATA.SYSTEM")
	dBeta	= getdouble("10004.VALUE", "DLGDATA.SYSTEM")
	dLY		= getdouble("10005.RAW", "DLGDATA.SYSTEM")
	dLZ		= getdouble("10006.RAW", "DLGDATA.SYSTEM")
	dLW1	= getdouble("10007.RAW", "DLGDATA.SYSTEM")
	dLW2	= getdouble("10008.RAW", "DLGDATA.SYSTEM")
	dLS		= getdouble("10009.RAW", "DLGDATA.SYSTEM")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "SystemDaten:\r\n", "")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "FS-Anz:\t" + dFSAnz + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "FW-Anz:\t" + dFWAnz + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "Alpha:\t" + dAlpha + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "Beta:\t" + dBeta + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "LY:\t" + dLY + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "LZ:\t" + dLZ + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "LW1:\t" + dLW1 + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "LW2:\t" + dLW2 + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "LS:\t" + dLS + "\r\n", "a")
	writefile(".\\debug\\MassenDynZyklusCalc.txt", "\r\nBerechnungen:\r\n", "a")

	nAnzZyklen = getsize("DLGDATA.MASSENCALC", "")
	for i = 0 to (nAnzZyklen - 1)
	{
		pathCalcData = "DLGDATA.MASSENCALC[" + i + "]"
		Fx = getdouble("F.X.RAW", pathCalcData)
		Fy = getdouble("F.Y.RAW", pathCalcData)
		Fz = getdouble("F.Z.RAW", pathCalcData)
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft Fx:\t" + Fx + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft Fy:\t" + Fy + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tResultierende Kraft Fz:\t" + Fz + "\r\n", "a")
		
		Mx = getdouble("MOMENT.X.RAW", pathCalcData)
		My = getdouble("MOMENT.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENT.Z.RAW", pathCalcData)
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) Mx:\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (ohne Antrieb) Mz:\t" + Mz + "\r\n", "a")

		Mx = getdouble("MOMENTANTRIEB.X.RAW", pathCalcData)
		My = getdouble("MOMENTANTRIEB.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENTANTRIEB.Z.RAW", pathCalcData)
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment Antrieb Mx (nur zur Info):\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment Antrieb My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment Antrieb Mz:\t" + Mz + "\r\n", "a")

		Mx = getdouble("MOMENTMITANTRIEB.X.RAW", pathCalcData)
		My = getdouble("MOMENTMITANTRIEB.Y.RAW", pathCalcData)
		Mz = getdouble("MOMENTMITANTRIEB.Z.RAW", pathCalcData)
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) Mx:\t" + Mx + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) My:\t" + My + "\r\n", "a")
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "\tMoment (mit Antrieb) Mz:\t" + Mz + "\r\n", "a")

		writefile(".\\debug\\MassenDynZyklusCalc.txt", "\r\nKraefte auf Fuehrungswagen:\r\n", "a")
		for n = 0 to (dFWAnz - 1)
		{
			pathFW = pathCalcData +".FW[" + n + "]"

			FSeitl		= getdouble("FSEITL.RAW", pathFW)
			FZugDruck	= getdouble("FZUGDRUCK.RAW", pathFW)
			FExtern		= getdouble("FEXTERN.RAW", pathFW)
			writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "," + (n+1) + "\tFSeitl:\t" + FSeitl + "\r\n", "a")
			writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "," + (n+1) + "\tFZugDruck:\t" + FZugDruck + "\r\n", "a")
			writefile(".\\debug\\MassenDynZyklusCalc.txt", "Zykl. " + (i+1) + "," + (n+1) + "\tFExtern:\t" + FExtern + "\r\n", "a")
		}
		writefile(".\\debug\\MassenDynZyklusCalc.txt", "\r\n", "a")
	}
}

MassenDynZyklus_Calc()
{
	dFSAnz = getdouble("10002", "DLGDATA.SYSTEM")
	dFWAnz = getdouble("10001", "DLGDATA.SYSTEM")
#	print dFWAnz

	nAnzZyklen = getsize("DLGDATA.MASSENCALC", "")
#	print nAnzZyklen

	for n = 0 to (dFWAnz - 1)
	{
		FAequi = 0
		for i = 0 to (nAnzZyklen - 1)
		{
			pathCalcData = "DLGDATA.MASSENCALC[" + i + "].FW[" + n + "]"
			FExt = getdouble("FEXTERN.RAW", pathCalcData)
#			print FExt
			pathZyklus = "DLGDATA.DYNZYKLUS.PROFIL." + i
			Qs = getdouble("QS.VALUE", pathZyklus)
			if ((FExt > 0) and (Qs > 0))
			{
				FAequi = FAequi + FExt * FExt * FExt * Qs
			}
		}
#		print FAequi
		FAequi = root((FAequi/100), 3)
		pathFW = "DLGDATA.MASSEN_FW[" + n + "]"
		strProfID = getstring("FAEQUI.PROFILEID", pathFW)
		if (strProfID == "")	
		{
			# Techwert erzeugen
			dRet = createobject(pathFW, "FAEQUI", 49)
			if (dRet == 0)
			{
				print("Error!")
			}
			# Einheitenprofil (Kraft) zuweisen
			setstring("FAEQUI.PROFILEID", pathFW, "11")
		}
#		print FAequi
		setdouble("FAEQUI.RAW", pathFW, FAequi)
		setstring("id", pathFW, n)
		setstring("text", pathFW, (translate("FW") + " " + (n + 1)))
#		print FAequi
#		print getdouble("FAEQUI.VALUE", pathFW)
	}

	# Komponenten von MAequi berechnen
	MAequiX = 0
	MAequiY = 0
	MAequiZ = 0

	for i = 0 to (nAnzZyklen - 1)
	{
		# fuer jeden Zyklus berechnetes Moment mit Beruecksichtigung des Antriebs ausm Store holen
		pathCalcData = "DLGDATA.MASSENCALC[" + i + "]"
		MZyklX = getdouble("MOMENTMITANTRIEB.X.RAW", pathCalcData)
		MZyklY = getdouble("MOMENTMITANTRIEB.Y.RAW", pathCalcData)
		MZyklZ = getdouble("MOMENTMITANTRIEB.Z.RAW", pathCalcData)
#		print MZyklX
#		print MZyklY
#		print MZyklZ
		MZyklX = abs(MZyklX)
		MZyklY = abs(MZyklY)
		MZyklZ = abs(MZyklZ)

		# Qs aus Zyklusdaten ausm Store holen
		pathZyklus = "DLGDATA.DYNZYKLUS.PROFIL." + i
		Qs = getdouble("QS.VALUE", pathZyklus)

		MAequiX = MAequiX + MZyklX * MZyklX * MZyklX * Qs
		MAequiY = MAequiY + MZyklY * MZyklY * MZyklY * Qs
		MAequiZ = MAequiZ + MZyklZ * MZyklZ * MZyklZ * Qs
	}
	MAequiX = root((MAequiX/100), 3)
	MAequiY = root((MAequiY/100), 3)
	MAequiZ = root((MAequiZ/100), 3)

	pathMomente = "DLGDATA.MASSEN_MOMENTE"
	strProfID = getstring("MAEQUI.PROFILEID", pathMomente)
	if (strProfID == "")	
	{
		# 3-dim Vektor erzeugen
		dRet = createobject(pathMomente, "MAEQUI", 63)
		if (dRet == 0)
		{
			print("Error!")
		}
		# Einheitenprofil (Drehmoment) zuweisen
		setstring("MAEQUI.PROFILEID", pathMomente, "10007")
	}
	# berechnete Komponenten im Vektor speichern
	setdouble("MAEQUI.X.RAW", pathMomente, MAequiX)
	setdouble("MAEQUI.Y.RAW", pathMomente, MAequiY)
	setdouble("MAEQUI.Z.RAW", pathMomente, MAequiZ)

#	savexml("DLGDATA","test.xml")
#	loadxml("DLGDATA","test.xml")
#	savexml("DLGDATA","test2.xml")

#	writeMassenResults()
}
