# Abhaengig von der gewaehlten Anwendung werden die entsprechende Skripte zum Drucken aufgerufen

#include "Init_Datenblatt.b"
#include "ProjectList_Datenblatt.b"
#include "LFInit_Datenblatt.b"
#include "LFProjectList_Datenblatt.b"
#include "KGTProjectList_Datenblatt.b"

{
	getEinschaltdauer();
	switch (getint("CURRENTBRANCH", ""))	{
				case 0:// Profilschienen
					ProjectList_Datenblatt();
					break;
				case 1:// KGT
					KGTProjectList_Datenblatt();
					break;
				case 2:// LF
					LFProjectList_Datenblatt();
					break;
			};
  
}
// Einschaltdauer der Achsen ermitteln und in Store Variable fuer Ausdruck uebertragen
getEinschaltdauer() {
 switch (getstring("EINGABEART","DLGDATA")) {
	case "STRECKENANTEILE":
		getEinschaltdauerDynStrecken();
		break;
	case "DYNAMIKZYKLUS":
		getEinschaltdauerDynzyklus();
		break;
	case "ZEITANTEILE":
		getEinschaltdauerDynZeitanteile();
		break;
 }
};

getEinschaltdauerDynzyklus() {
  var t_gesamt;
  var t_moving;
  var s;
  var t;
  // Zahl der Zyklen im Bewegungsablauf bestimmen
  var anzZyklen=18;
  for (var i=0;i<anzZyklen;i++) {
	s=getstring("DELTAS.RAW","DLGDATA.DYNZYKLUS.PROFIL."+i);
	t=getdouble("DELTAT.VALUE","DLGDATA.DYNZYKLUS.PROFIL."+i);
	t_gesamt+=t;
	if (s!="" && s!=0) {
		t_moving+=t;
	};
  };
  var einschaltdauer=t_moving/t_gesamt*100.0;
  setdouble("EINSCHALTDAUER","DATENBLATT",einschaltdauer);
};
getEinschaltdauerDynZeitanteile() {
 var q_einschalt;
 var v;
 var qt;
  
  // Zahl der Zyklen im Bewegungsablauf bestimmen
  var anzZyklen=18;
  for (var i=0;i<anzZyklen;i++) {
	v=getdouble("VM.RAW","DLGDATA.DYNZYKLUS.PROFIL."+i);
	qt=getdouble ("QT","DLGDATA.DYNZYKLUS.PROFIL."+i);
	
	if (v!="" && v!=0) {
		q_einschalt+=qt;
	};
  };
  
  setdouble("EINSCHALTDAUER","DATENBLATT",q_einschalt);
  
};
getEinschaltdauerDynStrecken() {
	setdouble("EINSCHALTDAUER","DATENBLATT",getdouble("EINSCHALTDAUER", "DLGDATA.DYNSTRECKEN"));
};