#include "CDialogBase.b"

function GetAliasDir (aliasname) {
	var result="";
	var AliasConfig=Object.fromStorage("ROOT.CATALOG.ALIAS");
	for (var i=0;i<AliasConfig.length;i++) {
		if (AliasConfig[i].NAME==aliasname) {
			result=AliasConfig[i].PATH;
			break;
		};
	};
	return result;
};


//////////////////////////////////////////////////////////////////
// MAIN-Block
{
    event       = getstring("EKSUBMITEVENT",    "");
    // print event;
	strIntEvent		= getstring("EVENT","")		
	
    CDialogBase	dlg;
	switch (event)
	{
	case "HELPFILE":
		var helpfile=dsgetstring('10082.VALUE','11783');
		helpfile=replace (helpfile,"/EKCatHelp/","");
		var d=GetAliasDir ("EKCatHelp");
		d=replace(d,"/","\\");
		var pdfFile=d+"\\"+helpfile;
		shellexecute (pdfFile,"","");
		break;
	case "HELPFILE_KGT":
		var helpfile=dsgetstring('10082.VALUE','11783');
		helpfile=replace (helpfile,"/EKCatHelp/","");
		var d=GetAliasDir ("EKCatHelp");
		d=replace(d,"/","\\");
		var pdfFile=d+"\\"+helpfile;
		pdfFile=replace(pdfFile,".pdf","_KGT.pdf");
		shellexecute (pdfFile,"","");
		break;
	case "IMPRESSUMFILE":
		var impressumfile=dsgetstring('10083.VALUE','11783');
		impressumfile=replace (impressumfile,"/EKCatHelp/","");
		var d=GetAliasDir ("EKCatHelp");
		d=replace(d,"/","\\");
		var pdfFile=d+"\\"+impressumfile;
		shellexecute (pdfFile,"","");
		break;
	}
	return false;
}