
initDynZyklus()
{
	strObjID = getstring("ID", "DLGDATA.DYNZYKLUS.PROFIL")
	nMPSize = 18
	setint("BDLGOK", "DLGDATA.DYNZYKLUS", 1)
		
	if (strObjID == "")
	{
		dRet = createobject("DLGDATA.DYNZYKLUS", "PROFIL", 61)

		if (dRet == 0)
		{
			print("Error!")
		}
		else
		{
			setstring("ID", "DLGDATA.DYNZYKLUS.PROFIL", "MP")
			setstring("T_PROTOTYPE.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL", "10000")
			setstring("S_PROTOTYPE.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL", "10001")
			setstring("V_PROTOTYPE.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL", "10002")
			setstring("A_PROTOTYPE.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL", "10003")
			setstring("QS_PROTOTYPE.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL", "10004")
			setstring("QT_PROTOTYPE.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL", "10004")
			setstring("VM.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL", "10002")
			setint("SIZE", "DLGDATA.DYNZYKLUS.PROFIL", nMPSize)

			setstring("S_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL", "284")
		}
	}
	initDrehZahlZyklus();
	if (getstring("DELTAS_MIN.PROFILEID", "DLGDATA.DYNZYKLUS.DELTAS_MIN") == "")
	{
		dRet = createobject("DLGDATA.DYNZYKLUS", "DELTAS_MIN", 49)
		setstring("DELTAS_MIN.PROFILEID", "DLGDATA.DYNZYKLUS", getstring("S_PROTOTYPE.PROFILEID", "DLGDATA.DYNZYKLUS.PROFIL"))
		setdouble("DELTAS_MIN.RAW", "DLGDATA.DYNZYKLUS", 0.001)
	}
	setstring("DELTAS_MIN.UNIT", "DLGDATA.DYNZYKLUS", getstring("S_PROTOTYPE.UNIT", "DLGDATA.DYNZYKLUS.PROFIL"))
	nLeftMargin = 145
	nTopMargin	= 10
	nBottomMargin = 40
	dXStep = 62
	nWidth = dXStep * nMPSize + nLeftMargin + 1
	setint("LEFTMARGIN","DLGDATA.DYNZYKLUS.GRAPH", nLeftMargin);
	setint("TOPMARGIN", "DLGDATA.DYNZYKLUS.GRAPH", nTopMargin);
	setint("BOTTOMMARGIN", "DLGDATA.DYNZYKLUS.GRAPH", nBottomMargin);
	setdouble("XSTEP", "DLGDATA.DYNZYKLUS.GRAPH", dXStep);
	setint("WIDTH", "DLGDATA.DYNZYKLUS.GRAPH", nWidth);
	setint("HEIGHT", "DLGDATA.DYNZYKLUS.GRAPH", 255);
	setalias("MPGRAPH", "DLGDATA.DYNZYKLUS.GRAPH");
}


initDrehZahlZyklus()
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL";
	strObjID = getstring("ID", strProfilePath);
	nMPSize = getint("RANGE.SIZE", strProfilePath);
	if (strObjID == "" || nMPSize <= 0)
		return false;
		
	dP = getdouble("P.BASE", "DLGDATA.KGTSYSTEM");
	if (getstring("N_PROTOTYPE.PROFILEID", strProfilePath) == "")	{
		strUPDrehzahl = "12";
		strUnit1_pro_min = "294";
		dRet = createobject(strProfilePath, "N_PROTOTYPE", 49, strUPDrehzahl, "", strUnit1_pro_min);
		dRet = createobject(strProfilePath, "NM", 49, strUPDrehzahl, "", strUnit1_pro_min);
		if (dP > 0)	{
			for (i = 0; i < nMPSize; ++i)	{
				dVe = getdouble("VE.BASE", strProfilePath + "." + i);
				dVm = getdouble("VM.BASE", strProfilePath + "." + i);
				strVe = getstring("VE.VALUE", strProfilePath + "." + i);
				strVm = getstring("VM.VALUE", strProfilePath + "." + i);
				if (strVe == "")
					dRet = createobject(strProfilePath + "." + i, "NE", 49, strUPDrehzahl, "", strUnit1_pro_min);
				else
					dRet = createobject(strProfilePath + "." + i, "NE", 49, strUPDrehzahl, (dVe/dP), strUnit1_pro_min);
				if (strVm == "")
					dRet = createobject(strProfilePath + "." + i, "NM", 49, strUPDrehzahl, "", strUnit1_pro_min);
				else
					dRet = createobject(strProfilePath + "." + i, "NM", 49, strUPDrehzahl, (dVm/dP), strUnit1_pro_min);
			}
		}
		else	{
			for (i = 0; i < nMPSize; ++i)	{
				dRet = createobject(strProfilePath + "." + i, "NE", 49, strUPDrehzahl, "", strUnit1_pro_min);
				dRet = createobject(strProfilePath + "." + i, "NM", 49, strUPDrehzahl, "", strUnit1_pro_min);
			}
		}
	}
	else if (dP > 0)	{
		for (i = 0; i < nMPSize; ++i)	{
			dVe = getdouble("VE.BASE", strProfilePath + "." + i);
			dVm = getdouble("VM.BASE", strProfilePath + "." + i);
			if (dVe != 0)
				setdouble("NE.BASE", strProfilePath + "." + i, (dVe/dP));
			if (dVm != 0)
				setdouble("NM.BASE", strProfilePath + "." + i, (dVm/dP));
		}
	}
	return true;
}

calcDrehzahl(nProfilIndex, strDrehzahlSub, strVSub)
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL";
	dV	= getdouble(strVSub + ".BASE", strProfilePath + "." + nProfilIndex);
	dSpindel = getdouble("P.BASE", "DLGDATA.KGTSYSTEM");
	dN = (dSpindel != 0) ? dV / dSpindel : 0;
	setdouble(strDrehzahlSub + ".BASE", strProfilePath + "." + nProfilIndex, dN);
	return dN;
}

calcNE(nProfilIndex)
{
	return calcDrehzahl(nProfilIndex, "NE", "VE");
}

calcNM(nProfilIndex)
{
	return calcDrehzahl(nProfilIndex, "NM", "VM");
}

calcV(nProfilIndex, strDrehzahlSub, strVSub)
{
	strProfilePath = "DLGDATA.DYNZYKLUS.PROFIL";
	dN	= getdouble(strDrehzahlSub + ".BASE", strProfilePath + "." + nProfilIndex);
	dSpindel = getdouble("P.BASE", "DLGDATA.KGTSYSTEM");
	dV = dSpindel * dN;
	setdouble(strVSub + ".BASE", strProfilePath + "." + nProfilIndex, dV);
	return dV;
}

calcVE(nProfilIndex)
{
	return calcV(nProfilIndex, "NE", "VE");
}

calcVM(nProfilIndex)
{
	return calcV(nProfilIndex, "NM", "VM");
}